##' @include gspinbutton.R

##' slider class
setClass("gSlider",
         contains="guiComponentRangeSelector",
         prototype=prototype(new("guiComponentRangeSelector"))
         )

##' slider widget constructor
##'
##' @param from If a number of length one then a starting point, in
##' which case to, by are passed to \code{seq}. Otherwise a sequence
##' of values for which sort(unique(from)) will order
##' @param to ending point when from is starting point
##' @param by step size if not specified by \code{from}
##' @param length.out in place of by
##' @param along.with in place of length.out
##' @export
gslider <- function(
                    from = 0, to = 100, by = 1, length.out=NULL, along.with=NULL,
                    value = from[1], horizontal = TRUE,
                    handler = NULL, action = NULL, container = NULL, ... ,
                    toolkit=guiToolkit()){
  
  ## mostly from seq.default
  ## Wanted to just call seq.default, but that didn't work with length.out bit
  if (!missing(along.with)) {
    length.out <- length(along.with)
  } else if(!missing(length.out)) {
    len <- length(length.out)
    if (!len) 
      stop("argument 'length.out' must be of length 1")
    if (len > 1L) {
      warning("first element used of 'length.out' argument")
      length.out <- length.out[1L]
    }
    length.out <- ceiling(length.out)
  }
  if(!is.null(length.out)) {
    ## set up by to be for length,out
    by <- (to - from)/(length.out[1] - 1)
  }

  
  widget <- .gslider (toolkit,
                      from=from, to=to, by=by, value=value, horizontal=horizontal,
                      handler=handler, action=action, container=container ,...
                      )
  obj <- new( 'guiComponent',widget=widget,toolkit=toolkit) 
  return(obj)
}
 
##' generic for toolkit dispatch
##' @alias gslider
setGeneric( '.gslider' ,
           function(toolkit,
                    from = 0, to = 100, by = 1, value = from, horizontal = TRUE,
                    handler = NULL, action = NULL, container = NULL, ... ) standardGeneric( '.gslider' ))


##' svalue referst o value of slider
##'
##' @param index if non \code{NULL} and \code{TRUE} and sequence specified at once then index

##' @include guiComponentWithItems.R

##' checkboxgroup class
setClass("gCheckboxGroup",
         contains="guiComponentWithItems",
         prototype=prototype(new("guiComponentWithItems"))
         )

##' Constructor for checkbox group. A linked group of checkboxes, but not exclusive.
##'
##' @export
##' @param items checkbox labels
##' @param checked logical. Are values checked
##' @param horizontal logical. If true displayed horizontally, else vertically
##' @param use.table logical. If supported, and \code{TRUE} then use a table widget with scrollbars
##' @param handler Handler called when state toggles
##' @param action passed to handler when called
##' @param container parent container
##' @param ... passed to \code{add} method of parent
##' @param toolkit toolkit
##' @example ~/pmg/r-forge/gwidgets/pkg/gWidgets/inst/tests/
##' @return Returns an object of class \code{gCheckboxGroup} for which the following methods are overridden:
##' %
##' \example{
##'
##' \item \code{svalue} Return the selected values or an empty
##' character vector. If \code{index=TRUE}, returns indices of
##' selected values.
##' 
##' \item \code{svalue<-} Set the selected values one of three ways:
##' by label name, by a logical variable indicating which are selected
##' (if ambigous, logical wins), if \code{index=TRUE} by the indices
##' to select.
##' 
##' \item \code{[} returns labels
##' 
##' \item \code{[<-} set the label values. Should be able to shorten
##' or lengthen list
##' 
##' }
gcheckboxgroup <- function(
                           items, checked = FALSE, horizontal = FALSE,
                           use.table=FALSE, handler = NULL,
                           action = NULL, container = NULL, ... ,
                           toolkit=guiToolkit()){

  if(missing(items))
    items <- character(0)
  horizontal <- as.logical(horizontal)
  
  
  widget <- .gcheckboxgroup (toolkit,
    items=items, checked=checked, horizontal=horizontal, use.table=use.table,
    handler=handler, action=action, container=container, ...
    )
  obj <- new( 'gCheckboxGroup',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gcheckboxgroup
##' @export
setGeneric( '.gcheckboxgroup' ,
           function(toolkit,
                    items, checked = FALSE, horizontal = FALSE,
                    handler = NULL, action = NULL,
                    container = NULL, ... ) standardGeneric( '.gcheckboxgroup' )) 

##' A class to record the toolkit a gui object uses
setClass("guiWidgetsToolkit",
         representation(toolkit="character"),
         prototype(toolkit="")
         )

##' toolkit class for RGtk2
setClass("guiWidgetsToolkitRGtk2",
         contains="guiWidgetsToolkit",
         prototype=prototype(new("guiWidgetsToolkit"))
         )

##' toolkit class for rJava
setClass("guiWidgetsToolkitrJava",
         contains="guiWidgetsToolkit",
         prototype=prototype(new("guiWidgetsToolkit"))
         )

##' toolkit class for SJava
setClass("guiWidgetsToolkitSJava",
         contains="guiWidgetsToolkit",
         prototype=prototype(new("guiWidgetsToolkit"))
         )
##' toolkit class for  tcltk
setClass("guiWidgetsToolkittcltk",
         contains="guiWidgetsToolkit",
         prototype=prototype(new("guiWidgetsToolkit"))
         )

##' toolkit class for  RwxWidgets
setClass("guiWidgetsToolkitRwxWidgets",
         contains="guiWidgetsToolkit",
         prototype=prototype(new("guiWidgetsToolkit"))
         )


##' toolkit class for qtbase
setClass("guiWidgetsToolkitQt",
         contains="guiWidgetsToolkit",
         prototype=prototype(new("guiWidgetsToolkit"))
         )


##################################################


##' all packages that are registered with gWidgets. Used if guiToolkit not specified
registered_packages <- c("gWidgetsRGtk2", "gWidgetstcltk", "gWidgetsQt", "gWidgetsrJava",
                         "gWidgetsRwxWidgets")

##' set or get the current toolkit for gWidgets
guiToolkit <- function(name=NULL) {
  ## plan, if name is NULL, and options("guiToolkit") NULL then we popup a menu
  ## with choices coming from all installed packages named gWidgetsXXXX
  ## when a name is selected, we require the package gWidgets+name

  if(is.null(name)) {
    ## try to get from inheritance, then get from option

    x = try(get("toolkit", inherits=TRUE), silent=TRUE)
    if(!inherits(x,"try-error")) {
      ## check that toolkit is of guiWidgets type
      x = try("x@toolkit", silent=TRUE)
      if(!inherits(x,"try-error"))
        name = x
      else
        name = getOption("guiToolkit")
    } else {
      name = getOption("guiToolkit")
    }
  }
  if(!is.null(name) && is.na(name)) return(NULL)          # use NA to override choice
  ## no if it is null, we have to find the possible choices
  if(is.null(name)) {

    f <- function(x) !inherits(try(find.package(x), silent=TRUE), "try-error")
    choices <- Filter(f, registered_packages)
    
    if(interactive()) {
      if(length(choices) == 0) {
        warning("No toolkits installed")
        return(NULL)
      } else if(length(choices) == 1) {
        theChoice = choices
      } else {
        theChoice = menu(choices, title="Select a GUI toolkit")
        if(theChoice == 0) {
          warning("No toolkit loaded")
          return(NULL)
        } else {
          theChoice = choices[theChoice]
        }
      }
      ## go with theChoice
      name = gsub("^gWidgets","",theChoice)
      options("guiToolkit"=name)
    } else {
      ## not interactive 
      return(NULL)
    }
  }

  ## require the package
  require(paste("gWidgets",name,sep=""), character.only=TRUE)
  ## we return an instance of the toolkit class
  obj = new(paste("guiWidgetsToolkit",name,sep=""), toolkit = name)
  return(obj)
}

##' Which toolkit are we using?
##'
##' @return string of toolkit (RGtk2, tcltk, Qt, ???)
##' @export
gtoolkit <- function() {
  obj <- guiToolkit()
  obj@toolkit
}

## a way to layout out a form (dialog) using a list, similar to ggenericwidget
## but perhaps better

## idea is taken from extjs www.extjs.com


##' @include guiComponents.R

##' Class for widget to layout form from a specification in a list
setClass("gFormLayout",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' A constructor for a widget to layout a form from a specification in a list
##'
##' @export
gformlayout <- function(
                        lst, container = NULL,
                        ... ,
                        toolkit=guiToolkit()){
  widget <- .gformlayout(toolkit,
                         lst=lst, container=container ,...
                         )
  obj <- new( 'gFormLayout',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gformlayout
setGeneric( '.gformlayout' ,
           function(toolkit,
                    lst, 
                    container = NULL, ... )
           standardGeneric( '.gformlayout' ))



##################################################
## ANY implementation
setClass("gFormLayoutANY",
         representation = representation("gComponentANY",
           lst="list"),
         contains="gComponentANY",
         prototype=prototype(new("gComponentANY"))
         )

###############
setMethod(".gformlayout",
          signature(toolkit="ANY"),
          function(toolkit,
                   lst,
                   container=NULL,
                   ...
  ) {

            ## see docs for description of the list
            e <- new.env()
            mainGroup <- ggroup(container = container, ...)
            .makeForm(lst, mainGroup, e)
            
            ## return the container now that it has all the stuff in in.
            obj = new("gFormLayoutANY",
              block=mainGroup, widget=mainGroup,
              ID = getNewID(), toolkit=toolkit,
              lst = lapply(e, function(i) i))
            
            invisible(obj)
          })

### methods
setMethod("[",
          signature(x="gFormLayoutANY"),
          function(x, i, j, ..., drop=TRUE) {
            .leftBracket(x, x@toolkit, i, j, ..., drop=drop)
          })
## return list containing widgets
setMethod(".leftBracket",
          signature(toolkit="ANY",x = "gFormLayoutANY"),
          function(x, toolkit, i, j, ..., drop = TRUE) {
            widgets <- x@lst
            if(missing(i))
              return(widgets)
            else if(length(i) == 1 && drop == TRUE)
              return(widgets[[i]])
            else
              return(widgets[i])
          })

## return a list of values
setMethod(".svalue",
          signature(toolkit="ANY",obj="gFormLayoutANY"),
          function(obj, toolkit, index=NULL, drop=NULL, ...) {
            return(lapply(obj[], svalue))
          })

setMethod(".names",
          signature(toolkit="ANY",x="gFormLayoutANY"),
          function(x, toolkit) {
            return(names(x[]))
          })
          
## changes here should be copied into gWidgetsWWW
## helper functions
.makeForm <- function(lst, parent, e, ...) {
  g <- ggroup(container = parent, expand=TRUE,...)

  ## make a local copy of lst and modify for do.call
  tmp <- lst;
  tmp$name <- tmp$type <- tmp$children <- NULL
  tmp$depends.on <- tmp$depends.FUN <- tmp$depends.signal <- NULL
  tmp$container <- g; tmp$expand <- TRUE

  ## treat fieldset differently
  if(lst$type == "fieldset") {
    .makeFieldset(lst, g, e, label = lst$label)
    return()
  } else {  
    ## make object
    newObject <- do.call(lst$type, tmp)
    ## store if a name is given
    if(!is.null(lst$name))
      e[[lst$name]] <- newObject
    ## do we enable new object
    if(!is.null(lst$depends.on)) {
      widget <- e[[lst$depends.on]]
      if(is.null(lst$depends.signal))
        lst$depends.signal <- "addHandlerChanged"
      do.call(lst$depends.signal,list(obj=widget,handler =  function(h,...) {
        value <- svalue(h$obj)
        enabled(newObject) <- lst$depends.FUN(value)
      }))
      enabled(newObject) <- lst$depends.FUN(svalue(widget))
    }
  }
   


  
  ## show children if there
  ## this recurses except on "fieldset"
  if(!is.null(lst$children)) {
    for(i in 1:length(lst$children)) {
      l <- lst$children[[i]]
      if(l$type == "fieldset") {
        if(lst$type == "gnotebook")
          .makeFieldset(l, newObject, e, label = l$label)
        else
          .makeFieldset(l, newObject, e)
      } else {
        if(lst$type == "gnotebook")
          .makeForm(l, newObject, e, label = l$label)
        else
          .makeForm(l, newObject, e)
      }
    }
  }
}

## fieldset does not recurse
.makeFieldset <- function(lst, parent, e, ...) {
  ## parent is parent container
  ## lst is list as above

  ## outer container
  if(!is.null(lst$label)) 
    g <- gframe(lst$label, container = parent, ...)
  else
    g <- ggroup(container = parent, ...)
  ## main table
  tbl <- glayout(container = g)
  
  ## do we enable new object
  if(!is.null(lst$depends.on)) {
    widget <- e[[lst$depends.on]]
    if(is.null(lst$depends.signal))
      lst$depends.signal <- "addHandlerChanged"
    do.call(lst$depends.signal, list(obj = widget,handler = function(h,...) {
      value <- svalue(h$obj)
      enabled(g) <- lst$depends.FUN(value) 
  }))
    enabled(g) <- lst$depends.FUN(svalue(widget))
  }
  
  ## fix label adjust
  if(is.null(lst$label.pos))
    lst$label.pos <- "left"
  if(lst$label.pos == "top") {
    label.anchor <- c(-1,0)
  } else {
    if(is.null(lst$label.just) || lst$label.just == "left")
      label.anchor <- c(-1,1)
    else if(lst$label.just == "center")
      label.anchor <- c(0,1)
    else
      label.anchor <- c(1,1)
  }
  
  if(is.null(lst$columns)) 
    no.columns <- 1
  else
    no.columns <- lst$columns
  
  ## add children
  for(i in 1:length(lst$children)) {
    l <- lst$children[[i]]
    ## each child is a list with name, label, type, then arguments
    ## make new list for do.call
    tmp <- l;
    tmp$name <- tmp$label <- tmp$type <- NULL
    tmp$depends.on <- tmp$depends.FUN <- tmp$depends.signal <- NULL
    tmp$container <- tbl

    newWidget <- do.call(l$type, tmp)

    ## store
    if(!is.null(l$name))
      e[[l$name]] <- newWidget
    ## do we enable new object
    if(!is.null(l$depends.on)) {
      widget <- e[[l$depends.on]]
      if(is.null(l$depends.signal))
        l$depends.signal <- "addHandlerChanged"
      do.call(l$depends.signal, list(obj = widget, handler =  function(h,...) {
        value <- svalue(h$obj)
        enabled(newWidget) <- l$depends.FUN(value)
      }))
      enabled(newWidget) <- l$depends.FUN(svalue(widget))
    }

    
    ## add to table
    col <- 1 + (i - 1) %% no.columns    #1, ..., no.columns
    row <- 1 + (i - 1) %/% no.columns   #1, ...
    newLabel <- glabel(l$label, container = tbl)
    if(!is.null(lst$label.font))
      font(newLabel) <- lst$label.font
    if(is.null(lst$label.pos) || lst$label.pos == "left") {
      tbl[row, 2 * (col - 1) + 1, anchor=label.anchor] <- newLabel
      if(l$type %in% c("gcombobox","gdroplist"))
        tbl[row, 2 * (col - 1) + 2, anchor=c(-1,1), expand=TRUE] <- newWidget
      else
        tbl[row, 2 * (col - 1) + 2, anchor=c(-1,1)] <- newWidget
    } else {
      tbl[2 * (row - 1) + 1, col, anchor=label.anchor] <- newLabel
      if(l$type %in% c("gcombobox","gdroplist"))
        tbl[2 * (row - 1) + 2, col, anchor=c(-1,1), expand=TRUE] <- newWidget
      else
        tbl[2 * (row - 1) + 2, col, anchor=c(-1,1)] <- newWidget
    }
  }
}

##' @includes guiComponent.R

##' Button class
setClass("gButton",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' Button widget constructor
##' 
##' @param text Button text. If text matches a stock icon, that icon is also displayed.
##' @param border Logical. Is button drawn with a border
##' @param handler handler to call when button is invoked
##' @param action passed to handler when called. If a \code{gaction}
##' instance, then the action will define the text and the handler
##' @param container parent container
##' @param ... passed to \code{add} method of container
##' @param toolkit toolkit
##' @export
##' @example ~/pmg/r-forge/gwidgets/pkg/gWidgets/inst/tests/ex-gbutton.R
##' @return An object of class \code{gButton} for which the following methods are overridden:
##'
##' \enumerate{
##' \item \code{svalue} gets button text
##' 
##' \item \code{svalue<-} sets button text
##' }
##' The "change" handler is called when the button is clicked.
gbutton =function(
  text = "", border=TRUE, handler = NULL, action = NULL, container = NULL,      ...,
  toolkit=guiToolkit()){
  force(toolkit)                        # load package


  text <- paste(as.character(text), collapse="\n")

  
  widget =  .gbutton (toolkit,
    text, border, handler, action, container,...)

  obj <- new( 'gButton',widget=widget,toolkit=toolkit) 

  return(obj)
}

##' gbutton generic for toolkit dispatch
##' @alias gbutton
##' @export
setGeneric( '.gbutton' , function(toolkit,
                                  text = "", border=TRUE, handler = NULL, action = NULL, container = NULL,...)
           standardGeneric( '.gbutton' ))



################ methods ##################################

##' svalue method for button
##'
##' Main property of a button is the label
##' @param obj object
##' @param index ignored
##' @param drop ignored
##' @return character. String on button
##' @exports
setMethod("svalue", signature(obj="gButton"),
          function(obj, index=NULL, drop=NULL, ... ) {
            callNextMethod()
          })




##' set label in a button
##'
##' @param obj
##' @param index ignored
##' @param ... ignored
##' @param value character. If string matches stock icon name, then an icon will be added to button.
##' @return void
##' @exports
setReplaceMethod("svalue", signature(obj="gButton"),
          function(obj, index=NULL, ...,value) {
            value <- paste(value, collapse="\n")
            callNextMethod()
          })




################## defaultWidget ################################
##' Generic to check if a button is the default button
setGeneric("defaultWidget",function(obj, ...) standardGeneric("defaultWidget"))

##' base method to check if a button is the default
setMethod("defaultWidget",signature(obj="gButton"),
          function(obj, ...) {
            toolkit <- obj@toolkit
            .defaultWidget(obj@widget, toolkit,...)
          })
##' dispatch with toolkit
##' @alias defaultWidget
setGeneric(".defaultWidget",function(obj, toolkit,...) standardGeneric(".defaultWidget"))

################### defaultWidget<- ###############################
##' generic to set a button as the default one
setGeneric("defaultWidget<-",function(obj, ..., value) standardGeneric("defaultWidget<-"))
##' base method to set a button as default
setMethod("defaultWidget<-",signature(obj="gButton"),
          function(obj, ..., value) {
            toolkit = obj@toolkit
            .defaultWidget(obj@widget, toolkit,...) <- value
            return(obj)
          })
##' dispatch with toolkit
##' @alias defaultWidget<-
setGeneric(".defaultWidget<-",function(obj, toolkit,...,value)
           standardGeneric(".defaultWidget<-"))

##' @include guiComponents.R

##' A toolbar class
setClass("gToolbar",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' A toolbar constructor
##'
##' @exports
gtoolbar <- function(
                     toolbarlist, style = c("both", "icons", "text", "both-horiz"),
                     action = NULL, container = NULL, ... ,
                     toolkit=guiToolkit()){
  widget <- .gtoolbar (toolkit,
                       toolbarlist=toolbarlist, style=style, action=action, container=container ,...
                       )
  obj <- new( 'gToolbar',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gtoolbar
setGeneric( '.gtoolbar' ,
           function(toolkit,
                    toolbarlist, style = c("both", "icons", "text", "both-horiz"),
                    action = NULL, container = NULL, ... )
           standardGeneric( '.gtoolbar' ))

##' @include guiComponents.R

##' Class for display of HTML text
setClass("gHtml",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' constructor of widget to display HTML text
##'
##' @export
ghtml <- function(
                  x, handler = NULL, 
                  action = NULL, container = NULL, 
                  ..., toolkit=guiToolkit()) {
  widget <- .ghtml(toolkit,
                   x,
                   handler = handler, 
                   action = action, container = container, 
                   ...)
  obj <- new("gHtml",widget=widget,toolkit=toolkit)
  return(obj)
}

##' generic for toolkit dispatch
##' @alias ghtml
setGeneric(".ghtml",function(toolkit,
                             x, handler = NULL, 
                             action = NULL, container = NULL, 
                             ...) standardGeneric(".ghtml"))

##' function to bypass call to require to keep things quiet
##'
##' @param package name
##' @return result of call to require(pkg)
.bypassRequire <- function(pkg) {
  do.call(sprintf("%s", "require"), list(pkg))
}

## needed to find methods
.onLoad <- function(lib, pkg) {

##   ## Bad practice here (see ?.onAttach), but don't want to require tcltk although likely it isn't too much to ask for
##   doRequire <- function(pkg) do.call("require",list(pkg))
##   popup <- function() {
##     ## popup install message if not presnet
##     ## already checked that no gWidgetsXXX is available
##     all <- utils:::installed.packages()
##     pkgs <- rownames(all)
    
##     title <- "gWidgets needs a toolkit package"
##     msg <- "gWidgets needs a toolkit package installed."

##     if("tcltk" %in% pkgs) {
##       if("RGtk2" %in% pkgs) {
##         msg <- paste(msg, "Try installing gWidgetsRGtk2.", sep="\n")
##       } else {
##         msg <- paste(msg, "Try installing gWidgetstcltk.", sep="\n")
##       }

##       installing_gWidgets_toolkits()
##       doRequire("tcltk")
##       w <- tktoplevel()
##       tkdialog(w, title,msg,"",0,"close")
      
##     } else {
##       msg <- paste(msg,
##                    "You must install either RGtk2 or tcltk,",
##                    "then a toolkit package.",
##                    sep="\n")
##       packageStartupMessage(msg, "\n")

##       installing_gWidgets_toolkits()
##     }

##   }
  
  
  
##   ## check that a toolkit package is loaded 
## #  tmp = installed.packages() 
## #  choices = tmp[grep("^gWidgets.",tmp[,1]),1]
## #  if(length(choices) == 0) {
##     ### popup() ## disabled -- had issues iwth automatic builds

##     msg <- gettext("gWidgets requires a toolkit implementation to be\n installed, for instance gWidgetsRGtk2 or gWidgetstcltk.")
##     warning(paste("\n\n**",msg,"**\n\n", sep=""))
## #  }

  
}

.onAttach <- function(...) {

}

##' @include guiContainer.R

##' Class for a gridded-layout container
setClass("gLayout",
         contains="guiContainer",
         prototype=prototype(new("guiContainer"))
         )

##' Constructor for grid layout container
##'
##' @export
glayout <- function(
                    homogeneous = FALSE, spacing = 10, container = NULL,      ... ,
                    toolkit=guiToolkit()){
  widget <- .glayout (toolkit,
                      homogeneous=homogeneous, spacing=spacing, container=container ,...
                      )
  obj <- new( 'gLayout',widget=widget,toolkit=toolkit) 
  return(obj)
}

##' generic for toolkit dispatch
##' @alias glayout
setGeneric( '.glayout' ,
           function(toolkit,
                    homogeneous = FALSE, spacing = 10, container = NULL,
                    ... )
           standardGeneric( '.glayout' ))

##' pass back item, list or matrix of items depending on dimension
setMethod("[",
          signature(x="gLayout"),
          function(x,i,j,...,drop=TRUE) {
            if(missing(drop)) drop <- TRUE
            if(missing(i))
              i <- seq_len(dim(x)[1])
            if(missing(j))
              j <- seq_len(dim(x)[2])

            if(length(i) == 1 && length(j) == 1)
              return(.leftBracket(x@widget, x@toolkit,i,j,...,drop=drop))

            ## a matrix or list
            out <- sapply(j, function(col) lapply(i, function(row) x[row, col]))
            if(is.matrix(out))
              return(out[,,drop=drop])
            else
              return(out)
             
          })

##' @include toolkitClasses.R
##' 

##' Basic class for gWidgets objects
setClass("guiWidget",
         representation(
                        toolkit="guiWidgetsToolkit",
                        widget="ANY"  # could be RGtkObject, TclObject,....
                        ),
         prototype(
                   toolkit =guiToolkit(),
                   widget=NULL
                   )
         ) 
           
##' Subclass of gWidgets with NULL possibility
setClassUnion("guiWidgetOrNULL",
              c("NULL","guiWidget"))

##' for ANY toolkit
##'
##' @export
setClass("gWidgetANY",
         representation(
                        toolkit="guiWidgetsToolkit",
                        widget="ANY",  # could be RGtkObject, TclObject,....
                        block="ANY",
                        ID = "numeric"
                        ),
         prototype(
                   toolkit =guiToolkit(),
                   widget=NULL,
                   block = NULL,
                   ID = getNewID()
                   )
         ) 
           


##################################################
## methods

################ show ##################################
##' show method for guiWidget objects
##'
##' @param object guiWidget object to show
##' @return NULL, called to print summary of object
##' @export
setMethod("show",signature(object="guiWidget"),
          function(object) {
            cat("guiWidget of type:",
                class(object@widget),
                "for toolkit:",
                class(object@toolkit),
                "\n")
          })

################## svalue ################################
##' generic for selected value, svalue
##'
##' The \code{svalue} method returns the main property of a widget. This of course is context specific.
##' @param obj guiWidget object
##' @param index for selection widgets this is set to decide if value or index should be returned
##' @param drop for selection widgets do we return data frame or
##' vector (if possible). For text widgets, do we return entire text
##' or just selected text
##' @return main value of object
##' @export
setGeneric("svalue",function(obj, index=NULL, drop=NULL,...) standardGeneric("svalue"))

##' base svalue method
##'
##' @inheritParams svalue
##' @export
setMethod("svalue",signature(obj="guiWidget"),
          function(obj, index=NULL, drop=NULL, ... ) {
            toolkit = obj@toolkit
            val <- .svalue(obj@widget, toolkit, ...,index=index, drop=drop)

            if(is.logical(index) && index)
              return(as.integer(val))
            
            ## do we have coercewith?
            ## we check lots of ways, these should just be slots, someday...
            coercewith <- NULL
            if(methods::.hasSlot(obj@widget, "coercewith"))
              coercewith <- obj@widget@coercewith

            if(is.null(coercewith))
              coercewith <- tag(obj, "coercewith")

            if(is.null(coercewith))
              coercewith <- tag(obj, "coerce.with")

            ## now return
            if(is.null(coercewith))
              return(val)

            if(is.character(coercewith))
              coercewith <- get(coercewith, inherits=TRUE)
            
            if(!is.function(coercewith))
              return(val)

            ## return coerced value
            coercewith(val)
          })

##' svalue method for numeric variables
setMethod("svalue",signature(obj="numeric"),
          function(obj, index=NULL, drop=NULL, ... ) {
            return(obj)
          })

##' svalue method for character data
setMethod("svalue",signature(obj="character"),
          function(obj, index=NULL, drop=NULL, ... ) {
            if(length(obj) == 1)
              return(get(obj, envir=.GlobalEnv))
            else
              return(obj)
          })

##' package generic has toolkit, object to dispatch on
##' @alias svalue
setGeneric(".svalue",function(obj, toolkit, index=NULL, drop=NULL,  ...)
           standardGeneric(".svalue"))


################# svalue<- #################################
##' svalue<- generic
##'
##' Method for setting main property of a widget
##' @param obj guiWidget object
##' @param index For selection widgets one can set by index or by value
##' @param ... generally ignored, but some widgets use this to pass in extra values. See toolkit documentation
##' @param value new value for main property of widget
##' @return called for its side effect. Whether the "change" handler is called is toolkit and widget dependent.
##' @export
setGeneric("svalue<-",function(obj, index=NULL, ...,value) standardGeneric("svalue<-"))

##' svalue method for any widget
setReplaceMethod("svalue",signature(obj="guiWidget"),
          function(obj, index=NULL,  ...,value) {
            toolkit = obj@toolkit
            .svalue(obj@widget, toolkit, index=index,  ...) <- value
            obj
          })

##' dispatch to toolkit
##' @alias svalue<-
setGeneric(".svalue<-",function(obj, toolkit, index=NULL, ..., value)
           standardGeneric(".svalue<-"))

############### [ ###################################
##' [ method for selection widgetgs in guiWidget. 
##'
##' Method to refer to objects to select from
##' @param x guiWidget selection widget object
##' @param i index of vector, or row
##' @param j index of column, if possible
##' @param drop logical indicating if values should be dropped, when sensible
##' @return returns vector or data frame of values
##' @export
setMethod("[",
          signature(x="guiWidget"),
          function(x,i,j,...,drop=TRUE) {
            if(missing(drop)) drop <- TRUE
            return(.leftBracket(x@widget, x@toolkit,i,j,...,drop=drop))
          })

##' generic for implementing [ at toolkit level
setGeneric(".leftBracket",function(x, toolkit, i,j, ..., drop=TRUE)
           standardGeneric(".leftBracket"))

################ [<- ##################################
##' base [<- method for guiWidget.
##'
##' For selction widgets this method allows the possible selected values to be set
##' @param x guiWidget selection widget instance
##' @param i index of vector or row, if appropriate
##' @param j index of coumn, if appropriate
##' @param ... mostly ignored, but some toolkits may implement hidden arguments
##' @param value new value
setReplaceMethod("[",signature(x="guiWidget"),
          function(x,i,j,...,value) {
            toolkit = x@toolkit
            if(missing(i) && missing(j))
              .leftBracket(x@widget, toolkit,...) <- value
            else if(missing(j))
              .leftBracket(x@widget, toolkit,i,...) <- value
            else 
              .leftBracket(x@widget, toolkit,i,j,...) <- value
            return(x)
          })

##' generic for .leftBracket<- to implement [<- at toolkit level
setGeneric(".leftBracket<-",function(x, toolkit, i,j, ..., value)
           standardGeneric(".leftBracket<-"))


################## visible ################################
##' Generic to check visibility of widget
##'
##' @param obj guiWidget instance
##' @param set logical. Should one set the value. One should use
##' \code{visible<-} in most all cases, but for \code{gbasicdialog}
##' this is necessary
##' @return logical indicating if object is visible (shown)
##' @export
setGeneric("visible",function(obj, set=NULL, ...) standardGeneric("visible"))

##' visible method for widgets
setMethod("visible",signature(obj="guiWidget"),
          function(obj, set=NULL, ...) {
            toolkit = obj@toolkit
            .visible(obj@widget,toolkit, set=set, ...)
          })
##' dispatch with toolkit
##' @alias visible
setGeneric(".visible",function(obj, toolkit, set=NULL, ...) standardGeneric(".visible"))

############### visible<- ###################################
##' Generic method to adjust visibility of object
##'
##' A widget is visible if it is drawn (shown). This method is used to toggle that state.
##' @param obj guiWidget instance
##' @param ... ignored
##' @param value logical. Should object be visible or hidden
##' @note Many widgets override this method. If that is the case and
##' you wish to hide the widget, then place in a box container.
##' @return Called for side effect
##' @export
setGeneric("visible<-",function(obj, ..., value) standardGeneric("visible<-"))

##' visible<- method for widgets
setReplaceMethod("visible",signature(obj="guiWidget"),
          function(obj, ..., value) {
            toolkit = obj@toolkit
            .visible(obj@widget, toolkit, ...) <- value
            return(obj)
          })
##' dispatch with toolkit
##' @alias visible<-
setGeneric(".visible<-",function(obj, toolkit,...,value)
           standardGeneric(".visible<-"))

############### enabled ###################################
##' Generic to check if widget is sensitive to user input
##'
##' @param obj guiWiget object
##' @param ... ignored
##' @return logical indicating if widget is sensitive to user input
##' @export
setGeneric("enabled",function(obj, ...) standardGeneric("enabled"))

##' Method to check if widget is sensitive to user input
setMethod("enabled",signature(obj="guiWidget"),
          function(obj, ...) {
            toolkit = obj@toolkit
            .enabled(obj@widget, toolkit,...)
          })
##' dispatch with toolkit
##' @alias enabled
setGeneric(".enabled",function(obj, toolkit,...) standardGeneric(".enabled"))

################ enabled<- ##################################
## Generic to set whether widget is sensitive to user input
setGeneric("enabled<-",function(obj, ..., value) standardGeneric("enabled<-"))

## method to adjust whether widget is sensitive to user input
setReplaceMethod("enabled",signature(obj="guiWidget"),
          function(obj, ..., value) {
            toolkit = obj@toolkit
            .enabled(obj@widget, toolkit,...) <- value
            return(obj)
          })
##' dispatch with toolkit
##' @alias enabled<-
setGeneric(".enabled<-",function(obj, toolkit,...,value)
           standardGeneric(".enabled<-"))

############### editable ###################################
##' Generic to check if widget can be edited
setGeneric("editable",function(obj, ...) standardGeneric("editable"))

##' Method to check if widget can be edited
setMethod("editable",signature(obj="guiWidget"),
          function(obj, ...) {
            toolkit = obj@toolkit
            .editable(obj@widget, toolkit,...)
          })
##' dispatch with toolkit
##' @alias editable
setGeneric(".editable",function(obj, toolkit,...) standardGeneric(".editable"))

################ editable<- ##################################
## Generic to set whether widget can be edited
setGeneric("editable<-",function(obj, ..., value) standardGeneric("editable<-"))

## method to adjust whether widget can be edited
setReplaceMethod("editable",signature(obj="guiWidget"),
          function(obj, ..., value) {
            toolkit = obj@toolkit
            .editable(obj@widget, toolkit,...) <- value
            return(obj)
          })
##' dispatch with toolkit
##' @alias editable<-
setGeneric(".editable<-",function(obj, toolkit,...,value)
           standardGeneric(".editable<-"))

############## size ####################################
##' Generic for size method
setGeneric("size",function(obj, ...) standardGeneric("size"))

##' Method to return preferred size of widget
setMethod("size",signature(obj="guiWidget"),
          function(obj, ...) {
            toolkit = obj@toolkit
            .size(obj@widget, toolkit,...)
          })
##' dispatch with toolkit
##' @alias size
setGeneric(".size",function(obj, toolkit,...) standardGeneric(".size"))

############### sizes<- ###################################
## Generic for method to adjust size of widget
setGeneric("size<-",function(obj, ..., value) standardGeneric("size<-"))

##' Method to adjust size of widget
##'
##' 
setMethod("size<-",signature(obj="guiWidget"),
          function(obj, ..., value) {
            toolkit = obj@toolkit
            .size(obj@widget, toolkit,...) <- value
            return(obj)
          })

##' dispatch with toolkit
##' @alias size<-
setGeneric(".size<-",function(obj, toolkit,...,value)
           standardGeneric(".size<-"))



################# font #################################
##' Generic to get the font information
setGeneric("font",function(obj, ...) standardGeneric("font"))
## base method for font generic
setMethod("font",signature(obj="guiWidget"),
          function(obj, ...) {
            toolkit <- obj@toolkit
            .font(obj@widget, toolkit,...)
          })

##' dispatch with toolkit
##' @alias font
setGeneric(".font",function(obj,toolkit,...) standardGeneric(".font"))

################# font<- #################################
##' Generic to set font properties of widget
setGeneric("font<-",function(obj, ..., value) standardGeneric("font<-"))

##' base method for setting font properties of a widget
setMethod("font<-",signature(obj="guiWidget"),
          function(obj, ..., value) {
            toolkit <- obj@toolkit
            .font(obj@widget, toolkit,...) <- value ## DEPRECATED.fixFontMessUp(value)
            return(obj)
          })

##' dispatch with toolkit
##' @alias font<-
setGeneric(".font<-",function(obj, toolkit,...,value)
           standardGeneric(".font<-"))

############## tag ####################################
##' Generic for retrieving data from an object
setGeneric("tag",function(obj,i, drop=TRUE, ...) standardGeneric("tag"))

## base method for retrieving data from a widget
setMethod("tag",signature(obj="guiWidget"),
          function(obj,i,drop=TRUE, ...) {
            toolkit = obj@toolkit
            .tag(obj@widget, toolkit,i, drop=drop,...)
          })
##' dispatch with toolkit
##' @alias tag
setGeneric(".tag",function(obj, toolkit,i, drop=TRUE,...) standardGeneric(".tag"))


################ tag<- ##################################
##' Generic to set arbitrary data in an object
setGeneric("tag<-",function(obj, i, replace=TRUE, ..., value) standardGeneric("tag<-"))

##' base method for assigning data to an object
setMethod("tag<-",signature(obj="guiWidget"),
          function(obj, i, replace=TRUE, ..., value) {
            toolkit <- obj@toolkit
            .tag(obj@widget, toolkit,i, replace, ...) <- value
            return(obj)
          })

##' dispatch with toolkit
##' @alias tag<-
setGeneric(".tag<-",function(obj, toolkit,i, replace=TRUE,...,value)
           standardGeneric(".tag<-"))

################ id ##################################
##' Generic to retrieve id of object
setGeneric("id",function(obj, ...) standardGeneric("id"))
##' Base method to retrieve id from an object
setMethod("id",signature(obj="guiWidget"),
          function(obj, ...) {
            toolkit <- obj@toolkit
            .id(obj@widget, toolkit,...)
          })
##' dispatch with toolkit
##' @alias id
setGeneric(".id",function(obj, toolkit,...) standardGeneric(".id"))


################ id<- ##################################
##' Generic to set id for an object
setGeneric("id<-",function(obj, ..., value) standardGeneric("id<-"))

##' base method to set id for an object
setMethod("id<-",signature(obj="guiWidget"),
          function(obj, ..., value) {
            toolkit = obj@toolkit
            .id(obj@widget,toolkit,...) <- value
            return(obj)
          })
##' dispatch with toolkit
##' @alias id<-
setGeneric(".id<-",function(obj, toolkit,...,value)
           standardGeneric(".id<-"))

############## isExtant ####################################
##' generic to check if a widget still exists
setGeneric("isExtant",function(obj, ...) standardGeneric("isExtant"))

##' base method to check if a widget still exists
setMethod("isExtant",signature(obj="guiWidget"),
          function(obj, ...) {
            toolkit = obj@toolkit
            .isExtant(obj@widget,toolkit, ...)
          })

##' dispatch with toolkit
##' @alias isExtant
setGeneric(".isExtant",function(obj, toolkit, ...) standardGeneric(".isExtant"))


################## toolkitProvidesWidget ################################
##' function to check if a toolkit provides a widget
##'
##' @export
##' @param widgetname Character. Name of widget
##' @param toolkit the toolkit to check
##' @returns a logical indicating if the widget is implemented in the toolkit
toolkitProvidesWidget <- function(
                                  widgetname,
                                  toolkit=guiToolkit()){
  .toolkitProvidesWidget (toolkit, widgetname)
}

##' generic for toolkit dispatch
##' @alias toolkitProvidesWidget
setGeneric( '.toolkitProvidesWidget' ,
           function(toolkit,
                    widgetname)
           standardGeneric( '.toolkitProvidesWidget' ))


##' implementation for ANY toolkit
##' @alias toolkitProvidesWidget
setMethod(".toolkitProvidesWidget",
          signature(toolkit="ANY"),
          function(toolkit,
                   widgetname) {
            notThere <- list(guiWidgetsToolkitQt=c("ggraphics","ggraphicsnotebook"),
                             guiWidgestToolkitRGtk2=c("gsvg", "ghtml"),
                             guiWidgetsrToolkitJava=c("gsvg", "ghtml", "ggraphics", "ggraphicsnotebook"),
                             guiWidgetsToolkittcltk=c("gsvg", "ghtml", "ggraphics", "ggraphicsnotebook",
                               "gdfnotebook")
                             )

            notThere <- notThere[[class(toolkit)]]
            return(!widgetname %in% notThere)
          })



##################################################
## Usual R methods made into methods for dispatch

################### update ###############################
##' generic for update
setGeneric("update")

##' base method for update to dispatch on guiWidget instances
setMethod("update",signature(object="guiWidget"),
          function(object, ...) {
            .update(object@widget, object@toolkit, ...)
          })

##' generic for toolkit dispatch
##' @alias update
setGeneric(".update",function(object, toolkit,  ...)
           standardGeneric(".update"))

##' Base method to find length of guiWidget instances
setMethod("length",signature(x="guiWidget"),
          function(x) {
            .length(x@widget, x@toolkit)
          })

##' generic for toolkit dispatch
##' @alias length
setGeneric(".length",function(x, toolkit)
           standardGeneric(".length"))

############## dim ####################################
##' base method to find dim(ension) of guiWidget instances
setMethod("dim",signature(x="guiWidget"),
          function(x) {
            .dim(x@widget, x@toolkit)
          })

##' generic for toolkit dispatch
##' @alias dim
setGeneric(".dim",function(x, toolkit)
           standardGeneric(".dim"))

##' base method to find dimnames attribute of guiWidget instance
#setGeneric("dimnames")
setMethod("dimnames",signature(x="guiWidget"),
          function(x) {
            .dimnames(x@widget, x@toolkit)
          })

##' generic for toolkit dispatch
##' @alias dimnames
setGeneric(".dimnames",function(x, toolkit)
           standardGeneric(".dimnames"))

##' base method to set dimnames for guiWidget instance
#setGeneric("dimnames<-")
setReplaceMethod("dimnames",signature(x="guiWidget"),
                 function(x,value) {
                   .dimnames(x@widget, x@toolkit) <- value
                   return(x)
                 })
##' generic for toolkit dispatch
##' @alias dimnames<-
setGeneric(".dimnames<-",function(x, toolkit, value) {
  standardGeneric(".dimnames<-")
})


## names
## as of 2.5.0 this became primiive
if(as.numeric(R.Version()$major) <= 2 &
   as.numeric(R.Version()$minor) <= 4.1) {
  setGeneric("names")
  setGeneric("names<-")
}

##' Base method for getting names of guiWidget instances
setMethod("names",signature(x="guiWidget"),
          function(x) {
            .names(x@widget, x@toolkit)
          })

##' generic for toolkit dispatch
##' @alias names
setGeneric(".names",function(x, toolkit)
           standardGeneric(".names"))

##' base method to set names of guiWidget instance
setReplaceMethod("names",signature(x="guiWidget"),
                 function(x,value) {
                   .names(x@widget, x@toolkit) <- value
                   return(x)
                 })
##' generic for toolkit dispatch
##' @alias names<-
setGeneric(".names<-",function(x, toolkit, value) {
  standardGeneric(".names<-")
})

##################################################
## Work with underlying toolkit objects

##################################################
##' Generic for method to return toolkit widget from guiWidget instance
setGeneric("getToolkitWidget",function(obj) standardGeneric("getToolkitWidget"))

##' base method to return toolkit widget from guiWidget instance
setMethod("getToolkitWidget",signature(obj="guiWidget"),
          function(obj) {
            .getToolkitWidget(obj@widget, obj@toolkit)
          })

##' generic for toolkit dispatch
##' @alias getToolkitWidget
setGeneric(".getToolkitWidget",function(obj, toolkit)
           standardGeneric(".getToolkitWidget"))


################## access via $ and [[ #############################
##' Invoke a method on the underlying toolkit object
##'
##' @param x guiwidget
##' @param meth_name name of method
##' @return function that one can call, as in \code{x$method(a=1)}
##' @export
"$.guiWidget" <- function(x, meth_name)
            .callToolkitMethod(x@widget, x@toolkit, meth_name)

setGeneric(".callToolkitMethod",function(x, toolkit, meth_name)
           standardGeneric(".callToolkitMethod"))

##' Get an underlying property of the toolkit object
##' @param x guiWidget
##' @param ... first argument has property
##' @return value
##' @export
##'
"[[.guiWidget" <- function(x, ...) {
  property <- list(...)[[1]]
  .getToolkitProperty(x@widget, toolkit=x@toolkit, property=property)
}

setGeneric(".getToolkitProperty",function(x, toolkit, property)
           standardGeneric(".getToolkitProperty"))

##' Set underlying toolkit property
##' @param x guiWidget
##' @param i property to set
##' @param j ignored
##' @param value new value of property
##' @export
"[[<-.guiWidget" <- function(x, i, j, value) {
  .setToolkitProperty(x@widget, toolkit=x@toolkit, property=i, value=value)
  x
}

setGeneric(".setToolkitProperty",function(x, toolkit, property, value)
           standardGeneric(".setToolkitProperty"))

##' @include guiComponents.R

##' single line text edit class
setClass("gEdit",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' Single line text edit constructor
##'
##' @exportsg If not text give, and an initial message given, then this message is displayed until the widget receives the focus
##' @param text initial text
##' @param width number of characters
##' @param coerce.with A function or name of function to coerce value with before returning by \code{svalue}
##' @param initial.msg If not text give, and an initial message given, then this message is displayed until the widget receives the focus
##' @param handler Change handler. Called when return key is hit
##' @param action passed to handler
##' @param container parent container
##' @param ... passed to \code{add} method of parent
##' @param toolkit toolkit
##' @return An object of class \code{gEdit}. This has sub-classed methods:
##'
##' \enumerate{
##'
##' \item \code{}
##'
##' \item \code{svalue} to retrieve the text
##'
##' \item \code{svalue<-} to set the text
##'
##' \item \code{[} to get the autocomplete values
##'
##' \item \code{[<-} Character. To set autocomplete values
##'
##' \item \code{visible<-} to specify a character to display instead of text (for passwords)
##'
##' }
##'
##' The default handler call is when the user activates the entry,
##' typically by pressing the enter key.
##'
##' The \code{addhandlerBlur}
##' method is called when the widget loses focuses.
##'
##' The \code{addHandlerKeystroke} method adds a handler called after
##' each keystroke. If possible, the first argument has a component
##' \code{key} passing back the last value.
##'
##' 
gedit <- function(
                  text = "", width = 25, coerce.with = NULL, initial.msg="",
                  handler = NULL, action = NULL, container = NULL, ... ,
                  toolkit=guiToolkit()){

  widget <- .gedit(toolkit,
                   text=text, width=width, coerce.with=coerce.with, initial.msg=initial.msg,
                   handler=handler, action=action, container=container ,...
                   )
  obj <- new( 'guiComponent',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gedit
setGeneric( '.gedit' ,
           function(toolkit,
                    text = "", width = 25, coerce.with = NULL, initial.msg=initial.msg,
                    handler = NULL,action = NULL, container = NULL, ... )
           standardGeneric( '.gedit' ))

##' @include guiContainer.R

##' Class for a two-paned container
setClass("gPanedGroup",
         contains="guiContainer",
         prototype=prototype(new("guiContainer"))
         )

##' constructor for a two-paned container
##'
##' @export
gpanedgroup <- function(
  widget1=NULL, widget2=NULL, horizontal = TRUE, container = NULL , ...,
  toolkit=guiToolkit()){
  widget <- .gpanedgroup (toolkit,
                          widget1, widget2, horizontal=horizontal,
                          container=container, ...
                          )
  obj <- new( 'gPanedGroup',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gpanedgroup
setGeneric( '.gpanedgroup' ,
           function(toolkit,
                    widget1, widget2, horizontal = TRUE, container = NULL, ... )
           standardGeneric( '.gpanedgroup' ))

##' @include gframe.R

##' Class for a box container with disclosure trigger
setClass("gExpandGroup",
         contains="gFrame",
         prototype=prototype(new("gFrame"))
         )

##' Constructor of box container widget with disclosure trigger and label
##'
##' @export
##' @param text Label text
##' @param markup logical. Does text have markup. (not too many)
##' @param horizontal horizontal (\code{TRUE}) or vertical packing.
##' @param handler handler called when toggled
##' @param action passed to handler
##' @param container parent container
##' @param ... passed to parent's \code{add} method
##' @param toolkit toolkit
##' @return An object of class \code{gExpandgroup}. This (basically)
##' inherits from \code{gFrame} its methods and overrides:
##'
##' \enumerate{
##'
##' \item \code{visible<-} Logical. To specify if widget is open (\code{TRUE}) or closed.
##'
##' }
##'
##' 
gexpandgroup <- function(
                         text = "", markup = FALSE, horizontal=TRUE,
                         handler = NULL, action = NULL,
                         container = NULL, ... ,
                         toolkit=guiToolkit()){
  widget <- .gexpandgroup (toolkit,
                           text=text, markup=markup, horizontal=horizontal,
                           handler=handler, action=action, container=container ,...
                           )
  obj <- new( 'gExpandGroup',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gexpandgroup
setGeneric( '.gexpandgroup' ,
           function(toolkit,
                    text = "", markup = FALSE,horizontal=TRUE,
                    handler = NULL, action = NULL,
                    container = NULL, ... )
standardGeneric( '.gexpandgroup' ))

##' @include gtable.R

##' Class for a data frame editor
setClass("gDf",
         contains="gGridComponent",
         prototype=prototype(new("gGridComponent"))
         )

##' Constructor for a data frame editor
##'
##' @exports
##' @param items data frame to edit
##' @param name name of data frame (for saving, but not really needed)
##' @param do.subset logical. If \code{TRUE} a combobox to subset values by is produced.
##' @param container parent container
##' @param ... passed to container's \code{add} method
##' @param toolkit toolkit
##' @return An object of class \code{gDf} with overridden methods:
##'
##' \enumerate{
##'
##' \item \code{svalue} to return the selected cells
##'
##' \item \code{svalue<-} to set the selected cells
##'
##' \item \code{[} to get the current values
##'
##' \item \code{[<-} to set the current values. For most toolkits one
##' can not coerce the underlying class of a column (say from numeric
##' to character)
##'
##' \item \code{dim} dimension of object
##'
##' \item \code{length} number of columns
##'
##' }
##'
##' The widget may have underlying handlers assigned by \code{addHandlerClicked}
##'
##' }
##' 
gdf <- function(
                items = NULL, name = deparse(substitute(items)), do.subset = FALSE,
                container = NULL, ... ,
                toolkit=guiToolkit()){
  widget <- .gdf (toolkit,
                  items=items, name=name, do.subset=do.subset, container=container ,...
                  )
  obj <- new( 'gDf',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gdf
setGeneric( '.gdf' ,
           function(toolkit,
                    items = NULL, name = deparse(substitute(items)),
                    do.subset = FALSE,      container = NULL, ... )
           standardGeneric( '.gdf' ))


## methods
## addHandlerChanged, addHandlerClicked, addHandlerDoubleClicked
## addHandlerColumnClicked, addHandlerColumnDoubleClicked

##' @include guiComponents.R

##' Class for adding a status bar to main window
setClass("gStatusbar",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' constructor to add a status bar to main window
##'
##' @exports
gstatusbar <- function(
                       text = "", container = NULL, ... ,
                       toolkit=guiToolkit()){
  widget <- .gstatusbar (toolkit,
    text=text, container=container ,...
    )
  obj <- new( 'gStatusbar',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gstatusbar
setGeneric( '.gstatusbar' ,
           function(toolkit,
                    text = "", container = NULL, ... )
           standardGeneric( '.gstatusbar' ))

##' @include guiComponents.R

##' dialog for file and directory selection
##'
##' @exports
##' @param text initial text
##' @param type type of browser: to open a file, to save a file or to select a directory
##' @param initialfilename Suggested file name
##' @param filter A filter specifiation. This is toolkit specific
##' @param multi Logical. Allow multiple files to be selected?
##' @param handler called when a file or files have been selected
##' @param action passed to handler
##' @param ... ignored
##' @param toolkit toolkit
##' @return returns filename(s) or \code{NA} if no selection. 
##' 
gfile <- function(
                  text = "", type = c("open", "save", "selectdir"),
                  initialfilename = NULL,
                  filter = list("All files" = list(patterns = c("*")), "R files" = list(patterns = c("*.R",          "*.Rdata")), "text files" = list(mime.types = c("text/plain"))          ),
                  multi=FALSE,
                  handler = NULL, action = NULL, ... ,
                  toolkit=guiToolkit()){
  widget =  .gfile (toolkit,
    text=text, type=type, initialfilename=initialfilename,
    filter=filter, multi=multi, handler=handler, action=action ,...
    )
}


##' generic for toolkit dispatch
##'
##' @export
##' @rdname gfile
setGeneric( '.gfile' ,
           function(toolkit,
                    text = "", type = c("open", "save", "selectdir"),
                    initialfilename = NULL,
                    filter = list("All files" = list(patterns = c("*")), "R files" = list(patterns = c("*.R",          "*.Rdata")), "text files" = list(mime.types = c("text/plain"))
                      ),
                    handler = NULL, action = NULL, ... )
           standardGeneric( '.gfile' ))


##' class for a widget to select a file
setClass("gFilebrowse",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )


##' constructor for file/directory selection widget
##'
##' Basically a \code{gedit} instance with a button to initiate \code{gfile}.
##' @export
##' @param text Instructional text
##' @param type type of dialog (see \code{\link{gfile}})
##' @param quote Do we quote value 
##' @param container parent container
##' @param ... passed to \code{add} method of parent
##' @param toolkit toolkit
##' @return Returns an object of class \code{gFilebrowse}. This should
##' inherit the methods  of \code{gedit} instances.
gfilebrowse <- function (
                         text = "Select a file...", type = "open", quote = TRUE, 
                         container = NULL, ..., toolkit = guiToolkit()) {
  widget <- .gfilebrowse (toolkit,
                          text=text, type=type, quote=quote, container=container, ...)
  obj <- new('gFilebrowse',widget=widget,toolkit=toolkit) 
  return(obj)
}

##' generic for toolkit dispatch
##' @alias gfilebrowse
setGeneric(".gfilebrowse",
           function(toolkit,
                    text = "Select a file...", type = "open", quote = TRUE, 
                    container = NULL, ...)
           standardGeneric( '.gfilebrowse' ))

##' @include guiComponents.R

##' Class for display of line in a layout
setClass("gSeparator",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' constructor providing a widget for displaying a line in a GUI
##'
##' @exports
gseparator <- function(
                       horizontal = TRUE, container = NULL, ... ,
                       toolkit=guiToolkit()){
  widget <- .gseparator (toolkit,
                         horizontal=horizontal, container=container ,...
                         )
  obj <- new( 'gSeparator',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gseparator
setGeneric( '.gseparator' ,
           function(toolkit,
                    horizontal = TRUE, container = NULL, ... )
           standardGeneric( '.gseparator' ))

##' @include guiComponents.R

##' Class for creating a widget based on function values or markup specified by a list
setClass("gGenericWidget",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' Constructor for "generic widget"
##'
##' @export
ggenericwidget <- function(
                           lst,  cli = NULL, container = NULL,
                           ... ,
                           toolkit=guiToolkit()){

  ## if lst is a function, we much fix
  fName <- NULL
  if(is.function(lst)) 
    fName <- deparse(substitute(lst))
  
  widget <- .ggenericwidget (toolkit,
                             lst=lst, cli=cli, container=container , fName=fName, ...
                             )
  obj = new( 'guiComponent',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias ggenericwidget
setGeneric( '.ggenericwidget' ,
           function(toolkit,
                    lst, cli = NULL,
                    container = NULL, ... )
           standardGeneric( '.ggenericwidget' ))





##################################################
## This is basically a hack, but it kinda works so I'm not touching it
##################################################

setClass("gGenericWidgetANY",
         representation = representation("gComponentANY",
           lst="list"),
         contains="gComponentANY",
         prototype=prototype(new("gComponentANY"))
         )

###############
setMethod(".ggenericwidget",
          signature(toolkit="ANY"),
          function(toolkit,
                   lst,
                   cli = NULL,          # iCLi object for output
                   container=NULL,
                   ...
  ) {


            
            ## ReadParseEvaL -- saves typing
            rpel = function(string, envir=.GlobalEnv) {
              eval(parse(text=string), envir=envir)
            }

            theArgs <- list(...)
            if(!is.null(theArgs$fName))
              lst <- theArgs$fName      # to pass in fun name
            

            if(is.character(lst)) {
              if(rpel(Paste("is.function(",lst,")"))) {
                ## run automenugenerator
                lst = rpel(autogenerategeneric(lst), environment())
              } else {
                gwCat(paste("Can not create genericwidget from", lst,"\n",sep=" "))
                return(glabel("", container = container))
              }
            }
      

            
##             if(!is.list(lst) && is.character(lst)) {
##               if(rpel(Paste("is.function(",lst,")"))) {
##                 ## run automenugenerator
##                 lst = rpel(autogenerategeneric(lst))
##               } else if(is.function(lst)) {
##                 lst = rpel(autogenerategeneric(lst))
##               }
##             }
            
            ## error check
            if(!is.list(lst)) {
              warning("ggenericwidget needs to be called with a list, a function name or a function to work\n")
              return(glabel("", container = container))
            }

            
            ## store widgets here
            vals = list()
            
            
            ## add to this box, this is what gets returned
            mainGroup = ggroup(horizontal=FALSE, spacing=10,
              container=container, ...)
            
            ## Data
            if(!is.null(lst$variableType)) {
              
              if(lst$variableType == "univariate") {
                vals$Data = gunivariate(...,
                  container=mainGroup, anchor=c(-1,0), expand=TRUE)
              } else if(lst$variableType == "univariatetable") {
                vals$Data = gunivariatetable(...,
                  container=mainGroup, anchor=c(-1,0), expand=TRUE) 
              } else if(lst$variableType == "fileurl") {
                vals$Data = gfileurl(...,
                  container=mainGroup, anchor=c(-1,0), expand=TRUE) 
              } else if(lst$variableType == "bivariate") {
                vals$Data = gbivariate(...,
                  container=mainGroup, anchor=c(-1,0), expand=TRUE) 
              } else if(lst$variableType == "model") {
                vals$Data = gmodel(...,
                  container=mainGroup, anchor=c(-1,0), expand=TRUE) 
              } else if(lst$variableType == "lattice") {
                vals$Data = glattice(...,
                  container=mainGroup, anchor=c(-1,0), expand=TRUE) 
              } else if(lst$variableType == "lmer") {
                vals$Data = glmer(...,
                  container=mainGroup, anchor=c(-1,0), expand=TRUE) 
              } else {
                cat(Paste("Need to implement variableType ",lst$variableType,"\n"))
                vals$Data = NULL
              }
            }


            
            ## arguments
            if(!is.null(lst$arguments)) {
              frame = gframe(text="Arguments",
                horizontal=FALSE, container=mainGroup,
                anchor=c(-1,0), expand=TRUE, fill="x")
              font(frame) <- c(weight="bold", size="small")

              group = ggroup(horizontal=FALSE, container=frame)
              table = glayout(container=group)        # k rows, 4 cols
              trow = 1; tcol= 1
              ## function for recursing down list
              addWidgetToDialog = function(name, lstele) {
                
                if(is.null(lstele$type) || is.list(lstele$type)) {
                  ## recurse after adding seperator
                                        #        gseparator(horizontal=FALSE, container=group)
                  if(name != "arguments") {
                    ## add some indication that this is a seperate group. Not in a frame
                    ## but this might end up looking better if in a frame
                    label = glabel(name, container=table)
                    font(label) <- c(style="italic", weight="bold")
                    table[trow,1] <<- label
                    table[trow,2:4] <<- gseparator(horizontal=TRUE, container=table)
                    trow <<- trow+1; tcol <<- 1
                  }
                  for(i in names(lstele)) {
                    
                    addWidgetToDialog(i,lstele[[i]])
                  }
                  ## increment rows
                  trow <<- trow+1; tcol <<- 1
                } else {
                  ## the listelement use the argument names so do.call just works.
                  if(!is.list(lstele$type) && lstele$type == "ilabel") {
                    table[trow,2:4] <<- glabel(lstele$text, container=table)
                    trow <<- trow+1; tcol <<- 1
                    ##        glabel(lstele$text, container=group)
                  } else {
                    ## not a label
                    table[trow,tcol, anchor=c(1,0)] <<- glabel(name,
                                                handler = function(h,...) {
                                                  showHelpAtArgument(name, lst$help)
                                                },
                                                container=table) 

                    lstele$container <- table # need this for tcltk
                    vals[[name]] <<- do.call(lstele$type, lstele[-1])
                    table[trow,tcol + 1, anchor=c(-1,0)] <<- vals[[name]]
                    visible(vals[[name]]) <- TRUE

                    if(tcol == 3) trow <<- trow + 1
                    tcol <<- (tcol+2) %% 4
                  }
                }
              }
              
              
              ## now call function to recurse down list
              if(!is.null(lst$arguments))
                addWidgetToDialog("arguments",lst$arguments)
              ## now we need to make table visible
              visible(table) <- TRUE
            }
            
            ## do we assignto?
            assignto = NULL                       # initialize
            if(!is.null(lst$assignto)) {
              frame = gframe("Assign output to:",container=mainGroup, anchor=c(-1,0), expand=TRUE, fill="x")
              font(frame) <- c(weight="bold")
              
              assignto = gedit("",container=frame)
              ##    adddroptarget(assignto)
            }
            
            
            ## now add buttons
            ok.cb = function(h,...) {
              vals = h$action$vals            # contains the object
              lst = h$action$lst              # original list

              ## assignto
              if(!is.null(h$action$assignto))
                assignto = svalue(h$action$assignto)
              
    
              head <- lst$action$beginning
              tail <- lst$action$end
              args <- c()  
              for(i in names(vals)) {
                val = svalue(vals[[i]])

                if(is.empty(val)) next
                if(i == "..." | i == "Data" ) {
                  args = c(args,val)
                } else {
                  ## combine with name
                  args = c(args,Paste(i,"=",val))
                }
              }
              str = Paste(head, PasteWithComma(args), tail)
              
              if(!is.empty(assignto))
                names(str) = make.names(assignto)
              else
                assignto = NULL

              ## send to fcommandline instance
              if(is.null(h$action$cli)) {
                cli <- gcommandline(command=str, assignto=assignto,
                  useGUI = FALSE, useConsole = TRUE,
                  container=NULL)
              } else {
                cli = h$action$cli
                command <- str; names(command) <- assignto
                svalue(cli) <- command
              }
            }
            
            cancel.cb = function(h,...) {
              action = h$action
              dispose(action)
            }
            
            help.cb = function(h,...) {
              helppage = h$action
              win = gwindow(Paste("Help on ", helppage), visible=TRUE)
              size(win) <- c(600, 400)
              group = ggroup(horizontal = FALSE, container=win)
              ghelp(topic=helppage, container=group, expand=TRUE)
              closeGroup = ggroup(container=group)
              addSpring(closeGroup)
              gbutton("cancel", handler = function(h,...) dispose(win),
                      container=closeGroup)
            }
            
            buttongroup = ggroup(container=mainGroup)
            addSpring(buttongroup)               # push to right
            gbutton("ok", action=list(vals=vals,lst=lst,assignto = assignto,cli=cli),
                    handler = ok.cb, container=buttongroup)
            addSpace(buttongroup, 25)
            gbutton("help",action = lst$help,  handler = help.cb, container=buttongroup)
 


            ## return the container now that it has all the stuff in in.
            obj = new("gGenericWidgetANY",
              block=mainGroup, widget=mainGroup,
              ID = getNewID(), toolkit=toolkit,
              lst = lst)
            invisible(obj)
          })

### methods
## return the list
setMethod(".svalue",
          signature(toolkit="ANY",obj="gGenericWidgetANY"),
          function(obj, toolkit, index=NULL, drop=NULL, ..) {
            return(obj@lst)
          })

### returns a string that evaluates to a list
autogenerategeneric = function(f,
  fName,
  help = fName,                             # name of help function
  variableType = NULL   # one ofc(NULL,"univariate","bivariate","model","lattice"),
  ) {

  if(missing(fName)) {
    if(is.function(f)) {
      fName = deparse(substitute(f))
    } else{                               # f is a string
      fName = f 
      f = get(f)
    }
  }
  lst = formals(f)

  ## figure out variableType: univariate, bivariate, model or lattice
  if(is.null(variableType)) {
    firstArg = names(lst)[1]

    if(firstArg == "formula") {
      variableType = "model"
      lst[['formula']] <- NULL
      lst[['data']] <- NULL
      lst[['subset']] <- NULL
    } else if(firstArg == "file") {
      variableType = "fileurl"
      lst[['file']] <- NULL
    } else if(firstArg == "x" & length(names(lst)) > 1) {
      secondArg = names(lst)[2]
      if(secondArg == "y") {
        variableType = "bivariate"
        lst[['x']] <- NULL
        lst[['y']] <- NULL
      } else {
        variableType = "univariate"
        lst[['x']] <- NULL
      }
    } 
  }

  ## make list as a string
  out = Paste(fName,".LIST <- list(", "\n")
  out = Paste(out, "\ttitle = \"",fName,"\",\n")
  out = Paste(out, "\thelp = \"",help,"\",\n")
  out = Paste(out, "\tvariableType = \"",variableType,"\",\n")
  out = Paste(out, "\tassignto = ","TRUE",",\n")
#  out = Paste(out, "\taction = list\(\n")
    out = Paste(out, "\taction = list(\n")
  out = Paste(out, "\t\tbeginning = \"",fName,"(\", \n")
  out = Paste(out, "\t\tending = \")\"),\n")
#  out = Paste(out, "\targuments = list\(\n")
    out = Paste(out, "\targuments = list(\n")
#  out = Paste(out, "\t\tArguments = list\(\n") # add or change these
  

  

  for(i in names(lst)) {
    ## intercept the type
    name = i
    val = lst[[i]]
    type = str1(lst[[i]])$type

#    cat(f,":",i,"is of type",type,"\n")
    
    if(0) {
      ### want to test for empty
      ## what do do here -
      out = Paste(out,"\t\t\t\"","...",'"',"=list(\n")
      out = Paste(out,"\t\t\t\ttype= \"gedit\",\n")
      out = Paste(out,"\t\t\t\ttext=",'""'  ,"),\n")
    } else {
      ## these vals we handle generically
      val1 = "placeholder"
      switch(type,
             "name" = {
               out = Paste(out,"\t\t\t\"",name,'"',"=list(\n")
               out = Paste(out,"\t\t\t\ttype= \"gedit\",\n")
               out = Paste(out,"\t\t\t\ttext=", '""'  ,"),\n")
             },
             "numeric" = {
               out = Paste(out,"\t\t\t\"",name,'"',"=list(\n")
               out = Paste(out,"\t\t\t\ttype= \"gedit\",\n")
               out = Paste(out,"\t\t\t\tcoerce.with= as.numeric,\n")
               out = Paste(out,"\t\t\t\ttext=\"", val  ,"\"),\n")
             },
             "logical" ={
               out = Paste(out,"\t\t\t\"",name,'"',"=list(\n")
               out = Paste(out,"\t\t\t\ttype= \"gdroplist\",\n")
               out = Paste(out,"\t\t\t\tindex= FALSE,\n")
               if(!is.na(val) && !is.null(val) && is.logical(val) && val == FALSE) {
                 out = Paste(out,"\t\t\t\titems=", 'c(\"FALSE\", \"TRUE\"),',
                   "coerce.with=as.logical),\n")
               } else {
                 out = Paste(out,"\t\t\t\titems=", 'c(\"TRUE\",\"FALSE\"),',
                   "coerce.with=as.logical),\n")
               }
             },
             "character" = {
               out = Paste(out,"\t\t\t\"",name,'"',"=list(\n")
               out = Paste(out,"\t\t\t\ttype= \"gedit\",\n")
               out = Paste(out,"\t\t\t\tcoerce.with= as.character,\n")               
               out = Paste(out,"\t\t\t\ttext=\"\'", val  ,"\'\"),\n")
             },
             "call" = {
               ## only handle c(...)
               ## others are just blank gentry
               callVal = as.character(val)
               if(callVal[1] == "c") {
                 items = eval(val)
                 quoteIt = '\"'
                 if(class(items) == "numeric")
                   quoteIt = ""

                 ## combin
 #                theValue = "c("
#                 for(j in 2:length(callVal)) {
#                   theValue=Paste(theValue, quoteIt,callVal[j],quoteIt, ',')
 #                }
#                 theValue=Paste(theValue,'"")') #add emput
                 tmp = paste(quoteIt, items, quoteIt, sep = "", collapse=", ")
                 theValue = paste("c(", tmp, ")",sep="")
                 
                 out = Paste(out,"\t\t\t\"",name,'"',"=list(\n")
                 if(length(callVal) >3) {
                   out = Paste(out,"\t\t\t\ttype= \"gdroplist\",\n")
                   if(class(items) == "character")
                     out = Paste(out,"\t\t\t\tdo.quote= TRUE,\n")
                 } else {
                   out = Paste(out,"\t\t\t\ttype= \"gradio\",\n")
                   out = Paste(out,"\t\t\t\tindex= FALSE,\n")
                 }
                 out = Paste(out,"\t\t\t\titems=", theValue  ,"),\n")
               } else {
                 ## just leavl blank
                 out = Paste(out,"\t\t\t\"",name,'"',"=list(\n")
                 out = Paste(out,"\t\t\t\ttype= \"gedit\",\n")
                 out = Paste(out,"\t\t\t\ttext=\"\"),\n")
               }
             },
             "NULL" = {
               out = Paste(out,"\t\t\t\"",name,'"',"=list(\n")
               out = Paste(out,"\t\t\t\ttype= \"gedit\",\n")
               out = Paste(out,"\t\t\t\ttext=", "\"NULL\""  ,"),\n")
             },                           # default
             {
             out = Paste(out,"Don't know what to do\n")
           })
    }
  }
  ## finish up
  out = gsub(",\n$","",out)
  out = Paste(out, "))\n")              # trimmed a ) for Arguments


  return(out)
}

##' @include guiComponents.R

##' Class for graphic device widget
setClass("gGraphics",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' Constructor for an embeddable graphics device
##'
##' @exports
ggraphics <- function(
                      width = dpi * 6, height = dpi * 6, dpi = 75, ps = 12,      container = NULL, ... ,
                      toolkit=guiToolkit()){
  widget <- .ggraphics (toolkit,
                        width=width, height=height, dpi=dpi, ps=ps, container=container ,...
                        )
  obj <- new( 'gGraphics',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias ggraphics
setGeneric( '.ggraphics' ,
           function(toolkit,
                    width = dpi * 6, height = dpi * 6, dpi = 75, ps = 12,
                    container = NULL, ... )
           standardGeneric( '.ggraphics' ))



##' Class for notebook to hold multiple ggraphics widgets
setClass("gGraphicsNotebook",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' constructor for notebook to hold multiple graphics devices
##'
##' @export
ggraphicsnotebook <- function(
                              width = dpi * 6, height = dpi * 6, dpi = 75, container = NULL,      ... ,
                              toolkit=guiToolkit()){
  widget <- .ggraphicsnotebook (toolkit,
                                width=width, height=height, dpi=dpi, container=container ,...
                                )
  obj <- new( 'gGraphicsNotebook',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias ggraphicsnotebook
setGeneric( '.ggraphicsnotebook' ,
           function(toolkit,
                    width = dpi * 6, height = dpi * 6, dpi = 75,
                    container = NULL,      ... )
           standardGeneric( '.ggraphicsnotebook' ))

##' @include guiComponents.R

##' a calendar class for date selection
setClass("gCalendar",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' A constructor for a date selection widget
##'
##' @param text initial text
##' @param format Date format
##' @param handler handler called when changed
##' @param action passed to handler
##' @param container parent container
##' @param ... passed to \code{add} method of parent
##' @param toolkit toolkit
##' @return Returns an object of class \code{gCalendar} for which the following methods are overridden:
##' \enumerate{
##' \item \code{svalue} get the date
##' 
##' \item \code{svalue<-} set the date
##' }
##' The change handler is inherited from \code{\link{gedit}}
##' @export
gcalendar <- function(
                      text = "", format = "%Y-%m-%d", 
                      handler = NULL, action=NULL, container = NULL,...,
                      toolkit=guiToolkit()){
  widget <- .gcalendar (toolkit,
                        text=text, format=format, handler=handler,action=action,
                        container=container , ...
                        )
  obj <- new( 'gCalendar',widget=widget,toolkit=toolkit) 
 return(obj)
}


##' generic for toolkit dispatch
##' @alias gcalendar
setGeneric( '.gcalendar' ,
           function(toolkit,
                    text = "", format = "%Y-%m-%d", 
                    handler=NULL, action=NULL, container = NULL,
                    ... )
           standardGeneric( '.gcalendar' ))



##' svalue method for gcalendar
##'
##' Main property of calendar is the date
##' @param obj object
##' @param index ignored
##' @param drop ignored
##' @return character. The date, after formatting.
##' @exports
setMethod("svalue", signature(obj="gCalendar"),
          function(obj, index=NULL, drop=NULL, ... ) {
            .svalue(obj@widget, obj@toolkit, ...,index=index, drop=drop)            
          })




##' set date
##'
##' @param obj
##' @param index ignored
##' @param ... ignored
##' @param value character. Should be in format for calendar widget
##' @return void
##' @exports
setReplaceMethod("svalue", signature(obj="gCalendar"),
          function(obj, index=NULL, ...,value) {
            .svalue(obj@widget, obj@toolkit, index=index, ...) <- value
            return(obj)
          })

##' @include guiComponentWithItems.R

##' Combobox class
setClass("gCombobox",
         contains="guiComponentWithItems",
         prototype=prototype(new("guiComponentWithItems"))
         )

##' constructor for combobox
##'
##' @export
##' @param items Items to select from. A vector or a data frame. If a
##' data frame, then first column is values. Second is optional, but
##' can specify a stock icon name, third is optional and can be used
##' to specify a tooltip. These may not be supported in all toolkits.
##' @param selected integer. Which item (by index) is selected. Use -1 for no selection
##' @param editable logical. Is user allowed to edit value
##' @param coerce.with A function of function name to be called before
##' selected value is returned by \code{svalue}
##' @param handler Called when combobox value is changed.
##' @param action passed to handler
##' @param container parent container
##' @param ... passed to parent container's \code{add} method
##' @param toolkit toolkit
##' @return Returns an object of class \code{gCombobox} for which the following methods are overriden:
##' \enumerate{
##' \item \code{svalue} Return selected value by name or (if \code{index=TRUE} by index). The latter only if \code{editable=FALSE}.
##' 
##' \item \code{\svalue<-} Set the selected value by value or if \code{index=TRUE} by index.
##'
##' \item \code{[} return items to select from
##'
##' \item \code{[<-} Set items to select from.
##' }
##' @example ~/pmg/r-forge/gwidgets/pkg/gWidgets/inst/tests/ex-gcombobox.R
gcombobox =function(
  items, selected = 1, editable = FALSE, coerce.with=NULL, handler = NULL,      action = NULL, container = NULL, ... ,
  toolkit=guiToolkit()){

  ## adjust items. Pass in data frame
  if(!is.data.frame(items) && !is.matrix(items))
    items <- data.frame(items, stringsAsFactors=FALSE)

  if(!is.data.frame(items))
    items <- as.data.frame(items)

  
  widget =  .gdroplist (toolkit,
    items=items, selected=selected, editable=editable, coerce.with=coerce.with, handler=handler, action=action, container=container, ...
    )
  obj = new( 'gCombobox',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##'
##' @alias gcombobox
setGeneric( '.gdroplist' , function(toolkit,
                                    items, selected = 1, editable = FALSE, coerce.with = NULL, handler = NULL,      action = NULL, container = NULL, ... ) standardGeneric( '.gdroplist' ))

##' Alias for gcombobox. Deprecated
##' 
##' @alias gcombobox
gdroplist <- gcombobox 



##' svalue method for combobox
##'
##' Main property of checkbox group are the states. 
##' @param obj object
##' @param index If \code{TRUE} returns index of selected. Otherwise a character vector.
##' @param drop ignored
##' @return character or index. Some toolkits return \code{-1} when nothing is selected.
##' @exports
setMethod("svalue", signature(obj="gCombobox"),
          function(obj, index=NULL, drop=NULL, ... ) {
            .svalue(obj@widget, obj@toolkit, ...,index=index, drop=drop)            
          })




##' set state for combobox
##'
##' @param obj
##' @param index if \code{TRUE} then an index is expected. If \code{FALSE}, then name should match available unless \code{editable=TRUE} is specified
##' @param ... ignored
##' @param value numeric or character depending on \code{index}
##' @return void
##' @exports
setReplaceMethod("svalue", signature(obj="gCombobox"),
          function(obj, index=NULL, ...,value) {
            .svalue(obj@widget, obj@toolkit, index=index, ...) <- value
            return(obj)
          })

##' replacement method for combobox selection items
##'
##' Ensure that value is a data frame. One can pass a vector or a
##' one-column data frame to inidicate the possible values for
##' selection, a second column is used for an icons (if possible), a
##' third for a tooltip (if possible).
##' get_from_templace for guiWidget
setReplaceMethod("[",signature(x="gCombobox"),
          function(x,i,j,...,value) {
            
            ## adjust value. Pass in data frame
            if(!is.data.frame(value) && !is.matrix(value))
              value <- data.frame(value, stringsAsFactors=FALSE)
            
            if(!is.data.frame(value))
              value <- as.data.frame(value)

            callNextMethod(x, i, j, ..., value=value)
          })

  

##################################################
### Code to handle toolkits
### A new toolkit should have:
### * a name gWidgetsXXXXX
### * a subclass of guiWidgetsToolkit
### * methods for .functions (.glabel, .svalue, ...)
### * optionally, methods for glabel(obj, ...) dispatching to .glabel(obj,toolkit, ...)

### toolkit code comes *before* others




##################################################
### Components



 
## gcheckbox
## the constructor

## gradio
## constructor


## gdroplist
## the class
## the constructor


## gcheckboxgroup
## the constructor

## gspinbutton
## the constructor

## gslider
## the constructor

## gedit
## the constructor

## gtext
## the constructor

## gaction

## gmenu
## the constructor

## gtoolbar
## the constructor

## gtable

## the constructor

## gdf
## the constructor

## gdfnotebook
## the constructor

## gtree
## the constructor


## gfile (gfilebrowse in base)
## the constructor

## gcalendar
## the constructor

## ggraphics

## the constructor


## gplotnotebook
## the constructor

## gimage

## the constructor

## gsvg

## the constructor


## gstatusbar

## the constructor

## ghtml function


## gseparator
## the constructor

##################################################
## these should be in gWidgets, based on others no toolkit specific code

## the constructor

## ghelp, ghelpbrowser

## the constructor

## ggenericwidget

## the constructor

## gformlayout

## the constructor

## gvarbrowser

## the constructor

##################################################
### Containers

## define a gWidget constructor
## not a generice          

## ggroup
 
## the constructor

## gframe
## the constructor

## gexpandgroup
## the constructor



## gnotebook
## the constructor

## glayout

## the constructor

## gpanedgroup
## the constructor

## icons
##################################################
##
## Methods


## add






## focus

## focus<-


## tooltip


## font

## font<-

## undo

## redo

## tag

## tag<-


## id

## id<-


## toOlkitprovidesgwidgetsdg
## Does thie toolkit provide the widget
## the constructor


##################################################


## ####
## put into RGtk2 only
## ## S3 class for coercing to gWidget
## as.gWidget <- function(obj,...) UseMethod("as.gWidget")
## as.gWidget.default <- function(obj,...) {
##   print(sprintf("No coercion to gWidget available for object of class %s",class(obj)))
##   return(obj)
## }

##' @include guiContainer.R

##' Class for top level windows
setClass("gWindow",
         contains="guiContainer",
         prototype=prototype(new("guiContainer"))
         )

##' constructor for top-level window
##'
##' @export
gwindow <- function(title="Window" , visible=TRUE, name=title,
                    width = NULL, height = NULL, parent = NULL,
                    handler = NULL, action = NULL,
                    ...,
                    toolkit=guiToolkit()
                    ) {
  theArgs <- list(...)
  if(!is.null(theArgs$location)) {
    parent <- theArgs$location
    cat(gettext("location argument is renamed to 'parent'\n"))
  }
  
  ## THe visible=TRUE default is not the best. I'd change it if I could go back in time, but
  ## c'est la vie. Anyways, for those that it really bugs there is this check
  if(!is.null(getOption("gWidgets:gwindow-default-visible-is-false")))
    visible <- FALSE
  
  
  win <- .gwindow(toolkit,title, visible,width, height, parent, handler, action, ...)
  obj <- new("gWindow",widget=win,toolkit=toolkit)
  return(obj)
}

##' define a toolkit constructor, dispatch on toolkit
##' @alias gwindow
setGeneric(".gwindow",function(toolkit, title, visible, width, height, parent, handler, action,...) standardGeneric(".gwindow"))


## methods
## add
## svalue: title property
## size, size<-
## visible, visible<-
## update: recompute window size

##' @include guiComponents.R

##' single line text edit class
setClass("gAction",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' An action constructor
##'
##' @param label label for action
##' @param tooltip toolktip for actin
##' @param icon icon (stock icon name) for icon
##' @param key.accel keyboard accelerator. If given, parent must be specified.
##' @param handler handler to call when action is invoked
##' @param action values passed to parameterize action
##' @param parent parent window. Needed if keyboard accelerator used.
##' @param ... 
##' @param toolkit 
##' @export
##' @return a gaction instance
gaction <- function(
                    label, tooltip=NULL, icon = NULL, key.accel = NULL,
                    handler = NULL, action = NULL, parent=NULL, ...,
                    toolkit=guiToolkit()) {
  widget <- .gaction (toolkit,
                      label, tooltip, icon, key.accel, handler, action, parent, ...
                      )
  obj <- new( 'gAction',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gaction
setGeneric( '.gaction' ,
           function(toolkit,
                    label, tooltip = NULL, icon = NULL, key.accel=NULL,
                    handler = NULL, action = NULL, parent=NULL, 
                    ... )
           standardGeneric( '.gaction' ))

##' @include guiComponents.R

##' class to display heiarchical data in a tree widget
setClass("gTree",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' constructor for widget to display heirarchical data
##'
##' @exports
gtree <- function(
                  offspring = NULL, hasOffspring = NULL, offspring.data = NULL,
                  col.types = NULL, icon.FUN = NULL, chosencol = 1, multiple = FALSE,
                  handler = NULL, action = NULL, container = NULL, ... ,
                  toolkit=guiToolkit()){
  widget <- .gtree (toolkit,
                    offspring=offspring, hasOffspring=hasOffspring,
                    offspring.data=offspring.data, col.types=col.types, icon.FUN=icon.FUN,
                    chosencol=chosencol, multiple=multiple,
                    handler=handler, action=action, container=container ,...
                    )
  obj <- new( 'gTree',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gtree
setGeneric( '.gtree' ,
           function(toolkit,
                    offspring = NULL, hasOffspring = NULL,
                    offspring.data = NULL,
                    col.types = NULL, icon.FUN = NULL, chosencol = 1,
                    multiple = FALSE,
                    handler = NULL, action = NULL, container = NULL, ... )
           standardGeneric( '.gtree' ))


## methods

##' svalue get selected values. index=TRUE: 1-based path; index=FALSE|NULL chararacter value
##' svalue<- set path by index
##' [ get text based path (by ids)
##' update update tree at root

##' @include guiComponent.R

##' 

##' Method to add icon to list of stock icons
##'
##' @export
addStockIcons = function(iconNames,iconFiles, ..., toolkit = guiToolkit()) {
  out =  .addStockIcons (toolkit, iconNames, iconFiles, ...)
  return(out)
}

##' generic for dispath
##' @alias addStockIcons
setGeneric( '.addStockIcons' ,
           function(toolkit, iconNames, iconFiles,... )
           standardGeneric( '.addStockIcons' ))

##' return list of available stock icons
##'
##' @export
getStockIcons = function( ..., toolkit = guiToolkit()) {
  out =  .getStockIcons (toolkit,...)
  return(out)
}

##' generic for toolkit dispatch
##' @alias getStockIcons
setGeneric( '.getStockIcons' ,
           function(toolkit,...)
           standardGeneric( '.getStockIcons' ))

##' Find a stock icon from the given class
##'
##' @export
stockIconFromClass = function(theClass, ..., toolkit = guiToolkit()) {
  out =  .stockIconFromClass (toolkit, theClass, ...)
  return(out)
}
##' generic for dispath
##' @alias stockIconFromClass
setGeneric( '.stockIconFromClass' ,
           function(toolkit, theClass,... )
           standardGeneric( '.stockIconFromClass' ))

##' Find stock icon from the given object
##'
##' @export
stockIconFromObject = function(obj, ..., toolkit = guiToolkit()) {
  out =  .stockIconFromClass (toolkit, obj, ...)
  return(out)
}

##' generic for dispath
##' @alias stockIconFromObject
setGeneric( '.stockIconFromObject' ,
           function(toolkit, obj,... )
           standardGeneric( '.stockIconFromObject' ))







## returns a list with key the icon name
## and value the filepath





## find the stock icons. This includes those added bia loadGWidgetIcons()
gWidgetsIcons = list()
assignInNamespace("gWidgetsIcons",gWidgetsIcons,ns="gWidgets")
addedStockIcons = list()
assignInNamespace("addedStockIcons",addedStockIcons, ns="gWidgets")

getgWidgetsIcons = function() {
  gWidgetsIcons = getFromNamespace("gWidgetsIcons",ns="gWidgets")
  if(length(gWidgetsIcons) == 0) {
    path = system.file("images",package="gWidgets")
    allIcons = list.files(path)
    ## create a hash with name -> location
    for(i in allIcons) {
      filename = sub("\\.xpm$|\\.gif$|\\.jpg$|\\.jpeg$|\\.png$|\\.tiff$","",i)
      gWidgetsIcons[[filename]] <- system.file("images",i,package="gWidgets")
    }
  }
  assignInNamespace("gWidgetsIcons",gWidgetsIcons,ns="gWidgets")
  return(gWidgetsIcons)
}

## incorporate both these and any additional ones added via addStockIcons
setMethod(".getStockIcons",
          signature(toolkit="ANY"),
          function(toolkit) {
            gWidgetsIcons = getgWidgetsIcons()
            addedStockIcons = getFromNamespace("addedStockIcons",ns="gWidgets")

            return(c(addedStockIcons ,gWidgetsIcons))

            
          })

setMethod(".addStockIcons",
          signature(toolkit="ANY"),
          function(toolkit, iconNames, iconFiles, ...) {
            stockIcons = getgWidgetsIcons()
            addedStockIcons = getFromNamespace("addedStockIcons", ns="gWidgets")
            
            if(length(iconNames) == length(iconFiles)) {
              for(i in 1:length(iconNames)) {
                if(!is.na(match(iconNames[i],names(stockIcons))))
                  cat("Overriding stock icon",iconNames[i],"\n")
                addedStockIcons[[iconNames[i]]] <- iconFiles[[i]]
              }
              assignInNamespace("addedStockIcons", addedStockIcons, ns="gWidgets")
            } else {
              cat("Lengths of names and file don't match\n")
            }
            invisible()
          })

## name can be a vector
## return NA, if not there
getstockiconname = function(name=NULL) {
  .stockicons = getStockIcons()         # cache?

  if(is.null(name))
    return(unlist(.stockicons))
  

  tmpfun = function(names) {
    sapply(names, function(name) {
      ## already a stock name?
      if(name %in% .stockicons)
        return(name)
      
      if(name %in% names(.stockicons)) {
        return(.stockicons[[name]])
      } else {
        return(NA)
      }
    })
  }
  
  return(tmpfun(name))
}


#################################################
## functions to deal with icons
## class to icon translation -- return stock name
## with prefix

## find the stock icons. This includes those added bia loadGWidgetIcons()
setMethod(".stockIconFromClass",
          signature(toolkit="ANY"),
          function(toolkit,theClass, ...) {

            default = "symbol_star"
            
            if(is.null(theClass) ||
               is.na(theClass) ||
               length(theClass) == 0
               )
              return(NA)
            
            if(theClass %in% .models)
              return(getstockiconname("lines"))
            if(theClass %in% .ts)
              return(getstockiconname("ts"))
            if(theClass %in% .functions)
              return(getstockiconname("function1"))
            
            ret = switch(theClass,
              "complex"="numeric",
              "character"="character",
              "date" = "date",              
              "data.frame" = "dataframe",
              "integer"= "numeric",
              "factor"="factor",
              "function"="function1",
              "list" = "dataframe",
              "logical" = "logical",
              "matrix" = "matrix",
              "numeric"= "numeric",
              "recordedplot" = "plot",
              NA)
            
            return(getstockiconname(ret))
          })


setMethod(".stockIconFromObject",
          signature(toolkit="ANY"),
          function(toolkit,obj, ...) {
            .stockIconFromClass(class(obj)[1])
          })

##' @include guiContainer.R

##' Class for tabbed notebook container
setClass("gNotebook",
         contains="guiContainer",
         prototype=prototype(new("guiContainer"))
         )

##' Constructor for a tabbed notebook container
##'
##' @export
gnotebook <- function(
                      tab.pos = 3, closebuttons = FALSE, dontCloseThese = NULL,
                      container = NULL, ... ,
                      toolkit=guiToolkit()){
  widget <- .gnotebook (toolkit,
                        tab.pos=tab.pos, closebuttons=closebuttons, dontCloseThese=dontCloseThese,
                        container=container ,...
                        )
  obj <- new( 'gNotebook', widget=widget,toolkit=toolkit)
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gnotebook
setGeneric( '.gnotebook' ,
           function(toolkit,
                    tab.pos = 3, closebuttons = FALSE, dontCloseThese = NULL,
                    container = NULL, ... )
           standardGeneric( '.gnotebook' ))

##' @include guiComponents.R

##' Class for tabular data display: gdf, gtable 
setClass("gGridComponent",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )


##' svalue method for gdf or gtable widget
##'
##' Main property of a table is the selection
##' @param obj object
##' @param index if \code{index=NULL} or \code{FALSE} then values from
##' the table are given if \code{index=TRUE} then the indices are
##' returned. The value of \code{drop} deteremines what is returned.
##' @param drop if \code{NULL} or \code{TRUE} then when
##' \code{index=TRUE} the indices of the currently selected rows are
##' returned. If \code{index=FALSE} then the values from the chosen
##' column are returned. Otherwise, if \code{drop=FALSE} then when
##' \code{index=TRUE} then -- if the toolkit supports it -- a list with
##' components \code{rows} and \code{columns} describing rectangles
##' of selected values.
##' @return a vector or data frame of values, or a vector or list of
##' indices. If no selection returns \code{NULL}.
setMethod("svalue", signature(obj="gGridComponent"),
          function(obj, index=NULL, drop=NULL, ... ) {
            .svalue(obj@widget, obj@toolkit, ...,index=index, drop=drop)            
          })




##' set selection in gdf or gtable object
##'
##' @param obj
##' @param index if \code{NULL} or \code{FALSE} then a specification
##' by match on the chosen columns. If \code{TRUE} then a
##' specification of indices. This can be as a vector of row indices,
##' or as a list with row and column specifications.
##' @param value replacement value
setReplaceMethod("svalue", signature(obj="gGridComponent"),
          function(obj, index=NULL, ...,value) {
            .svalue(obj@widget, obj@toolkit, index=index, ...) <- value
            return(obj)
          })




## leftbracket -- column coercion an issue, resizing frames an issue, replacement method

## leftbracket<-

## dim, dimnames, length, names, ....

##################################################

##' class to display tabular data for selection
setClass("gTable",
         contains="gGridComponent",
         prototype=prototype(new("gGridComponent"))
         )

##' A constructor for displaying tabular data for selection
##'
##' @exports
gtable <- function(
                   items, multiple = FALSE, chosencol = 1, icon.FUN = NULL,
                   filter.column = NULL, filter.labels = NULL, filter.FUN = NULL,
                   handler = NULL, action = NULL, container = NULL, ... ,
                   toolkit=guiToolkit()){

  ## coerce items
  if(!missing(items)) {
    if (is.vector(items))
      items <- data.frame(Values=items, stringsAsFactors=FALSE)
    if(is.matrix(items))
      items <- data.frame(items, stringsAsFactors=FALSE)
  }
  
  widget <- .gtable (toolkit,
                     items=items, multiple=multiple, chosencol=chosencol,
                     icon.FUN=icon.FUN,
                     filter.column=filter.column, filter.labels=filter.labels, filter.FUN=filter.FUN,
                     handler=handler, action=action, container=container ,...
                     )
  obj <- new( 'gTable',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gtable
setGeneric( '.gtable' ,
           function(toolkit,
                    items, multiple = FALSE, chosencol = 1,
                    icon.FUN = NULL,
                    filter.column = NULL, filter.labels = NULL, filter.FUN = NULL,
                    handler = NULL, action = NULL, container = NULL, ... )
           standardGeneric( '.gtable' ))


## handler code in subclasses
## addHandlerChanged, addHandlerClicked

##' @include guiComponents.R

##' class to hold a notebook of data frame editors
setClass("gDfNotebook",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' A notebook container for many \code{gdf} instances
##'
##' @exports
##' @param items data frame for initial page
##' @param container parent container
##' @param ... passed to \code{add} method of parent container
##' @param toolkit toolkit
gdfnotebook <- function(
                        items = NULL, container = NULL, ... ,
                        toolkit=guiToolkit()){
  widget <- .gdfnotebook (toolkit,
                          items=items, container=container ,...
                          )
  obj <- new( 'gDfNotebook',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gdfnotebook
setGeneric( '.gdfnotebook' ,
           function(toolkit,
                    items = NULL, container = NULL, ... )
           standardGeneric( '.gdfnotebook' ))

##' @include guiComponents.R

##' Class for widget to display SVG data
setClass("gSvg",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' construtor for widget to display svg data
##'
##' Reimplemented methods:
##' \enumerate{
##' \item \code{svalue} returns file name
##' \item \code{svalue<-} set image from file
##' }
##' @exports
##' @param filename name of file to write to
##' @param width width in pixels
##' @param height height in pixels
##' @param handler (if implemented) add handler to be called on mouse click
##' @param action passed to handler
##' @param container parent container
##' @param ... passed to \code{add} method of container
##' @param toolkit toolkit
##' @note A native svg driver is available for Qt, but not tcltk, Gtk.
gsvg <- function(
                 filename="", width=480, height=480,
                 handler=NULL, action=NULL,
                 container = NULL, ... ,
                 toolkit=guiToolkit()){
  widget <- .gsvg (toolkit,
                   filename=filename, width=width, height=height,
                   handler=handler, action=action, container=container ,...
                   )
  obj <- new( 'gSvg',widget=widget,toolkit=toolkit) 
  return(obj)
}

##' generic for toolkit dispatch
##' @alias gsvg
setGeneric( '.gsvg' ,
           function(toolkit,
                    filename = "", width=480,  height=480,
                    handler=NULL, action=NULL,
                    container = NULL, ... )
           standardGeneric( '.gsvg' ))


##' gsvg constructor for ANY class (default to label)
setMethod(".gsvg",
          signature(toolkit="ANY"),
          function(toolkit,
                   filename = "", width=480, height=480,
                   handler=NULL, action=NULL,
                   container = NULL,
                   ...) {
            cat(gettext("gsvg widget not imlemented"))
            return(glabel(container=container, ...))
          })

##' @imports guiComponents
##' 

############### removeHandler ###################################
##' generic to remove a handler
##' @alias removeHandler
setGeneric("removehandler",function(obj, ID=NULL, ...)
           standardGeneric("removehandler"))

##' base method to remove a handler
##' @alias removeHandler
setMethod("removehandler", signature("guiWidget"),
          function(obj, ID=NULL, ...) {
            .removehandler(obj@widget, obj@toolkit, ID, ...)
          })

##' dispatch to toolkit
##' @alias removeHandler
setGeneric(".removehandler",function(obj, toolkit, ID=NULL, ...)
           standardGeneric(".removehandler"))

##' generic to define method to remove a handler by ID
setGeneric("removeHandler",function(obj, ID=NULL, ...)
           standardGeneric("removeHandler"))

##' base method to remove a handler
##'
##' @param obj object with event handler set for it
##' @param ID ID of handler returned when handler is set. If NULL, all handlers are removed
##' @return NULL, called for side effect
##' @export
setMethod("removeHandler", signature("guiWidget"),
          function(obj, ID=NULL, ...) {
            .removehandler(obj@widget, obj@toolkit, ID, ...)
          })

############### blockHandler ###################################
##' Generic to block a handler from being called until block is unblocked
##' @alias blockHandler
setGeneric("blockhandler",function(obj, ID=NULL, ...)
           standardGeneric("blockhandler"))
##' base method for blocking a handler by ID
##' @alias blockHandler
setMethod("blockhandler", signature("guiWidget"),
          function(obj, ID=NULL, ...) {
            .blockhandler(obj@widget, obj@toolkit, ID, ...)
          })
##' method for toolkit dispatch
##' @alias blockHandler
setGeneric(".blockhandler",function(obj, toolkit, ID=NULL, ...)
           standardGeneric(".blockhandler"))

##' Generic to define method to block a handler from being called
##' 
##' @param obj object with event handler set for it
##' @param ID ID of handler returned when handler is set. If NULL, all handlers are blocked
##' @return NULL, called for side effect
##' @export
setGeneric("blockHandler",function(obj, ID=NULL, ...)
           standardGeneric("blockHandler"))

##' base method to block a handler from being called.
setMethod("blockHandler", signature("guiWidget"),
          function(obj, ID=NULL, ...) {
            .blockhandler(obj@widget, obj@toolkit, ID, ...)
          })

##################################################
##' Generic to define method to unblock a blocked handler
setGeneric("unblockhandler",function(obj, ID=NULL, ...)
           standardGeneric("unblockhandler"))

##' base method to unblock a blocked handler
setMethod("unblockhandler", signature("guiWidget"),
          function(obj, ID=NULL, ...) {
            .unblockhandler(obj@widget, obj@toolkit, ID, ...)
          })

##' method for toolkit dispatch
##' @alias unblockHandler
setGeneric(".unblockhandler",function(obj, toolkit, ID=NULL, ...)
           standardGeneric(".unblockhandler"))

##' Generic for unblocking a blocked handler
##'
##' @param obj object with event handler
##' @param ID id of handler set through addHandlerXXX call
##' @param ... ignored
##' @return NULL, called for side effect
##' @export
setGeneric("unblockHandler",function(obj, ID=NULL, ...)
           standardGeneric("unblockHandler"))
setMethod("unblockHandler", signature("guiWidget"),
          function(obj, ID=NULL, ...) {
            .unblockhandler(obj@widget, obj@toolkit, ID, ...)
          })


##################################################
## addhandler is now exported
setGeneric("addhandler",function(obj, signal, handler, action=NULL, ...) standardGeneric("addhandler"))
setMethod("addhandler",signature(obj="guiWidget"),
          function(obj, signal, handler, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandler(obj@widget, toolkit, handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandler",function(obj,  toolkit, signal, handler, action=NULL,...) standardGeneric(".addhandler"))

##' Add a handler using toolkit-specific signal
##'
##' This is not portable across toolkits, as the signal passed in a toolkit specific.
##' @param obj gWidgets object to get event handler
##' @param signal toolkit signal defining event
##' @param handler function to call when event occurs. Uses standard signature (h,...)
##' @param action used to parameterize handler call, passed in as \code{h$action}
##' @param ... ignored
##' @return an ID of the handler for blocking or removal
##' @export
setGeneric("addHandler",function(obj, signal, handler, action=NULL, ...) standardGeneric("addHandler"))

##
setMethod("addHandler",signature(obj="guiWidget"),
          function(obj, signal, handler, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandler(obj@widget, toolkit, signal, handler, action, ...)
          })

           

## addhandlerchanged
setGeneric("addhandlerchanged",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addhandlerchanged"))
setMethod("addhandlerchanged",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerchanged(obj@widget, toolkit, handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandlerchanged",function(obj, toolkit,...) standardGeneric(".addhandlerchanged"))


##' Set handler for most typical event
##'
##' The "Changed" handler is set to be called for the most typical
##' event (arbitrarily defined of course). This event varies from
##' widget to widget. It is the same event that the widget
##' constructor's \code{handler} argument is called for.
setGeneric("addHandlerChanged",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addHandlerChanged"))
setMethod("addHandlerChanged",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerchanged(obj@widget, toolkit, handler, action, ...)
          })



## addhandlerkeystroke
setGeneric("addhandlerkeystroke",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addhandlerkeystroke"))
setMethod("addhandlerkeystroke",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerkeystroke(obj@widget, toolkit,handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandlerkeystroke",function(obj, toolkit,...) standardGeneric(".addhandlerkeystroke"))
#caps
setGeneric("addHandlerKeystroke",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addHandlerKeystroke"))
setMethod("addHandlerKeystroke",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerkeystroke(obj@widget, toolkit,handler, action, ...)
          })



## addhandlerclicked
setGeneric("addhandlerclicked",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addhandlerclicked"))
setMethod("addhandlerclicked",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerclicked(obj@widget, toolkit,handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandlerclicked",function(obj, toolkit,...) standardGeneric(".addhandlerclicked"))
## caps
setGeneric("addHandlerClicked",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addHandlerClicked"))
setMethod("addHandlerClicked",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerclicked(obj@widget, toolkit,handler, action, ...)
          })



## addhandlerdoubleclick
setGeneric("addhandlerdoubleclick",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addhandlerdoubleclick"))
setMethod("addhandlerdoubleclick",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerdoubleclick(obj@widget,toolkit,handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandlerdoubleclick",function(obj, toolkit,...) standardGeneric(".addhandlerdoubleclick"))
## caps
setGeneric("addHandlerDoubleclick",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addHandlerDoubleclick"))
setMethod("addHandlerDoubleclick",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerdoubleclick(obj@widget,toolkit,handler, action, ...)
          })



## addhandlerrightclick
setGeneric("addhandlerrightclick",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addhandlerrightclick"))
setMethod("addhandlerrightclick",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerrightclick(obj@widget,toolkit,handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandlerrightclick",function(obj,toolkit,...) standardGeneric(".addhandlerrightclick"))
## caps
setGeneric("addHandlerRightclick",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addHandlerRightclick"))
setMethod("addHandlerRightclick",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerrightclick(obj@widget,toolkit,handler, action, ...)
          })


###
## Column clicks
## clicked
setGeneric("addhandlercolumnclicked",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addhandlercolumnclicked"))
setMethod("addhandlercolumnclicked",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlercolumnclicked(obj@widget, toolkit,handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandlercolumnclicked",function(obj, toolkit,...) standardGeneric(".addhandlercolumnclicked"))
## caps
setGeneric("addHandlerColumnClicked",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addHandlerColumnClicked"))
setMethod("addHandlerColumnClicked",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlercolumnclicked(obj@widget, toolkit,handler, action, ...)
          })



## addhandlerCOLUMNdoubleclick
setGeneric("addhandlercolumndoubleclick",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addhandlercolumndoubleclick"))
setMethod("addhandlercolumndoubleclick",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlercolumndoubleclick(obj@widget,toolkit,handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandlercolumndoubleclick",function(obj, toolkit,...) standardGeneric(".addhandlercolumndoubleclick"))
## caps
setGeneric("addHandlerColumnDoubleclick",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addHandlerColumnDoubleclick"))
setMethod("addHandlerColumnDoubleclick",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlercolumndoubleclick(obj@widget,toolkit,handler, action, ...)
          })

## columnrightclick


## addhandlerCOLUMNdoubleclick
setGeneric("addhandlercolumnrightclick",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addhandlercolumnrightclick"))
setMethod("addhandlercolumnrightclick",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlercolumnrightclick(obj@widget,toolkit,handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandlercolumnrightclick",function(obj, toolkit,...) standardGeneric(".addhandlercolumnrightclick"))
## caps
setGeneric("addHandlerColumnRightclick",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addHandlerColumnRightclick"))
setMethod("addHandlerColumnRightclick",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlercolumnrightclick(obj@widget,toolkit,handler, action, ...)
          })



## Selections
setGeneric("addhandlerselect",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addhandlerselect"))
setMethod("addhandlerselect",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerselect(obj@widget,toolkit,handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandlerselect",function(obj,toolkit,...) standardGeneric(".addhandlerselect"))
## caps
setGeneric("addHandlerSelect",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addHandlerSelect"))
setMethod("addHandlerSelect",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerselect(obj@widget, toolkit, handler, action, ...)
          })





## addhandlerFocus
setGeneric("addhandlerfocus",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addhandlerfocus"))
setMethod("addhandlerfocus",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerfocus(obj@widget,toolkit,handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandlerfocus",function(obj,toolkit,...) standardGeneric(".addhandlerfocus"))
## caps
setGeneric("addHandlerFocus",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addHandlerFocus"))
setMethod("addHandlerFocus",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerfocus(obj@widget,toolkit,handler, action, ...)
          })



## addhandlerblur
setGeneric("addhandlerblur",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addhandlerblur"))
setMethod("addhandlerblur",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerblur(obj@widget,toolkit,handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandlerblur",function(obj,toolkit,...) standardGeneric(".addhandlerblur"))
## caps
setGeneric("addHandlerBlur",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addHandlerBlur"))
setMethod("addHandlerBlur",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerblur(obj@widget,toolkit,handler, action, ...)
          })




## addhandlerdestroy
setGeneric("addhandlerdestroy",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addhandlerdestroy"))
setMethod("addhandlerdestroy",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerdestroy(obj@widget, toolkit,handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandlerdestroy",function(obj,toolkit,...) standardGeneric(".addhandlerdestroy"))
##caps
setGeneric("addHandlerDestroy",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addHandlerDestroy"))
setMethod("addHandlerDestroy",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerdestroy(obj@widget, toolkit,handler, action, ...)
          })


# addhandlerexpose
setGeneric("addhandlerexpose",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addhandlerexpose"))
setMethod("addhandlerexpose",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerexpose(obj@widget,toolkit,handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandlerexpose",function(obj, toolkit,...) standardGeneric(".addhandlerexpose"))
## caps
setGeneric("addHandlerExpose",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addHandlerExpose"))
setMethod("addHandlerExpose",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerexpose(obj@widget,toolkit,handler, action, ...)
          })

# addhandlerunrealize
##' handler when window is unrealized
##'
##' For gwindow objects this handler is called before the window is closed. If this handler
##' returns \code{TRUE} the window will be close, if \code{FALSE} the window will not be closed.
##' @param obj gWidget object
##' @param handler function with signature (h,...) to call when event occurs
##' @param action value passed to handler function in component \code{h$action}
##' @param ... ignored
##' @return ID of handler, used for blocking or removing
##' @export
##' @examples
##' \dontrun{
##' w <- gwindow("Really close?")
##' addHandlerUnrealize(w, handler=function(h,...) {
##' gconfirm("Really close?", parent=w)
##' })
##' }
setGeneric("addhandlerunrealize",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addhandlerunrealize"))
setMethod("addhandlerunrealize",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerunrealize(obj@widget,toolkit,handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandlerunrealize",function(obj, toolkit,...) standardGeneric(".addhandlerunrealize"))
## caps
setGeneric("addHandlerUnrealize",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addHandlerUnrealize"))
setMethod("addHandlerUnrealize",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlerunrealize(obj@widget,toolkit,handler, action, ...)
          })




## mousemotion
##' Handler to respond to mouse motion
##'
##' Movement of mouse over widget triggers this handler
##' @param obj gWidget object
##' @param handler function with signature (h,...) to call when event occurs
##' @param action value passed to handler function in component \code{h$action}
##' @param ... ignored
##' @return ID of handler, used for blocking or removing
##' @export
setGeneric("addhandlermousemotion",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addhandlermousemotion"))
setMethod("addhandlermousemotion",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlermousemotion(obj@widget,toolkit,handler, action, ...)
          })
## dispatch with toolkit
setGeneric(".addhandlermousemotion",function(obj, toolkit,...) standardGeneric(".addhandlermousemotion"))
## caps
setGeneric("addHandlerMouseMotion",function(obj, handler=NULL, action=NULL, ...) standardGeneric("addHandlerMouseMotion"))
setMethod("addHandlerMouseMotion",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .addhandlermousemotion(obj@widget,toolkit,handler, action, ...)
          })




# addhandleridle
setGeneric("addhandleridle",function(obj, handler=NULL, action=NULL, interval=1000, ...) standardGeneric("addhandleridle"))
setMethod("addhandleridle",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, interval=1000, ...) {
            toolkit = obj@toolkit
            .addhandleridle(obj@widget, toolkit, handler=handler, action=action, interval=interval, ...)
          })
## dispatch with toolkit
setGeneric(".addhandleridle",function(obj, toolkit,handler=NULL,action=NULL,
                                      interval=1000,...) standardGeneric(".addhandleridle"))
## caps
setGeneric("addHandlerIdle",function(obj, handler=NULL, action=NULL, interval=1000, ...) standardGeneric("addHandlerIdle"))
setMethod("addHandlerIdle",signature(obj="guiWidget"),
          function(obj, handler=NULL, action=NULL, interval=1000, ...) {
            toolkit = obj@toolkit
            .addhandleridle(obj@widget, toolkit, handler=handler, action=action, interval=interval, ...)
          })

## addpopupmenu
setGeneric("addpopupmenu",function(obj, menulist, action=NULL, ...) standardGeneric("addpopupmenu"))
setMethod("addpopupmenu",signature(obj="guiWidget"),
          function(obj, menulist, action=NULL, ...) {
            toolkit = obj@toolkit
            .addpopupmenu(obj@widget, toolkit,menulist, action, ...)
          })
## dispatch with toolkit
setGeneric(".addpopupmenu",function(obj, toolkit, menulist, action=NULL, ...) standardGeneric(".addpopupmenu"))
## caps
setGeneric("addPopupmenu",function(obj, menulist, action=NULL, ...) standardGeneric("addPopupmenu"))
setMethod("addPopupmenu",signature(obj="guiWidget"),
          function(obj, menulist, action=NULL, ...) {
            toolkit = obj@toolkit
            .addpopupmenu(obj@widget, toolkit,menulist, action, ...)
          })

## add3rdmousepopupmenu
setGeneric("add3rdmousepopupmenu",function(obj, menulist, action=NULL,  ...) standardGeneric("add3rdmousepopupmenu"))
setMethod("add3rdmousepopupmenu",signature(obj="guiWidget"),
          function(obj, menulist, action=NULL,  ...) {
            .add3rdmousepopupmenu(obj@widget, obj@toolkit, menulist,
                                  action=action,  ...)
          })
## dispatch with toolkit
setGeneric(".add3rdmousepopupmenu",function(obj, toolkit,menulist, action=NULL, ...) standardGeneric(".add3rdmousepopupmenu"))
## caps
setGeneric("add3rdMousePopupmenu",function(obj, menulist, action=NULL,  ...) standardGeneric("add3rdMousePopupmenu"))
setMethod("add3rdMousePopupmenu",signature(obj="guiWidget"),
          function(obj, menulist, action=NULL,  ...) {
            .add3rdmousepopupmenu(obj@widget, obj@toolkit, menulist,
                                  action=action,  ...)
          })

## adddropsource
setGeneric("adddropsource",function(obj, targetType="text",
                                    handler=NULL, action=NULL, ...) standardGeneric("adddropsource"))
setMethod("adddropsource",signature(obj="guiWidget"),
          function(obj, targetType="text", handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .adddropsource(obj@widget, toolkit,targetType=targetType,
                           handler=handler, action=action, ...)
          })
## dispatch with toolkit
setGeneric(".adddropsource",function(obj, toolkit,targetType="text", handler=NULL, action=NULL, ...) standardGeneric(".adddropsource"))
## caps
setGeneric("addDropSource",function(obj, targetType="text",
                                    handler=NULL, action=NULL, ...) standardGeneric("addDropSource"))
setMethod("addDropSource",signature(obj="guiWidget"),
          function(obj, targetType="text", handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .adddropsource(obj@widget, toolkit,targetType=targetType,
                           handler=handler, action=action, ...)
          })


## adddropmotion
setGeneric("adddropmotion",function(obj, handler=NULL, action=NULL, ...)
           standardGeneric("adddropmotion"))
setMethod("adddropmotion",signature(obj="guiWidget"),
          function(obj,  handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .adddropmotion(obj@widget, toolkit,
                           handler=handler, action=action, ...)
          })
## dispatch with toolkit
setGeneric(".adddropmotion",function(obj, toolkit, handler=NULL, action=NULL, ...) standardGeneric(".adddropmotion"))
## caps
setGeneric("addDropMotion",function(obj, handler=NULL, action=NULL, ...)
           standardGeneric("addDropMotion"))

setMethod("addDropMotion",signature(obj="guiWidget"),
          function(obj,  handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .adddropmotion(obj@widget, toolkit,
                           handler=handler, action=action, ...)
          })

## adddroptarget
setGeneric("adddroptarget",function(obj, targetType="text",
                                    handler=NULL, action=NULL, ...) standardGeneric("adddroptarget"))
setMethod("adddroptarget",signature(obj="guiWidget"),
          function(obj, targetType="text", handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .adddroptarget(obj@widget, toolkit,targetType=targetType,
                           handler=handler, action=action, ...)
          })
## dispatch with toolkit
setGeneric(".adddroptarget",function(obj, toolkit,targetType="text", handler=NULL, action=NULL, ...) standardGeneric(".adddroptarget"))
## caps
setGeneric("addDropTarget",function(obj, targetType="text",
                                    handler=NULL, action=NULL, ...) standardGeneric("addDropTarget"))
setMethod("addDropTarget",signature(obj="guiWidget"),
          function(obj, targetType="text", handler=NULL, action=NULL, ...) {
            toolkit = obj@toolkit
            .adddroptarget(obj@widget, toolkit,targetType=targetType,
                           handler=handler, action=action, ...)
          })

require(methods)
require(utils)

## Set up generics and classes for ANY widgets.                                 
## ANY widgets are meant to work with any toolkit. They are compound widgets
## their methods are not inherited from the toolkit ones, but rather are made explicit here.


## how to make a generic widget here?



### Methods
## We need these methods to get the dispatch correct.



## TAG method uses ID
## This is taken from gWIdgets tcltk. It uses a big hash. Ughh
## create namespace object
tags = list()
assignInNamespace("tags",list(),"gWidgets")

## clear out tags for this ID. Not exported. Is this used?
Tagsclear = function(obj) {

  id = obj@ID
  
  tags = getFromNamespace("tags",ns="gWidgets")
  allKeys = names(tags)

  inds = grep(paste("^",id,"::",sep=""),allKeys)
  if(length(inds) == 0)
    return(NA)

  ## else
  tags[[inds]] <- NULL
  assignInNamespace("tags",tags,ns="gWidgets")
}


setMethod("tag",signature(obj="gWidgetANY"),
          function(obj,i,drop=TRUE, ...) {
            if(missing(drop)) drop <- TRUE
            .tag(obj, obj@toolkit,i, drop=drop,...)
          })

setMethod(".tag", signature(toolkit="ANY",obj="guiWidget"),
          function(obj, toolkit, i, drop=TRUE, ...) {
            if(missing(i)) i = NULL
            if(missing(drop)) drop <- TRUE                        
            .tag(obj@widget,toolkit,  i, drop=drop,  ...)
          })
setMethod(".tag", signature(toolkit="ANY",obj="gWidgetANY"),
          function(obj, toolkit, i, drop=TRUE, ...) {
            if(missing(i)) i = NULL
            if(missing(drop)) drop <- TRUE                                    


            id = obj@ID

            ## get all values for this id
            tags = getFromNamespace("tags",ns="gWidgets")
            allKeys = names(tags)

            inds = grep(paste("^",id,"::",sep=""),allKeys)
            if(length(inds) == 0)
              return(NULL)

            justTheKeys = sapply(allKeys[inds],function(keyWithID) {
              sub(paste("^",id,"::",sep=""),"",keyWithID)
            })

            tagByKey = list()
            for(key in justTheKeys) 
              tagByKey[[key]] = tags[[paste(id,key,sep="::")]]
                      
            
            
            if(is.null(i)) return(tagByKey)

            if(drop) {
              if(length(i) == 1)
                return(tagByKey[[i]])
              else
                return(sapply(i, function(j) tagByKey[j]))
            } else {
              return(sapply(i, function(j) tagByKey[j]))
            }
          })

## tag <-
setReplaceMethod("tag",signature(obj="gWidgetANY"),
          function(obj, i, replace=TRUE, ..., value) {
            .tag(obj, obj@toolkit,i,replace, ...) <- value
            return(obj)
          })

## objects can be in many different flavors: guiWIdget, gWidgettcltk, tcltkObject
setReplaceMethod(".tag", signature(toolkit="ANY",obj="guiWidget"),
          function(obj, toolkit, i, replace=TRUE, ..., value) {
            if(missing(i)) i = NULL
            .tag(obj@widget,toolkit,  i, replace, ...) <- value
            return(obj)
          })

setReplaceMethod(".tag", signature(toolkit="ANY",obj="gWidgetANY"),
          function(obj, toolkit, i, replace=TRUE, ..., value) {
            if(missing(i)) i = NULL
            

            id = obj@ID
            key = paste(id,i,sep="::")
            
            ## if we append we need to work a little harder
            tags = getFromNamespace("tags",ns="gWidgets")
  
            if(replace==FALSE) {
              value = c(tags[[key]],value)
            }

            tags[[key]] <- value
            assignInNamespace("tags", tags,ns="gWidgets")

            return(obj)

          })

### svalue


## Generic svalue
setMethod(".svalue",signature(toolkit = "ANY", obj="character"),
          function(obj, toolkit, index=NULL, drop=NULL,  ...)  {
            ifelse(length(obj) == 1,
                   return(getObjectFromString(obj)),
                   return(NA)
                   )
          })

setMethod(".svalue",signature(toolkit = "ANY", obj="NULL"),
          function(obj, toolkit, index=NULL, drop=NULL,  ...)  {
            return(NULL)
          })


setMethod("svalue",signature(obj="gWidgetANY"),
          function(obj, index=NULL, drop=NULL, ... ) {
            toolkit = obj@toolkit
            .svalue(obj, toolkit, ...,index=index, drop=drop)
          })

## svalue<- -- objec specific
setReplaceMethod("svalue",signature(obj="gWidgetANY"),
          function(obj, index=NULL, ...,value) {
            .svalue(obj, obj@toolkit, index=index, ...) <- value
            return(obj)
          })

## [. [<-
## [
setMethod("[",
          signature(x="gWidgetANY"),
          function(x,i,j,...,drop=TRUE) {
            
            return(.leftBracket(x, x@toolkit,i,j,...,drop=TRUE))
          })

## [<-
setReplaceMethod("[",signature(x="gWidgetANY"),
          function(x,i,j,...,value) {
            if(missing(i) && missing(j))
              .leftBracket(x, x@toolkit,...) <- value
            else if(missing(j))
              .leftBracket(x, x@toolkit,i,...) <- value
            else 
              .leftBracket(x, x@toolkit,i,j,...) <- value
            return(x)
          })

## size<-
setReplaceMethod("size",signature(obj="gWidgetANY"),
          function(obj, ..., value) {
            .size(obj, obj@toolkit,...) <- value
            return(obj)
          })

## visible
setMethod("visible",signature(obj="gWidgetANY"),
          function(obj, set=NULL, ...) {
            .visible(obj,obj@toolkit, set=set, ...)
          })

setReplaceMethod("visible",signature(obj="gWidgetANY"),
          function(obj, ..., value) {
            .visible(obj, obj@toolkit, ...) <- value
            return(obj)
          })

## enabled -- TRUE If state is normal
setMethod("enabled",signature(obj="gWidgetANY"),
          function(obj, ...) {
            .enabled(obj, obj@toolkit,...)
          })

setReplaceMethod("enabled",signature(obj="gWidgetANY"),
          function(obj, ..., value) {
            .enabled(obj, obj@toolkit,...) <- value
            return(obj)
          })

setMethod("focus",signature(obj="gWidgetANY"),
          function(obj, ...) {
            .focus(obj, obj@toolkit,...)
          })


setReplaceMethod("focus",signature(obj="gWidgetANY"),
          function(obj, ..., value) {
            .focus(obj, obj@toolkit,...) <- value
            return(obj)
          })

## font<-
setReplaceMethod("font",signature(obj="gWidgetANY"),
          function(obj, ..., value) {
            .font(obj, obj@toolkit,...) <- value
            return(obj)
          })

## update
setMethod("update",signature(object="gWidgetANY"),
          function(object, ...) {
            .update(object, object@toolkit, ...)
          })


## dimnames
setMethod("dimnames", "gWidgetANY", function(x) .dimnames(x,x@toolkit))
setReplaceMethod("dimnames",
                 signature(x="gWidgetANY"),
                 function(x,value) {
                   .dimnames(x,x@toolkit) <- value
                   return(x)
                 })

## as of 2.5.0 this became primiive
if(as.numeric(R.Version()$major) <= 2 &
   as.numeric(R.Version()$minor) <= 4.1) {
  setGeneric("names")
  setGeneric("names<-")
}

setMethod("names", "gWidgetANY", function(x) .names(x,x@toolkit))
setReplaceMethod("names",
                 signature(x="gWidgetANY"),
                 function(x,value) {
                   .names(x,x@toolkit) <- value
                   return(x)
                 })


## add for widgets (gtext, ghelp, ...)
## Container methods are in toolkits implementations
setMethod("add",signature(obj="ANY"),
          function(obj, value, ...) {
            .add(obj, obj@toolkit,value,...)
          })

setMethod(".add",
          signature(toolkit="ANY",
                    obj="ANY", value="gWidgetANY"),
          function(obj, toolkit, value, ...) {
            .add(obj, toolkit, value@widget, ...)
          })



## undo and redo only implemented in some toolkits
setMethod("undo",signature(obj="gWidgetANY"),
          function(obj,...) {
            .undo(obj, obj@toolkit,...)
          })

setMethod(".undo", signature(toolkit="ANY",obj="guiWidget"),
          function(obj, toolkit, ...) {
            .undo(obj@widget,toolkit,...)
          })
setMethod(".undo", signature(toolkit="ANY",obj="gWidgetANY"),
          function(obj,toolkit, ...) {
            ## nothing
          })

setMethod("redo",signature(obj="gWidgetANY"),
          function(obj,...) {
            .redo(obj, obj@toolkit,...)
          })

setMethod(".redo", signature(toolkit="ANY",obj="guiWidget"),
          function(obj, toolkit, ...) {
            .redo(obj@widget,toolkit)
          })
setMethod(".redo", signature(toolkit="ANY",obj="gWidgetANY"),
          function(obj, toolkit, ...) {
            ## nothing
          })

##' @include guiComponents



##' Alert dialog to display transient messages
##' 
##' @param message main message. 
##' @param title Title (may not be displayed)
##' @param delay length of time (in seconds) to display
##' @param parent parent object to show near
##' @param ... ignored
##' @param toolkit toolkit
##' @rdname gWidgets-dialogs
galert = function(
  message,
  title = "message",
  delay = 3,
  parent = NULL, 
  ..., toolkit=guiToolkit()) {
  .galert(toolkit,message, title, delay=delay, parent=parent,
            ...)
}
##' generic for toolkit dispatch
##' @alias galert
setGeneric(".galert",
           function(toolkit,
                    message, title="message", delay=3, parent=NULL, ...)
           standardGeneric(".galert"))


##' Constructor for modal message dialog
##' 
##' @export
##' @param message Character. message to display. 
##' @param title Character. Title
##' @param icon What icon to show
##' @param parent Hint as to where to display
##' @param handler called if Ok button clicked
##' @param action passed to handler
##' @param ... ignored
##' @param toolkit toolkit
##' @rdname gWidgets-dialogs
gmessage = function(
  message,
  title = "message",
  icon = c("info", "warning", "error", "question"),
  parent=NULL,
  handler = NULL, action = NULL,
  ..., toolkit=guiToolkit()) {
  .gmessage(toolkit,message, title, icon, parent, handler, action,
            ...)
}

##' generic for toolkit dispatch
##' @alias gmessage
setGeneric(".gmessage",
           function(toolkit,
                    message="", title="", icon="",
                    parent = NULL,
                    handler=NULL, action=NULL, ...)
           standardGeneric(".gmessage"))

############## ginput ####################################

##' Constructor for modal dialog to collect a line of text
##'
##' @export
##' @param message Character. Message to display.
##' @param text Character. Initial text
##' @param title Character. Title of window
##' @param icon which icon to display
##' @param parent gives hint as to where to place dialog
##' @param handler called on \code{Ok}
##' @param action passed to handler
##' @param ... ignored
##' @param toolkit toolkit
##' @rdname gWidgets-dialog
ginput <- function(
  message, text="",
  title = "Input",
  icon = c("info", "warning", "error", "question"),
  parent = NULL,
  handler = NULL, action = NULL,
  ..., toolkit=guiToolkit()) {
  .ginput(toolkit,
          message, text=text, title=title, icon, parent, handler, action, 
          ...)
}

##' generic for toolkit dispatch
##' @alias ginput
##' @export
##' @rdname gWidgets-dialog
setGeneric(".ginput",
           function(toolkit,
                    message=message, text=text, title=title, icon=icon,
                    parent = parent,
                    handler=handler, action=action, ...)
           standardGeneric(".ginput"))

################# gconfirm #################################
##' Constructor for modal dialog to get confirmation
##'
##' @export
gconfirm = function(
  message,
  title = "Confirm",
  icon = c("info", "warning", "error", "question"),
  parent=NULL,
  handler = NULL, action = NULL,
  ..., toolkit=guiToolkit()) {
  .gconfirm(toolkit,message=message, icon=icon, parent=parent, handler=handler, action=action,
            ...)
}

##' generic for toolkit dispatch
##' @alias gconfirm
setGeneric(".gconfirm",
           function(toolkit,
                    message=message, title=title, icon=icon,
                    parent = parent,
                    handler=handler, action=action, ...)
           standardGeneric(".gconfirm"))

################# gbasicdialog #################################

## define subclass for basic dialog
setClass("guiDialog",
         contains="guiContainer",
         prototype=prototype(new("guiContainer"))
         )




##' Constructor for modal dialog that can contain an arbitrary widget
##'
##' The basic dialog is basically a modal window. To use there is a 3
##' step process: 1) Create a container by calling this constructor,
##' say \code{dlg}; 2) use \code{dlg} as a container for your
##' subsequent GUI; 3) set the dialog to be modal by calling
##' \code{visible(dlg, set=TRUE)}. (One can't call \code{visible(dlg)
##' <- TRUE}.)
##' 
##' @export
##' @param title title for window
##' @param widget widget to add (Only if toolkit supports it)
##' @param parent parent to display by
##' @param do.buttons FALSE to suppress buttons when no parent
##' @param handler handler called when \code{Ok} button invoked
##' @param action passed to handler
##' @param ... ignored
##' @param toolkit toolkit
##' @rdname gWidgets-dialogs
gbasicdialog <- function(
                         title = "Dialog", widget,
                         parent = NULL,
                         do.buttons=TRUE,
                         handler = NULL, action = NULL,
                         ..., toolkit=guiToolkit()) {
  
  if(missing(widget)) {
    obj <- .gbasicdialognoparent(toolkit, title, parent, handler, action,  ..., do.buttons=do.buttons)
    obj <- new( 'guiDialog',widget=obj,toolkit=toolkit) 
  } else {
    obj <- .gbasicdialog(toolkit,
                  title=title, widget=widget,parent=parent,
                  handler=handler, action=action, 
                         ...)
  }
  return(obj)
}

##' generic for toolkit dispatch
##' 
##' @alias gbasicdialog
setGeneric(".gbasicdialog",
           function(toolkit,
                    title = "Dialog", widget, parent,
                    handler = NULL, action = NULL, 
                    ...)
           standardGeneric(".gbasicdialog"))

##' generic for toolkit dispatch when there is no parent
##' 
##' @alias gbasicdialog
setGeneric(".gbasicdialognoparent",
           function(toolkit,
                    title = "Dialog",  parent,
                    handler = NULL, action = NULL, 
                    ...)
           standardGeneric(".gbasicdialognoparent"))

##' @include guiWidget.R
##'
##' 
##' A widget subclass for basic components
setClass("guiComponent",
         contains=c("guiWidget"),
         prototype=prototype(new("guiWidget"))
         )

##' define a subclass
setClass("gComponentANY",
         contains=c("gWidgetANY"),
         prototype=prototype(new("gWidgetANY"))
         )


############### methods ###################################

################ add ##################################
##' method for adding to ghelp, etc
setMethod("add",signature(obj="guiComponent"),
          function(obj, value, ...) {
            .add(obj@widget, obj@toolkit, value, ...)
          })


############### focus ###################################
##' generic to check if a widget has the focus
setGeneric("focus",function(obj, ...) standardGeneric("focus"))

##' method to check is a component has the focus 
setMethod("focus",signature(obj="guiWidget"),
          function(obj, ...) {
            toolkit = obj@toolkit
            .focus(obj@widget, toolkit,...)
          })
##' dispatch with toolkit
##' @alias focus
setGeneric(".focus",function(obj, toolkit,...) standardGeneric(".focus"))


############### focus<- ###################################

##' generic to set focus on a widget
setGeneric("focus<-",function(obj, ..., value) standardGeneric("focus<-"))

##' method for setting focus on a component
setMethod("focus<-",signature(obj="guiWidget"),
          function(obj, ..., value) {
            toolkit <- obj@toolkit
            .focus(obj@widget, toolkit,...) <- value
            return(obj)
          })
##' dispatch with toolkit
##' @alias focus<-
setGeneric(".focus<-",function(obj, toolkit,...,value)
           standardGeneric(".focus<-"))



############### tooltip<- ###################################
##' generic to set a tooltip for a component
setGeneric("tooltip<-",function(obj, ..., value) standardGeneric("tooltip<-"))

##' base method for setting a toolktip
setMethod("tooltip<-",signature(obj="guiComponent"),
          function(obj, ..., value) {
            toolkit <- obj@toolkit
            .tooltip(obj@widget, toolkit,...) <- value
            return(obj)
          })
##' dispatch with toolkit
##' @alias tooltip<-
setGeneric(".tooltip<-",function(obj, toolkit,...,value)
           standardGeneric(".tooltip<-"))


############## undo ####################################
##' Generic to implement undo feature in widgets
setGeneric("undo",function(obj, ...) standardGeneric("undo"))

##' base method for undo
setMethod("undo",signature(obj="guiComponent"),
          function(obj, ...) {
            toolkit = obj@toolkit
            .undo(obj@widget, toolkit,...)
          })
##' dispatch with toolkit
##' @alias undo
setGeneric(".undo",function(obj,toolkit,...) standardGeneric(".undo"))

############## redo ####################################
##' Generic to implement redo feature in widgets
setGeneric("redo",function(obj, ...) standardGeneric("redo"))

##' Base method for redo
setMethod("redo",signature(obj="guiComponent"),
          function(obj, ...) {
            toolkit = obj@toolkit
            .redo(obj@widget, toolkit,...)
          })
##' dispatch with toolkit
##' @alias redot
setGeneric(".redo",function(obj,toolkit,...) standardGeneric(".redo"))

##' @include guiComponents.R

##' single line text edit class
setClass("gMenu",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' menu constructor, main and popup
##'
##' @exports
gmenu <- function(
  menulist, popup = FALSE, action = NULL, container = NULL,      ... ,
  toolkit=guiToolkit()){
  widget <- .gmenu (toolkit,
                    menulist=menulist, popup=popup, action=action, container=container ,...
                    )
  obj <- new( 'guiComponent',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gmenu
setGeneric( '.gmenu' ,
           function(toolkit,
                    menulist, popup = FALSE, action = NULL, container = NULL,
                    ... )
           standardGeneric( '.gmenu' ))

##' @include guiComponents.R

##' multi-line text edit class
setClass("gText",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' Multiline text edit constructor
##'
##' @exports
gtext <- function(
                  text = NULL, width = NULL, height = 300, font.attr = NULL,
                  wrap = TRUE,
                  handler = NULL, action = NULL, container = NULL,      ... ,
                  toolkit=guiToolkit()){
  widget <- .gtext(toolkit,
                   text=text, width=width, height=height, font.attr=font.attr, wrap=wrap,
                   handler=handler, action=action, container=container ,...
                   )
  obj <- new( 'gText',widget=widget,toolkit=toolkit) 
  return(obj)
}
 

##' generic for toolkit dispatch
##' @alias gtext
setGeneric( '.gtext' ,
           function(toolkit,
                    text = NULL, width = NULL, height = 300, font.attr = NULL,
                    wrap = TRUE,
                    handler = NULL, action = NULL, container = NULL,... )
           standardGeneric( '.gtext' ))


################### methods ###############################

################### insert ###############################
##' generic to insert text into gtext widget
setGeneric("insert",function(obj,value,
                             where = c("end","beginning","at.cursor"),
                             font.attr=NULL,
                             do.newline=TRUE,
                             ...) standardGeneric("insert"))

##' insert text method
setMethod("insert",signature(obj="gText"),
          function(obj, value, where = c("end","beginning","at.cursor"), font.attr = NULL,
                   do.newline = TRUE, ...) {
            toolkit = obj@toolkit
            where = match.arg(where)
            .insert(obj@widget, toolkit, value, where, font.attr,do.newline,...)
          })

##' dispatch with toolkit
##' @alias insert
setGeneric(".insert",function(obj, toolkit,value, where=c("end","beginning","at.cursor"),
                              font.attr=NULL, do.newline=TRUE,...)
           standardGeneric(".insert"))

##' @include guiContainer.R

##' Base class for box containers. Subclasses are gFrame, gExpandGroup
setClass("gGroup",
         contains="guiContainer",
         prototype=prototype(new("guiContainer"))
         )

##' Constructor for horizontal or vertical box container
##'
##' @param horizontal layout children left to right (\code{TRUE}) or top to bottom (\code{FALSE})
##' @param spacing between widget spacing. (No API to set margin size)
##' @param use.scrollwindow if \code{TRUE} uses scrollbars when
##' requested size for children larger than display size of the widget
##' @param container parent container
##' @param ... ignored
##' @param toolkit underlying toolkit, unusual to specify
##' @export
##' @seealso \code{\link{gframe}}, \code{\link{gexpandgroup}}
ggroup <- function(
                   horizontal = TRUE, spacing = 5, use.scrollwindow = FALSE, container = NULL, ... ,
                   toolkit=guiToolkit()){
  widget <- .ggroup (toolkit,
                     horizontal=horizontal, spacing=spacing,
                     use.scrollwindow = use.scrollwindow, 
                     container=container,...
                     )
  obj <- new( 'gGroup',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' 
##' @alias ggroup
setGeneric( '.ggroup' ,
           function(toolkit,
                    horizontal = TRUE, spacing = 5,  use.scrollwindow = FALSE, container = NULL,  ... )
           standardGeneric( '.ggroup' ))



################## Methods ###############################


##' Return spacing between widgets in a box container
##'
##' Main property of a box container is the spacing between widgets
##' @param obj object
##' @param index ignored
##' @param drop ignored
##' @param ... ignored
##' @return integer. between widget spacing in pixes
setMethod("svalue",signature(obj="gGroup"),
          function(obj, index=NULL, drop=NULL, ... ) {
            .svalue(obj@widget, obj@toolkit, ...,index=index, drop=drop)            
          })


##' set between widget spacing for box containers
##'
##' @param obj
##' @param index ignormed
##' @param ... ignored
##' @param value integer, spacing values
setReplaceMethod("svalue",signature(obj="gGroup"),
          function(obj, index=NULL, ...,value) {
            .svalue(obj@widget, obj@toolkit, index=index, ...) <- value
            return(obj)
          })


################## addSpace ################################
##' addSpace generic for box containers
##'
##' @export
setGeneric("addSpace",function(obj,value, ...) standardGeneric("addSpace"))

##' Add space between previous child and next one
##'
##' @param obj object
##' @param value integer, pixel size
##' @param ... ignored
##' @return void
setMethod("addSpace",signature(obj="gGroup"),
          function(obj, value, ...) {
            toolkit = obj@toolkit
            .addSpace(obj@widget,toolkit,value,...)
          })

##' dispatch with toolkit
##' @alias addSpace
setGeneric(".addSpace",function(obj,toolkit,value,...) standardGeneric(".addSpace"))


##################################################
##' addSpring generic
setGeneric("addSpring",function(obj,...) standardGeneric("addSpring"))

##' addSpring between children for box containers
##'
##' A spring pushes the two children to the sides (or top and bottom) of the box
##' @param obj object
##' @param ... ignored
##' @return void
setMethod("addSpring",signature(obj="gGroup"),
          function(obj, ...) {
            toolkit = obj@toolkit
            .addSpring(obj@widget, toolkit,...)
          })

##' dispatch with toolkit
##' @alias addSpring
setGeneric(".addSpring",function(obj, toolkit,...) standardGeneric(".addSpring"))

##' @include guiComponent.R
##'
##' 
##' A widget subclass for components with items
setClass("guiComponentWithItems",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

## [, [<-

FROM = "gWidgetsRGtk <gWidgetsRGtk@gmail.com>"
buddyList = c("My Friend <myfriend@gmail.com>","My dog <mydog@gmail.com>")

Rmail = function(draft = NULL, ...) {
  ## Define main widgets, store in a list for ease of use
  widgets = list()
  widgets$to = gdroplist(c(), editable=TRUE)
  widgets$from = glabel(FROM, editable=TRUE)
  widgets$subject = gedit()
  widgets$text = gtext()
  
  ## Handle drafts. Either a list or a filename to source")
  ## The generic svalue() method makes setting values easy")
  if(!is.null(draft)) {
    if(is.character(draft)) {
      print(draft)
      sys.source(draft,envir=environment())
      print("smudget")
      print(draft)
    }
    if(is.list(draft)) {
      print("draft is list")
      sapply(c("to","from","subject","text"), function(i)  {
        cat("assign",i,"value of",draft[[i]],"\n")
        svalue(widgets[[i]]) <- draft[[i]]
      })
    }
  }
  
  ## Helper functions
  sendIt = function(...) {
    tmp = tempfile()
    
    cat("To:", svalue(widgets$to),"\n",file = tmp, append=TRUE)
    cat("From:", svalue(widgets$from),"\n", file=tmp, append=TRUE)
    cat("Subject:", svalue(widgets$subject),"\n", file=tmp, append=TRUE)
    cat("Date:", format(Sys.time(),"%d %b %Y %T %Z"),"\n", file=tmp, append=TRUE)
    cat("X-sender:", "R", file=tmp, append=TRUE)
    cat("\n\n", file=tmp, append=TRUE)
    cat(svalue(widgets$text), file=tmp, append=TRUE)
    cat("\n", file=tmp, append=TRUE)
    
    ## Use UNIX sendmail to send message
    system(paste("sendmail -t  <", tmp))
    ## Add To: to buddyList
    if(exists("buddyList"))
    assign("buddyList", unique(c(buddyList,svalue(widgets$to))), inherits=TRUE)
    
    ## Close window, delete file
    unlink(tmp)
    dispose(window)
  }

  ## Function to save a draft to the file draft.R
  saveDraft = function(...) {
    draft = list()
    sapply(c("to","from","subject","text"), function(i) 
    draft[[i]] <<- svalue(widgets[[i]])
    )
    dump("draft","draft.R")
    cat("Draft dumped to draft.R\n")
  }
  
  ## A simple dialog
  aboutMail = function(...) gmessage("Sends a message")
  
  ## Make main window from top down
  
  window = gwindow("Compose mail")
  group = ggroup(horizontal=FALSE, spacing=0, container = window)
  ## Remove border
  svalue(group) <- 0
  
  ## Menubar is defined by a list
  menubarlist = list()
  menubarlist$File$Save$handler = saveDraft
  menubarlist$File$Send$handler = sendIt
  menubarlist$File$Quit$handler = function(...) dispose(window)
  menubarlist$File$Quit$icon = "quit"
  menubarlist$Help$About$handler = aboutMail
  add(group, gmenu(menubarlist))
  
  ## Toolbar is also defined by a list
  toolbarlist = list()
  toolbarlist$Send$handler = sendIt
  toolbarlist$Send$icon = "connect"
  toolbarlist$Save$handler = saveDraft
  toolbarlist$Save$icon = "save"
  add(group, gtoolbar(toolbarlist))
  
  
  ## Put headers in a glayout() container
  tbl = glayout(container = group)
  
  ## To: field. Looks for buddyList
  tbl[1,1] = glabel("To:")
  tbl[1,2] = widgets$to
  if(exists("buddyList")) widgets$to[] <- buddyList
  
  ## From: field. Click to edit value
  tbl[2,1] = glabel("From:")
  tbl[2,2] = widgets$from
  
  ## Subject: field. Handler updates window title
  tbl[3,1] = glabel("Subject:")
  tbl[3,2] = widgets$subject
  addHandlerKeystroke(widgets$subject, handler = function(h,...)
  svalue(window) = paste("Compose mail:",svalue(h$obj),collapse=""))
  
  ## Layout needs to be finalized
  visible(tbl) <- TRUE
  
  ## Add text box for message, but first some space
  addSpace(group, 5)
  add(group, widgets$text, expand=TRUE)
  
  ## That's it.
}

##' @include guiComponents.R

##' Class for widget to embed a graphic image
setClass("gImage",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' A widget for displaying an image
##'
##' @exports
gimage <- function(
                   filename = "", dirname = "", size = "", handler = NULL,
                   action = NULL, container = NULL, ... ,
                   toolkit=guiToolkit()){
  widget <- .gimage (toolkit,
                     filename=filename, dirname=dirname, size=size,
                     handler=handler, action=action, container=container ,...
                     )
  obj <- new( 'gImage',widget=widget,toolkit=toolkit) 
  return(obj)
}

##' generic for toolkit dispatch
##' @alias gimage
setGeneric( '.gimage' ,
           function(toolkit,
                    filename = "", dirname = "", size = "",
                    handler = NULL,action = NULL, container = NULL, ... )
           standardGeneric( '.gimage' ))

##' @include guiComponents.R

## A widget to provide a simple command line


##################################################

##' Class for a commandline widget
setClass("gCommandline",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' constructor of widget for use as a command line
##'
##' Basically a giant hack
##' @exports
##' @param command Initial command to evaluation
##' @param assignto Character or NULL. assign value to this name if non-NULL
##' @param useGUI use the GUI
##' @param useConsole use the console
##' @param prompt what prompt to use
##' @param width width in pixels
##' @param height height in pixels
##' @param container parent container
##' @param ... passed to containers \code{add} method
##' @param toolkit toolkit
##' @return an object of class \code{gCommandline} with methods:
##'
##' \enumerate{
##'
##' \item{svalue<-} Character. An expression to evaluate. If it has a names attribute this is used for assignment
##'
##' \item{[} Lists history
##'
##' }
gcommandline =function(
  command = "", assignto = NULL, useGUI = TRUE, useConsole = FALSE,
  prompt = getOption("prompt"), width = 500, height = 0.6 * width,
  container = NULL, ... ,
  toolkit=guiToolkit()){
  widget =  .gcommandline (toolkit,
    command=command, assignto=assignto,
    useGUI = useGUI, useConsole=useConsole,
    prompt=prompt, width=width, height=height, container=container, ...
    )
  obj = new( 'guiComponent',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gcommandline
setGeneric( '.gcommandline' ,
           function(toolkit,
                    command = "", assignto = NULL,
                    useGUI = TRUE, useConsole = FALSE,
                    prompt = getOption("prompt"), width = 500,
                    height = 0.6 * width, container = NULL, ... )
           standardGeneric( '.gcommandline' ))


##' gcommandline implementation for any toolkit
setClass("gCommandlineANY",
         representation=representation("gComponentANY",
           commandBox="guiWidgetOrNULL",
           outputBox="guiWidgetOrNULL",
           histList="guiWidgetOrNULL",
           useGUI = "logical",
           useConsole = "logical"
           ),
         contains="gComponentANY",
         prototype=prototype(new("gComponentANY"))
         )


##' gcommandline constructor for ANY toolkit
##' @alias gcommandline
setMethod(".gcommandline",
          signature(toolkit="ANY"),
          function(toolkit,
                   command = "", assignto=NULL,
                   useGUI = TRUE, 
                   useConsole = FALSE,
                   prompt = getOption("prompt"),
                   width = 500, height = 0.6 * width,
                   container = NULL,
                   ...) { 

            force(toolkit)

            .history = character()

            
            ## adjust command if need be
            if(nchar(command) > 0 && !is.null(assignto))
              command = addAssignto(command, assignto)


            if(is(container,"logical") && container)
              container = gwindow("gCommandLIne")
          ##
            if(useGUI == TRUE) {
              
              pg <- gpanedgroup(container=container, horizontal=FALSE, expand=TRUE)
              g <- ggroup(horizontal=FALSE, expand=FALSE, container=pg)
              bg <- ggroup(container=g, horizontal=TRUE)
              addSpring(bg)
              history <- gcheckbox("history", use.togglebutton=TRUE, container=bg)
              clear <- gbutton("clear", container=bg)
              evalCmd <- gbutton("evaluate", container=bg)
              
              commandBox <- gtext("## Type commands here:\n", container=g, expand=TRUE)
              size(commandBox) <- c(width, floor(height/3))
              
              outputBox <- gtext("", container=pg, expand=TRUE, fill="both")
              svalue(pg) <- 0.33
              
              ## History
              histWindow <- gwindow("History", parent=container, visible=FALSE)
              addHandlerUnrealize(histWindow, handler=function(h,...) {
                showHistory(FALSE)
                FALSE                                 # don't close just hide
              })
              histg <- ggroup(horizontal=FALSE, container=histWindow)
              glabel("History of recent commands", container=histg)
              histList <- gtable(data.frame(commands=character(0), stringsAsFactors=FALSE), container=histg, expand=TRUE)
              histbg <- ggroup(container=histg)
              addSpring(histbg)
              gbutton("cancel", container=histbg, handler=function(h,...) {
                svalue(history) <- FALSE
                visible(histWindow) <- FALSE # for tcltk
                focus(commandBox) <- TRUE
              })
              
              showHistory <- function(bool) {
                visible(histWindow) <- bool
              }
              
              addHandlerDoubleclick(histList, handler=function(h, ...) {
                svalue(commandBox) <- svalue(h$obj)
                focus(commandBox) <- TRUE
              })
              
              
              ## handlers
              addHandlerChanged(history, handler=function(h, ...) {
                showHistory(svalue(h$obj))
              })
              
              
              ## clear
              addHandlerChanged(clear, handler=function(h,...) {
                svalue(commandBox) <- ""
                focus(commandBox) <- TRUE
              })
              
              ## evaluate
              evaluateCommand <- function(...) {
                cmd <- svalue(commandBox)
                ## update history list
                tmp <- histList[,, drop=TRUE]
                tmp <- c(cmd, tmp)
                histList[] <- data.frame(commands=tmp, stringsAsFactors=FALSE)
                ## evaluate command, update outputbox
                out <- evalChunkReturnOutput(cmd)
                if(!out$error) {
                  insert(outputBox, out$output)
                } else {
                  ## an errow, now what
                  insert(outputBox, out$output, font.attr=c(color="red"))
                }
                ## clearm move focus to commandBox
                dispose(commandBox) 
                focus(commandBox) <- TRUE
              }
              
              addHandlerChanged(evalCmd, handler=evaluateCommand)
              
              
              
              
              obj = new("gCommandlineANY",
                block=pg,
                widget = pg,
                toolkit=toolkit,
                ID=getNewID(),
                commandBox=commandBox,
                outputBox=outputBox,
                histList=histList,
                useGUI = useGUI,
                useConsole = useConsole
                )
              
          ## initialize history
          tag(obj,"history")  <- c()
        } else {
          
          obj = new("gCommandlineANY",
            block=container,
                widget = container,
                toolkit=toolkit,
                ID=getNewID(),
                commandBox = container,
                outputBox = container,
                useGUI = useGUI,
                useConsole = useConsole
                )
            }

            if(nchar(command) > 0 )
              svalue(obj) <- command
            
            return(obj)
              
          })
          


##' return all previous, or just the index most recent
setMethod(".svalue",
          signature(toolkit="ANY",obj="gCommandlineANY"),
          function(obj, toolkit, index=NULL, drop=NULL, ...) {
            theArgs = list(...);

            histList <- obj@histList
            commandHistory <- histList[,1,drop=TRUE]
            
            if(length(commandHistory) == 0)
              return(c())
            if(is.null(index)) {
              return(commandHistory)
            } else {
              n = length(commandHistory)
              m = max(1, n - index + 1)
              return(rev(commandHistory[m:n]))
            }
          })

## evaluate command, store in history, swqp out widgets
setReplaceMethod(".svalue",
                 signature(toolkit="ANY",obj="gCommandlineANY"),
                 function(obj, toolkit, index=NULL, ..., value) {
                   ## get commane
                   command = value;
                   assignto = names(value)
                   if(!is.null(assignto)) {
                     command = addAssignto(command, assignto)
                   }
                   if(obj@useGUI)
                     svalue(obj@commandBox,font.attr = "monospace") <-  command 

                   ## add to history
                   tag(obj, "history", replace=FALSE) <- command

                   retVal = evalChunkReturnOutput(command)

                   if(obj@useGUI)
                     add(obj@outputBox, retVal$output)

                   if(obj@useConsole) {
                     cat(retVal$output)
                   }
                   
                   return(obj)
                 })

## history function
setMethod("[",
          signature(x="gCommandlineANY"),
          function(x, i, j, ..., drop=TRUE) {
            .leftBracket(x, x@toolkit, i, j, ..., drop=drop)
          })

setMethod(".leftBracket",
          signature(toolkit="ANY",x="gCommandlineANY"),
          function(x, toolkit, i, j, ..., drop=TRUE) {
            
            histList <- x@histList
            commandHistory <- histList[,1,drop=TRUE]

            if(missing(i))
              return(commandHistory)
            else
              commandHistory(i)
          })



##################################################
## Helpers
## taken from Sweave
## takes a chunk, interweaves command and output
evalChunkReturnOutput = function(chunk, prompt = getOption("prompt")) {

  output = ""
  addToOutput = function(...) 
    output <<- paste(output,..., sep=" ", collapse="\n")
  
  chunkexps <- try(parse(text=chunk), silent=TRUE)
  if(inherits(chunkexps,"try-error")) {
   addToOutput(chunkexps)
   cat("Houston, we have a problem with:\n",chunkexps,"\n")
   return(list(output=output, error=TRUE))
 }

  if(length(chunkexps) == 0)
    return(list(output=output, error=FALSE))

  for(nce in 1:length(chunkexps)) {
    ce <- chunkexps[[nce]]
    dce <- deparse(ce, width.cutoff=0.75*getOption("width"))
    command = paste(prompt,
      paste(dce,collapse=paste("\n", getOption("continue"), sep="")),
      sep="", collapse=""
      )

    addToOutput(command,"\n")

    ## is there output?
    tmpcon <- file()
    sink(file=tmpcon)
    err <- RweaveEvalWithOpt(ce, list(eval=TRUE,print=FALSE,term=TRUE,visible=FALSE))
    cat("\n") # make sure final line is complete
    sink()
    theOutput <- readLines(tmpcon)
    close(tmpcon)
    ## delete empty output
    if(length(theOutput)==1 & theOutput[1]=="") theOutput <- NULL
    
    if(inherits(err, "try-error")) {
      addToOutput(err,"\n")
    } else {
      if(!is.null(theOutput)) {
        addToOutput(paste(theOutput,sep="",collapse="\n"))
      }
    }
  }

  return(list(output = output, error=FALSE))
}


### working functions


## parse command(s) and make assingment on last one.
addAssignto = function(command,assignto) {
  assignto = make.names(assignto)
  tmp = unlist(strsplit(command, ";"))
  if(length(tmp)>1) {
    command = paste(tmp[-length(tmp)], Paste(assignto,"<-",tmp[length(tmp)]), collapse=";", sep=";")
  } else {
    command =  Paste(assignto,"<-", command)
  }
  return(command)
}

## interface to variables  used by ggenericwidget
##TODO:

## * responsevar-- droplist (update with data), with dnd, close subset dialog, formula editor dialog
## * formulavar -- droplist updated with data, with dnd, also has button for foumulat editor
## * datavar -- droplist updated with dnd, when updated chnages droplist in responsevar and formulavar
## * subsetvar -- updated with dnd, has subsetEditor
## * formulaEditor -- how to do? Must have following
##   adding binary terms: +, * ....
##   grouping via ()
##   wrapping terms: I(), tsvar(), ...
##   how to integrate lm, glm, sspir usages, nlm?


##################################################
## some specific widgets for handling variables

## call this instead of the others
## gvarariables(

gvariables = function(variableType=NULL,..., toolkit=guiToolkit()) {
  if(variableType %in% c("univariate","univariatetable","bivariate","model","lattice")) {
    tmp = switch(variableType,
      "univariate" = gunivariate(...,toolkit=toolkit),
      "univariatetable" = gunivariatetable(...,toolkit=toolkit),
      "fileurl" = gfileurl(...,toolkit=toolkit),
      "bivariate" = gbivariate(...,toolkit=toolkit),
      "model" = gmodel(...,toolkit=toolkit),
      "lattice" = glattice(...,toolkit=toolkit),
      "lmer" = glmer(...,toolkit=toolkit)
      )
    return(tmp)
  } else {
    ## can't do anything here yet
    ## expects something so we give back a box
    return(ggroup(...,toolkit=toolkit))
  }
}



## For these we return a string ready to go.

## take an idwidget, wrap an argument around it, return as a container
## with value method giving "arg=val"

setClass("gAddargANY",
         representation(argument="character"),
         contains="gComponentANY"
         )

addArg = function(argument,widget,container = NULL, toolkit=guiToolkit()) {
  
  
  delete(container,widget)                 # a hack, take away parent to reparent
  label = glabel(text=Paste(argument,"= "), container=container)
  add(container,widget)

  obj = new("gAddargANY",block=container, widget=widget,
    toolkit=toolkit,
    argument=argument)
  return(obj)
}



setMethod(".svalue",
          signature(toolkit="ANY",obj="gAddargANY"),
          function(obj, toolkit, index=NULL, drop=NULL,  ...) {
            val = svalue(obj@widget)
            arg = obj@argument


            val = stripWhiteSpace(val)

            if(val == "") {
              return(NA)
            } else if(
                      is(obj@widget,"gEditListANY") ||
                      is(obj@widget,"gEditNamedListANY") ||
                      arg == "...") {
              return(val)
            } else {
              if(is.null(drop) || drop==FALSE)
                return(Paste(arg,"=",val))
              else
                return(val)
            }
          })

setReplaceMethod(".svalue",
                 signature(toolkit="ANY",obj="gAddargANY"),
                 function(obj, toolkit, index=NULL, ..., value) {
                   svalue(obj@widget) <- value
                   return(obj)
                 })

## the most basic drop handler 
basicdrophandler = function(h,...) svalue(h$obj) <- h$dropdata
##################################################
### UNIVARIATE
## returns gedit vaRlue
setClass("gUnivariateANY",
         representation(widgets="list"),
         contains="gComponentANY"
         )

gunivariate = function(xlabel="x",container=NULL, ..., toolkit=guiToolkit()) {
  frame = gframe(text = "data", horizontal=TRUE, container=container, expand=TRUE)
  font(frame) <- c(weight="bold", size="small")
  
  xentry = gedit(text="",width=30, container=frame) # was NULL
  xarg = addArg(argument=xlabel, xentry, container=frame)

  obj = new("gUnivariateANY",block=frame, widget=frame,
    toolkit=toolkit, 
    widgets=list(xarg))
  return(obj)
}

setMethod(".svalue",
          signature(toolkit="ANY",obj="gUnivariateANY"),
          function(obj, toolkit, index=NULL, drop=NULL,  ...) {
            svalue(obj@widgets[[1]])
          })

##################################################
#######################################################################
## returns gedit value, perhaps in table()
setClass("gUnivariateTableANY",
         representation(widgets="list"),
         contains="gComponentANY"
         )

gunivariatetable = function(xlabel="x",container=NULL, ..., toolkit=guiToolkit()) {

  frame = gframe(text = "data", horizontal=TRUE, container=container,
    expand=TRUE)
  font(frame) <- c(weight="bold")
  
  xentry = gedit(text="",width=30, container=frame)
  xarg = addArg(argument=xlabel, xentry, container=frame)
  glabel("Tabulate data?",container=frame)
  doTable=gcombobox(c(TRUE,FALSE),container=frame)
  obj = new("gUnivariateTableANY",block=frame, widget=frame, toolkit=toolkit, widgets=list(x=xarg, doTable=doTable))
  return(obj)
}

setMethod(".svalue",
          signature(toolkit="ANY",obj="gUnivariateTableANY"),
          function(obj, toolkit, index=NULL, drop=NULL,  ...) {
            vals = svalue(obj@widgets[[1]], drop=TRUE)
            doTable = as.logical(svalue(obj@widgets[[2]]))
            if(doTable)
              vals = paste("table(",vals,")", sep="", collapse="")
            return(vals)
          })


#################################################
#################################################
## a File browser with a switch for wrapping in url
## returns gedit value, perhaps in table()
setClass("gFileURLANY",
         representation(widgets="list"),
         contains="gComponentANY"
         )

gfileurl = function(xlabel="file",container=NULL, ..., toolkit=guiToolkit()) {

  frame = gframe(text = "file", horizontal=TRUE, container=container,
    expand=TRUE)
  font(frame) <- c(weight="bold")
  
  xentry = gfilebrowse(text="",width=40, container=frame)
  xarg = addArg(argument=xlabel, xentry, container=frame)
  glabel("A url?",container=frame)
  doURL=gcombobox(c(FALSE,TRUE),container=frame)
  obj = new("gFileURLANY",block=frame, widget=frame, toolkit=toolkit, widgets=list(x=xarg, doURL=doURL))
  return(obj)
}

setMethod(".svalue",
          signature(toolkit="ANY",obj="gFileURLANY"),
          function(obj, toolkit, index=NULL, drop=NULL,  ...) {
            vals = svalue(obj@widgets[[1]])
            doURL = as.logical(svalue(obj@widgets[[2]])) # TRUE of FALSE
            if(doURL)
              vals = paste("url(",quoteIfNeeded(vals),")", sep="", collapse="")
            return(vals)
          })

##################################################
## bivariate
setClass("gBivariateANY",
         representation(widgets="list"),
         contains="gComponentANY"
         )

gbivariate = function(xlabel = "x", ylabel = "y", container=NULL, ...,
  toolkit=guiToolkit()) {
  
  frame = gframe(text = "data", horizontal=TRUE, container=container,
    expand=TRUE)
  font(frame) <- c(weight="bold")

  xentry = gedit(text="",width=30, container=frame)
  ##  adddroptarget(xentry, handler = basicdrophandler)
  xarg = addArg(argument=xlabel, xentry, container=frame)
  
  yentry = gedit(text="",width=30, container=frame)
  ##  adddroptarget(yentry, handler = basicdrophandler)
  yarg = addArg(argument=ylabel, yentry, container=frame)
  
  obj = new("gBivariateANY",block=frame, widget=frame,
    toolkit=toolkit,  widgets=list(xarg,yarg))
  return(obj)
}

setMethod(".svalue",
          signature(toolkit="ANY",obj="gBivariateANY"),
          function(obj, toolkit, index=NULL, drop=NULL, ...) {
            return(PasteWithComma(
                                  svalue(obj@widgets[[1]]), # xvalue
                                  svalue(obj@widgets[[2]])  # yvalue
                                  )
                   )
          })

setReplaceMethod(".svalue",
                 signature(toolkit="ANY",obj="gBivariateANY"),
                 function(obj, toolkit, index=NULL, ..., value) {
                   value = rep(value,2)[1:2]
                   lapply(1:2, function(i) svalue(obj@widgets[[i]]) <- value[i])
                   return(obj)
                 })


##################################################
## model formula -- this has drag and drop stuff, and formula editing
setClass("gModelANY",
         representation(widgets="list"),
         contains="gComponentANY",
         )

gmodel = function(lattice=FALSE, container=NULL,...,toolkit=guiToolkit()) {
  ## containers
  frame = gframe(text = "data",  horizontal=FALSE, container=container,
    expand=TRUE, anchor=c(-1,1))
  font(frame) <- c(weight="bold", size="small")

  
  ## we have 4 main things: response, predictor(s), data, subset
  
  editPredictorHandler = function(h,...) {
    editFormulaDialog(data=h$action$dataEntry,
                      responsewidget=h$action$responseEntry,
                      predictorwidget=h$action$predictorEntry)
  }
  
  dataDropHandler = function(h,...) {
     val.str = h$dropdata
     ## in gWidgetsRGtk2 dnd is a little messy
#JV     if(getOption("guiToolkit") != "RGtk2")
       svalue(h$obj) <- val.str ## gets on enter handler?
     names = try(getNamesofObject(val.str))
     if(!inherits(names,"try-error") &&
        !is.null(names)) {
       ## set dropdown values:
       responseEntry[] <- names
       predictorEntry[] <- names
       if(lattice)
         conditionEntry[] <- names
       ## what else?
     }
   }
    
  dataEnterHandler = function(h,...) {
     val.str = svalue(h$obj)
     names = getNamesofObject(val.str)
     if(!is.null(names)) {
       ## set dropdown values:
       responseEntry[] <- names
       predictorEntry[] <- names
       if(lattice)
         conditionEntry[] <- names
       ## what else?
     }
   }

  ## subsetDropHandler = basicdrophandler
  editSubsetHandler = function(h,...) {
    editSubsetDialog(data=h$action$dataEntry,
                     widget=h$action$subsetEntry)
  }
  editConditionHandler = function(h,...) {
    editConditionDialog(data=h$action$dataEntry,
                        widget = h$action$conditionEntry)
  }
  
  ## Build up the widgets now
  variableNames = c("",getNamesofObject())
  
  
  tbl = glayout(container=frame, anchor=c(-1,1), width=500,height=100)
  tbl[1,1] <- (responseEntry = gcombobox(variableNames,width=40,editable=TRUE, container =tbl))
  tbl[2,1] <- "response"
  size(responseEntry) <- c(200, -1)
  
  ## add ~
  tbl[1,2] <- " ~ "

  tbl[1,3] <- (predictorEntry = gcombobox(variableNames,width=50, editable=TRUE, container =tbl))
  tbl[2,3] <- "predictor(s)"
  size(predictorEntry) <- c(200, -1)
  
  tbl[1,4] <- (predictorEdit = gbutton("edit",container=tbl))
  
  
  
  
  ## lattice has a conditioning variable
  ## define this even if not needed
  conditionEntry = NULL
  if(lattice) {
      tbl[3,2] <- " | "
      tbl[3,3] <- (conditionEntry = gcombobox(variableNames, editable=TRUE,
                       container=tbl))
      tbl[4,3] <- "conditioning variable(s)"
    
    
    tbl[3,4] <- (conditionEdit = gbutton("edit",container=tbl))
  }
  visible(tbl) <- TRUE



               
  ## visual separation
  gseparator(container=frame)
  
  ## Now for data frame
  tbl = glayout(container=frame, anchor = c(-1,1), width=500,height=100)
  tbl[1,1, anchor=c(1,0)] = "data="
  tbl[1,2, anchor=c(-1,0)] = (dataEntry <-  gedit("", container=tbl))

  addhandlerchanged(dataEntry, handler = dataEnterHandler)
  adddroptarget(dataEntry, handler = dataDropHandler)
  
  ## subset has extra button for editing
  tbl[2,1, anchor=c(1,0)] = "subset="
  tbl[2,2, anchor=c(-1,0)] = (subsetEntry <- gedit("", container =tbl))
  
  tbl[2,3] = (subsetEdit <- gbutton("edit",container=tbl)
              )
  visible(tbl) <- TRUE                # for RGtk2
  
  ## add handlers --after dataEntry is defined
  addHandlerChanged(predictorEdit,
                    handler=editPredictorHandler,
                    action=list(dataEntry=dataEntry,
                      responseEntry=responseEntry,
                      predictorEntry=predictorEntry))
  

  addHandlerChanged(subsetEdit,
                    handler=editSubsetHandler,
                    action=list(
                      dataEntry=dataEntry,
                      subsetEntry=subsetEntry
                      )
                    )
  
  if(lattice) {
    addHandlerChanged(conditionEdit,
                      handler = editConditionHandler,
                      action = list(dataEntry=dataEntry,
                        conditionEntry =conditionEntry))
  }
  
  obj = new("gModelANY",block=frame,widget=frame,
    toolkit=toolkit,
    widgets =
    list(response  = responseEntry,
         predictor = predictorEntry,
         data      = dataEntry,
         subset    = subsetEntry,
         lattice   = conditionEntry
         )
    )
  return(obj)
}

setMethod(".svalue",
          signature(toolkit="ANY",obj="gModelANY"),
          function(obj, toolkit,index=NULL, drop=NULL, ...) {
            lst = lapply(obj@widgets, function(i) {
              if(!is.null(i)) svalue(i)
            })
            names(lst) = c("response","predictor","data","subset","lattice")[1:length(lst)]
            ## return a string of type r ~ p, data=..., subset=...
            str = with(lst, Paste(response," ~ ",predictor))
            if(!is.null(lst$lattice) && lst$lattice != "")
              str = Paste(str, " | ", lst$lattice)
            if(lst$data != "") str = PasteWithComma(str,Paste("data=",lst$data))
            if(lst$subset != "") str = PasteWithComma(str,Paste("subset=",lst$subset))
            
            return(str)
          })

setReplaceMethod(".svalue",
                 signature(toolkit="ANY",obj="gModelANY"),
                 function(obj, toolkit, index=NULL, ..., value) {
                   if(is.list(value)) unlist(value)
                   lapply(1:4, function(i) svalue(obj@widjets[[i]]) <- value[i])
                   return(obj)
                 })


##################################################
## interface for lattice graphics
glattice = function(..., toolkit=guiToolkit()) return(gmodel(lattice = TRUE, ...,toolkit=toolkit))

##################################################
setClass("gLmerANY",
         representation(formulaEntry="guiWidget",
                        dataEntry="guiWidget"),
         contains="gComponentANY")


## interface for linear mixed effects models models
glmer = function(container=NULL, ..., toolkit=guiToolkit()) {
  
  frame = gframe(text = "data",  horizontal=FALSE, container=container)
  font(frame) <- c(weight="bold")
  
  tbl = glayout(container=frame)
  tbl[1,1] = "formula"
  tbl[1,2] = (formulaEntry <- gedit("", width=40, container =tbl))
  tbl[2,1] = "data="
  tbl[2,2] = (dataEntry <- gedit("", container =tbl))
  visible(tbl) <- TRUE
  
  obj = new("gLmerANY",block=frame,widget=frame,toolkit=toolkit,
    dataEntry = dataEntry, formulaEntry = formulaEntry)

  return(obj)
}

setMethod(".svalue",
          signature(toolkit="ANY",obj="gLmerANY"),
          function(obj, toolkit, index=NULL, drop=NULL, ...) {
            formulaValue = svalue(obj@formulaEntry)
            dataValue = svalue(obj@dataEntry)
            
            if (formulaValue == "")
              return("")
            string = formulaValue
            if(dataValue != "")
              string = Paste(string, ", data=",dataValue)
            
            return(string)
          })





## some special edit fields
## this is used to get "..." into generic widget
setClass("gEditListANY",
         contains="gComponentANY")

geditlist = function(...,toolkit=guiToolkit()) {

  edit = gedit(...,toolkit=toolkit)
  obj = new("gEditListANY", block=edit@widget@block, widget=edit@widget@widget, toolkit=toolkit)
  invisible(obj)

}


setClass("gEditNamedListANY",
         contains="gComponentANY")

geditnamedlist = function(..., toolkit=guiToolkit()) {
  edit = gedit(...,toolkit=toolkit)
  obj = new("gEditNamedListANY",
    block=edit@widget@block, widget=edit@widget@widget, toolkit=toolkit)
  invisible(obj)
}


##################################################
##
## two dialogs for editing


## sample edit Formula dialog, Smilar to one in Splus, but layout is
## not as nice, not quite as feature rich

editFormulaDialog = function(
  data=NULL,                            # within these variables
  responsewidget = NULL,                # response value
  predictorwidget = NULL                # predictor value
  ) {
  ## actually get data, not just a string
  if(is(data,"guiWidget") || is(data,"gComponentANY")) {
    data = svalue(data)
    dataName = deparse(substitute(data))
  }
  if(is.character(data) && length(data) == 1) {
    dataName = data 
    data = getObjectFromString(data)
  }

  if(is.na(data) || is.null(data)) {
    warning("Can't find data set")
    return(NA)
  }

  ## coerce data if possible
  if(!is.data.frame(data)) {
    tmp = try(as.data.frame(data), silent=TRUE)
    if(inherits(tmp,"try-error")) {
      warning("gtable shows data frames of vectors")
      return(NA)
    }
    data = tmp
  }
  varNames = names(data)

  ## define key widgets
  
  
  ## Set up the window
  ## main window
  win = gwindow("Edit model formula values")
  
  group = ggroup(horizontal=FALSE, container=win)
  
  datagroup = ggroup(container=group)
  size(datagroup) <- c(300,200)
  glabel("Dataset: ", container=datagroup)
  tmp = glabel(dataName, container=datagroup);
  font(tmp) <- c(weight="bold")
  addSpace(datagroup, 10)

  variables = gtable(varNames,multiple=TRUE, container =datagroup, expand=TRUE)

  gseparator(container =group)
  ## buttons

  
  buttonGroup = ggroup(container=group)
  glabel("Actions:", container=buttonGroup)
  tbl = glayout(container =buttonGroup, expand=TRUE)
  tbl[1,1,anchor=c(-1,0)] = (addresponse <- gbutton("Response",container =tbl))
  tbl[1,2,anchor=c(-1,0)] = (addterm <-  gbutton("+ (main effect)",container =tbl))
  tbl[2,1,anchor=c(-1,0)] = (addwithin <- gbutton(": (interaction)",container =tbl))
  tbl[2,2,anchor=c(-1,0)] = (addinteraction <- gbutton("* (main + interaction)",container =tbl))
  tbl[3,1,anchor=c(-1,0)] = (addsecondpowers <- gbutton("^2 (second-order)",container =tbl))
  tbl[3,2,anchor=c(-1,0)] = (subtractintercept <-  gbutton("remove intercept",container =tbl))
  visible(tbl) <- TRUE

  gseparator(container =group)
  tbl = glayout(container=group)

  response = gedit(svalue(responsewidget),container =tbl)
  predictor = gedit(svalue(predictorwidget), container =tbl)

  tbl[1,1] <- response
  tbl[1,2] <- glabel(" ~ ",container =tbl)
  tbl[1,3:6] <- predictor
  tbl[2,1] <- "response"
  tbl[2,3:6] <- "predictor formula"
  visible(tbl) <- TRUE


  

  buttonbox = ggroup(container=group)
  addSpring(buttonbox)
  okbutton = gbutton("ok", container =buttonbox)
  addSpace(buttonbox,15)  
  clearbutton = gbutton("clear", container =buttonbox)
  cancelbutton = gbutton("cancel", container =buttonbox)

  ## Now add handlers
  addhandlerclicked(addresponse, handler=function(h,...) {
    vals = svalue(variables)
    if(!is.null(vals)) {
      svalue(response) <- vals[1]
    }
  })
  addhandlerclicked(addinteraction,handler=function(h,...) {
    vars = svalue(variables)
    if(!is.null(vars)) {
      oldval = svalue(predictor)
      if(!is.null(oldval) && oldval !="")
        oldval = Paste(oldval, " + ")
      else
        oldval = ""
      svalue(predictor) <- Paste(oldval, paste(vars, sep="", collapse=" * "))
    }
  })
  addhandlerclicked(addterm,handler=function(h,...) {
    vars = svalue(variables)
    
    if(!is.null(vars)) {
      oldval = svalue(predictor)
      if(!is.null(oldval) && oldval !="")
        oldval = Paste(oldval, " + ")
      else
        oldval = ""
      svalue(predictor) <- Paste(oldval, paste(vars, sep="", collapse=" + "))
    }
  })
  addhandlerclicked(addsecondpowers,handler=function(h,...) {
    vars = svalue(variables)
    if(!is.null(vars)) {
      oldval = svalue(predictor)
      if(!is.null(oldval) && oldval !="")
        oldval = Paste(oldval, " + ")
      else
        oldval = ""
      svalue(predictor) <- Paste(oldval,
                                 " (",
                                 paste(vars, sep="", collapse=" + "),
                                 ")^2")
    }
  })
  addhandlerclicked(addwithin,handler=function(h,...) {
    vars = svalue(variables)
    if(!is.null(vars)) {
      oldval = svalue(predictor)
      if(!is.null(oldval) && oldval !="")
        oldval = Paste(oldval, " + ")
      else
        oldval = ""
      svalue(predictor) <- Paste(oldval,
                                 paste(vars, sep="", collapse=":")
                                 )
    }

  })
  addhandlerclicked(subtractintercept,handler=function(h,...) {
    svalue(predictor) <- Paste(svalue(predictor), " -1")
  })
  addhandlerclicked(okbutton, handler = function(h,...) {
    svalue(responsewidget) <- svalue(response)
    svalue(predictorwidget) <- svalue(predictor)
    dispose(win)
  })
  addhandlerclicked(clearbutton, handler=function(h,...) {
    svalue(response) <- ""
    svalue(predictor) <- ""
  })
  addhandlerclicked(cancelbutton,handler=function(h,...) {
    dispose(win)
  })
}

editSubsetDialog = function(
  data=NULL,
  widget = NULL                         # what to write to, start with
  ) {
  
  ## get data values
  if(is(data,"guiComponent") || is(data,"gComponentANY")) {
    data = svalue(data)
  }

  
  if(is.character(data)) {
    if(data == "") {
      warning("A data set needs to be set")
      return()
    }
    dataName = data
    data = svalue(data)
  } else {
    dataName = deparse(substitute(data))
  }

  if(!is.data.frame(data)) {
    tmp = try(as.data.frame(data), silent=TRUE)
    if(inherits(tmp,"try-error")) {
      warning("gtable shows data frames of vectors")
      return(NA)
    }
    data = tmp
  }
  varNames = names(data)
  
  
  ## main widgets
  
                                        #  preview = gtable(head(data))
  
  
  ## layout
  
  win = gwindow("Edit subset value")                    # main window
  group = ggroup(horizontal=FALSE, container=win)
  glabel(Paste("Data set:", dataName,""), container=group)

  tbl = glayout(container=group)
  tbl[1,1] <- (andOrPopup = gcombobox(c("","&","|"), container =tbl))
  tbl[1,2] <- (notPopup  = gcombobox(c("","!"), container =tbl))
  tbl[1,3] <- (var1 = gcombobox(varNames, editable=TRUE, container =tbl))
  tbl[1,4] <- (logicalPopup = gcombobox(c("","<","<=","==","!=",">=",">","%in%"), container =tbl))
  tbl[1,5] <- (var2 = gcombobox(varNames, editable = TRUE, container =tbl))

  tbl[2,1] <- "join with"
  tbl[2,2] <- "negate"
  tbl[2,3] <- ""
  tbl[2,4] <- "compare with"
  tbl[2,5] <- ""
  visible(tbl) <- TRUE
  
  buttonGroup = ggroup(container=group)
  addSpring(buttonGroup)

  addButton = gbutton("add", container =buttonGroup)
  addSpace(buttonGroup,10)
  clearButton =   gbutton("clear",container =buttonGroup)

  outputGroup = ggroup(container=group)
  glabel("Subset by",container=outputGroup)
  output = glabel("", container =group)
  font(output) <- c(weight="bold")  # make bold
  status = glabel("",container =group)
  
  gseparator(container=group)
  spacingGroup = ggroup(container=group)
  glabel("Preview:", container=spacingGroup)
  addSpring(spacingGroup)

  preview = gtable(data, container =group, expand=TRUE)
  enabled(preview) <- FALSE
  
  buttonGroup = ggroup(container=group)
  addSpring(buttonGroup)
  okButton = gbutton("ok", container =buttonGroup)
  addSpace(buttonGroup,10)
  cancelButton = gbutton("cancel", container =buttonGroup)

  ## now give some actions
  addHandlerAction = function(h,...) {
    str = Paste(
      svalue(var1),
      svalue(logicalPopup),
      svalue(var2)
      )
    if(!is.null(svalue(notPopup)) && length(svalue(notPopup)) > 0 && svalue(notPopup) == "!")
      str = Paste("!( ",str," )")
    ## error check
    tmp = try(rpel(Paste("subset(data,subset=",str,")"), envir=environment(NULL)))
    if(! inherits(tmp,"try-error")) {
      combine = svalue(andOrPopup)
      if(is.null(combine)) combine = ""
      previous = svalue(output)
      if(length(previous) == 0 || nchar(previous) == 0) {
        combine=""; previous=""
      }
      if(nchar(previous) > 0 && combine == "") {
        svalue(status) <-"You need an operator to combine terms"
        return(FALSE)
      }
        
      svalue(output) <- Paste(previous," ",combine," ",str)
      svalue(status) <- ""
      ## update preview
      subsetVal = svalue(output)

      tmpVals = rpel(Paste("head(subset(data,subset=",subsetVal,"))"),
        envir=environment(NULL))
      preview[,] = tmpVals
    } else {
      svalue(status) <- Paste(str," failed")
    }
  }

  ## when logical is %in$ and leftside if factor, we can do some  business
  addhandlerchanged(logicalPopup,handler = function(h,...) {
    ## check that all conditions are met
    if(length(svalue(logicalPopup)) > 0 && svalue(logicalPopup) == "%in%") {
      varName = svalue(var1)
      var = getObjectFromString(Paste(dataName,"$",varName))
      if(is.factor(var)) {
        varLevels = levels(var)
        selectVectorEntriesDialog(varLevels, var2)
      }
    }
  }
                    )
  
  addhandlerclicked(clearButton, handler = function(h,...) {
    svalue(output) <- ""
    svalue(status) <- ""
    preview[] <- head(data)
  })
  
  addhandlerclicked(addButton, handler=addHandlerAction)
  addhandlerclicked(okButton, handler = function(h,...) {
    outputValue = svalue(output)
    ## strip leading spaces
    svalue(widget) <- sub("^ +","",outputValue)
    dispose(win)
  })
  addhandlerclicked(cancelButton, handler=function(h,...) {
    dispose(win)
  })
}



## add terms 
editConditionDialog <- function(data,widget) {
    data <- svalue(data)
  if(is.na(data) || is.null(data)) {
    warning("empty dataset")
    return()
  } else if(data == "") {
    varNames = ls(envir=.GlobalEnv)
  } else {
    ## get data values
    if(is(data,"gComponentANY")) {
      data = svalue(data)
    }
    if(is.character(data)) {
      dataName = data
      data = rpel(Paste("get(\"",data,"\")", sep=" "))
    } else {
      dataName = deparse(substitute(data))
    }
    
    if(!is.data.frame(data)) {
      tmp = try(as.data.frame(data), silent=TRUE)
      if(inherits(tmp,"try-error")) {
        warning("gtable shows data frames of vectors")
        return(NA)
      }
      data = tmp
    }
    varNames = names(data)
  }

  win = gwindow("Select variables for conditioning variable",
    visible=TRUE)
  group = ggroup(horizontal=FALSE, container=win)

  vars = gtable(varNames, multiple=TRUE, handler=function(h,...) {
    values = svalue(h$obj)
    if(length(values) > 0) {
      out = paste(values, collapse=" + ")
      svalue(widget) <- out
    }
    dispose(win)
  },
    container =group, expand=TRUE)

  buttonGroup = ggroup(container=group)
  addSpring(buttonGroup)
  gbutton("ok",container=buttonGroup, action=vars,
          handler=function(h,...) {
            values = svalue(h$action)
            if(length(values) > 0) {
              out = paste(values, collapse=" + ")
              svalue(widget) <- out
            }
            dispose(win)
          })
  gbutton("close",container=buttonGroup, handler = function(h,...) dispose(win))
  status = gstatusbar("Select one or more variables to condition by.",
    container=group)

}

## select asks user for which columns to consider
editSelectDialog = function(data,widget) {
  
    ## get data values
  if(is(data,"gComponentANY")) {
    data = svalue(data)
    if(data == "") {
      warning("A data set needs to be set")
      return()
    }
  }
  if(is.character(data)) {
    if(data == "") {
      warning("A data set needs to be set")
      return()
    }
    dataName = data
    data = rpel(Paste("get(\"",data,"\")", sep=" "))
  } else {
    dataName = deparse(substitute(data))
  }

  if(!is.data.frame(data)) {
    tmp = try(as.data.frame(data), silent=TRUE)
    if(inherits(tmp,"try-error")) {
      warning("gtable shows data frames of vectors")
      return(NA)
    }
    data = tmp
  }
  varNames = names(data)

  win <- gwindow("Select variables", visible=TRUE)

  group <- ggroup(horizontal=FALSE,container=win)
  frame <- gframe("Select all the desired variables",
    container=group, expand=TRUE)
  font(frame) <- c(weight="bold")

  varList <- gtable(varNames, multiple=TRUE, container=frame, expand=TRUE)


  buttonGroup = ggroup(container=group)
  addSpring(buttonGroup)
  submitButton = gbutton("submit",container=buttonGroup,
    handler = function(h,...) {
    values = svalue(varList)
    ## wrap it up
    str = Paste("c(",paste(sapply(values,function(str) paste("'",str,"'",sep="")),sep=" ",collapse=", "),")")
    svalue(widget) <-  str
    ## lclose dialog
    dispose(win)
  })
}
  
  
  ## put values into a vector with paste
  selectVectorEntriesDialog <- function(vals, widget) {
    
    
    
    win=gwindow("Select values", visible=T)
    group = ggroup(horizontal = FALSE, container=win)
    varNamesList = gtable(vals, multiple = TRUE, group, expand=TRUE)

    buttonGroup = ggroup(container=group)
    addSpring(buttonGroup)
    okButton = gbutton("ok",container=buttonGroup)
    cancelButton = gbutton("cancel", container=buttonGroup)

    addhandlerclicked(cancelButton, handler = function(h,...) {
      dispose(win)
    })
    addhandlerclicked(okButton, handler = function(h,...) {
      varNames = svalue(varNamesList)
      varNamesAsString = Paste("c(\"",paste(varNames,sep="'",collapse="\",\""),"\")")
      svalue(widget) <- varNamesAsString
      ## tidy up
      dispose(win)
    })
  }

##  Some functions that seem to be useful. These are not exported,
## hence repeated in gWidgetsR****. This should likely be changed, but
## for now it isn't

gwCat <- function(...) {
  doCat <- getOption("gWidgetsDebug")
  if(!is.null(doCat)) message(...)
}

Paste = function(..., sep="", collapse="") {
  x = unlist(list(...))
  x = x[!is.na(x)]
  x = x[x != "NA"]
  paste(x, sep=sep, collapse=collapse)
}


PasteWithComma = function(...) {
  args = unlist(list(...))
  args = args[!is.na(args)]
  paste(args, sep="", collapse=", ")
}

quoteIfNeeded = function(str) {
  if(length(grep('^\\".*\\"$', str, perl=TRUE)) > 0 ||
     length(grep("^\\'.*\\'$", str, perl=TRUE)) > 0 )
    return(str)
  else
    return(paste('"',str,'"',sep="",collapse=""))
}

## ReadParseEvaL -- saves typing
rpel = function(string, envir=.GlobalEnv) {
  eval(parse(text=string), envir=envir)
}

## return type
str1 <- function(obj) {
  md <- mode(obj)
  lg <- length(obj)
  objdim <- dim(obj)
  if (length(objdim) == 0) 
    dim.field <- paste("length:", lg)
  else {
    dim.field <- "dim:"
    for (i in 1:length(objdim)) dim.field <- paste(dim.field, 
                                                   objdim[i])
    if (is.matrix(obj)) 
      md <- "matrix"
  }
  obj.class <- oldClass(obj)
  if (!is.null(obj.class)) {
    md <- obj.class[1]
    if (inherits(obj, "factor")) 
      dim.field <- paste("levels:", length(levels(obj)))
  }
  list( type = md, dim.field = dim.field)
}


## untaint a variable name so that $ can be used
untaintName = function(objName) {
  if (length(grep(" |\\+|\\-|\\*|\\/\\(|\\[|\\:",objName)) > 0) {
    objName=Paste("\"",objName,"\"")
  }
  return(objName)
}

## as name says
stripWhiteSpace = function(str) {
  sub('[[:space:]]+$', '', str) ## from ?gsub
  sub('^[[:space:]]+', '', str) ## from ?gsub
  return(str)
}

### We should make this configurable. Likely using options
### Use this for filtering
.datasets = c(
  "numeric","logical","factor","character",
  "data.frame","matrix","list",
  "table","xtabs",
  "nfnGroupedData","nffGroupedData","nmGroupedData"
  )
.models = c("lm","glm","lqs","aov","anova",
    "lme","lmList","gls",
  "ar","arma","arima0","fGARCH","fAPARCH"
    )
.ts = c("ts", "mts", "timeSeries", "its", "zoo")
.functions=c("function")
.plots = c("recordedplot")

knownTypes = list(
  "data sets and models"=c(.datasets, .models, .ts),
  "data sets"= c(.datasets,.ts),
  "model objects" = .models,
  "time series objects" = .ts,
  "functions"=.functions,
  "saved plots" = .plots,
  "all" = NULL
  )


## get does not work with name$component, this gets around that
## returns NULL if not available
getObjectFromString = function(STRING="", envir=.GlobalEnv) {
  tmp = try(get(STRING, envir), silent = TRUE)
  if(!inherits(tmp, "try-error")) return(tmp)
  
  tmp = try(rpel(STRING,envir), silent=TRUE)
  if(!inherits(tmp, "try-error"))  return(tmp)

  ## out of chances
  return(NULL)
}


## Find the name of the object by pasting toghther the pieces
## better to do name$name, but value may be a numeric
makeObjectName = function(root,value) {
  if(is.null(root)) return(untaintName(value))

  ## now decide between $ and [[]]
  if(value == make.names(value)) {
    return(Paste(root,"$",untaintName(value)))
  } else {
    return(Paste(root,"[['",value,"']]"))
  }
}



## a function to get objects and their types
## filter is a vector of classes
getObjectsWithType = function(root=NULL, filter = NULL, envir=.GlobalEnv) {

  if(is.null(root)) {
    objects = ls(envir=envir)
  } else {
    string = Paste("with(",root,",ls())")
    objects = try(rpel(string,envir=envir), silent=TRUE)
  }
  ## objects is character vector of components of root.
  badnames = grep("[[<-]|\\*",objects)
  if(length(badnames) > 0)
    objects = objects[-badnames]

  objectsWithRoot = sapply(objects,function(i) makeObjectName(root,i))

  
  type = sapply(objectsWithRoot, function(i) {
    string = Paste("str2(",i,")")
    rpel(string, envir=envir)
  })

  objects = data.frame(Name=objects,Type=type,stringsAsFactors=FALSE)

  ## filter
  if(!is.null(filter))
    objects = objects[type %in% filter,]

  return(objects)
  
  
}


## get the names of the object, if available (datastores)
getNamesofObject = function(string="") {
  ## if empty string, get variables in .GlobalEnv
  if(string == "") {
    ## return objects of certain type
    objects = getObjectsWithType(root=NULL, filter=knownTypes[['data sets']])
    return(unlist(objects$Name))
  } 
  obj = getObjectFromString(string)
  if(!is.null(obj)) {
    if(is.list(obj)) {
      return(names(obj))
    } else if(is.matrix(obj)) {
      return(colnames(obj))
    } else{
      return(NULL)
    }
  } else {
    return(NULL)
  }
}



## used to check output 
is.empty = function(obj) {
  
  if(is.null(obj) || is.na(obj) || (is.character(obj) && obj == "")) {
    return(TRUE)
  } else {
    return(FALSE)
  }
}


## fix font mess up DEPRECATED!!
.fixFontMessUp = function(val) {
  if(is.vector(val)) {
    tmp = val
    val = list()
    for(i in names(tmp)) val[[i]] = tmp[i]
  }

  weights = c("normal","oblique", "italic")
  styles = c("ultra-light","light","normal","bold","ultra-bold", "heavy")

  a = val$weight; b = val$style
  if((!is.null(a) && a %in% styles) || (!is.null(b) &&b %in% weights)) {
    tmp = a
    val$weight <- b
    val$style <- a
  }
  return(val)
}

## what type of object is thixs and a size
str2 <- function(obj) {
  md <- mode(obj)
  if (is.matrix(obj))  md <- "matrix"
  obj.class <- oldClass(obj)
  if (!is.null(obj.class)) {
    md <- obj.class[1]
  }
  return(md)
}

## blurb about installation -- put in so can be updated easily
## look to file to update
installing_gWidgets_toolkits <- function() {
  file <- system.file("install/Installing_gWidgets_Toolkits.txt", package="gWidgets")
  tmp <- readLines(file)
  for(i in tmp) cat(i,"\n")

}

##' return x unless null then give default
getWithDefault <- function(x, default)
  ifelse(is.null(x) || is.na(x) || x == "", default, x)


## ID is used by the ANY widgets
n=0;assignInNamespace("n",0,"gWidgets")
getNewID = function() {                 # get new one, incremented
  n = getFromNamespace("n",ns="gWidgets")
  assignInNamespace("n",n+1,ns="gWidgets")
  return(n+1)
}

##' @include guiComponent.R
##'
##'
##'
##' RangeSelector Class
setClass("guiComponentRangeSelector",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

## svalue, svalue<- [, [<-

##' spinbutton class
setClass("gSpinbutton",
         contains="guiComponentRangeSelector",
         prototype=prototype(new("guiComponentRangeSelector"))
         )

##' Spinbutton constructor
##'
##' @export
gspinbutton =function(
  from = 0, to = 10, by = 1,
  length.out = NULL, along.with=NULL,
  value = from, digits = 0,
  handler = NULL, action = NULL, container = NULL, ... ,
  toolkit=guiToolkit()){

  ## mostly from seq.default
  if (!missing(along.with)) {
    length.out <- length(along.with)
  } else if(!missing(length.out)) {
    len <- length(length.out)
    if (!len) 
      stop("argument 'length.out' must be of length 1")
    if (len > 1L) {
      warning("first element used of 'length.out' argument")
      length.out <- length.out[1L]
    }
    length.out <- ceiling(length.out)
  }
  if(!is.null(length.out)) {
    ## set up by to be for length,out
    by <- (to - from)/(length.out[1] - 1)
  }


  widget <- .gspinbutton (toolkit,
                          from=from, to=to, by=by, value=value, digits=digits,
                          handler=handler, action=action, container=container ,...
                          )
  obj <- new( 'gSpinbutton',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gspinbutton
setGeneric( '.gspinbutton' ,
           function(toolkit,
                    from = 0, to = 10, by = 1, value = from, digits = 0,
                    handler = NULL, action = NULL, container = NULL, ... ) standardGeneric( '.gspinbutton' ))

##' @include guiWidget.R
##'

##' A subclass of guiWidget to hold containers
setClass("guiContainer",
         contains="guiWidget",
         prototype=prototype(new("guiWidget"))
         )


## define a subclass
setClass("gContainerANY",
         contains="gWidgetANY",
         prototype=prototype(new("gWidgetANY"))
         )

################# methods #################################


################## add ################################

##' Generic for adding child widget to parent container
setGeneric("add",function(obj,value, ...) standardGeneric("add"))

##' method for adding child to a container
setMethod("add",signature(obj="guiContainer"),
          function(obj, value, ...) {
            toolkit = obj@toolkit
            ladd <- function(obj, value, ...,do.newline, font.attr, where)
              .add(obj@widget, obj@toolkit, value, ...)
            ladd(obj, value,...)
          })

## deprecated
##' 
## setMethod("add",signature(obj="guiWidget"),
##           function(obj, value, ...) {
##             toolkit = obj@toolkit
##             .add(obj@widget, toolkit,value,...)
##           })


## setMethod("add",signature(obj="guiComponent"),
##           function(obj, value, ...) {
##             toolkit = obj@toolkit
##             ladd <- function(obj,value, ..., label, name, override.closebuttons, index, pageno, markup, anchor, expand) .add(obj@widget,obj@toolkit,value,...)
##              ladd(obj,value,...)
##           })


##' dispatch with toolkit
##' @alias add
setGeneric(".add",function(obj, toolkit,value,...) standardGeneric(".add"))

##' Generic to delete child widget from parent
setGeneric("delete",function(obj,widget, ...) standardGeneric("delete"))
##' Delete method for containers
setMethod("delete",signature(obj="guiContainer"),
          function(obj, widget, ...) {
            toolkit = obj@toolkit
            .delete(obj@widget,toolkit,widget,...)
          })
##' dispatch with toolkit
##' @alias delete
setGeneric(".delete",function(obj, toolkit,widget,...) standardGeneric(".delete"))




## dispose
setGeneric("dispose",function(obj, ...) standardGeneric("dispose"))
## add generic for Containers and sometimes widgets
setMethod("dispose",signature(obj="guiWidget"),
          function(obj, ...) {
            toolkit = obj@toolkit
            .dispose(obj@widget, toolkit,...)
          })
## dispatch with toolkit
setGeneric(".dispose",function(obj,toolkit,...) standardGeneric(".dispose"))

##' @include ggroup.R

##' Class for framed box container with label
setClass("gFrame",
         contains="gGroup",
         prototype=prototype(new("gGroup"))
         )

##' Constructor for framed box container with label
##'
##' @export
gframe <- function(
                   text = "", markup = FALSE, pos = 0, horizontal=TRUE, container = NULL,
                   ... ,
                   toolkit=guiToolkit()){
  widget <- .gframe (toolkit,
                     text=text, markup=markup, pos=pos, horizontal=horizontal, container=container ,
                     ...
                     )
  obj <- new( 'gFrame',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gframe
setGeneric( '.gframe' ,
           function(toolkit,
                    text = "", markup = FALSE, pos = 0, horizontal=TRUE,
                    container = NULL,      ... )
           standardGeneric( '.gframe' ))

##' @include guiComponents.R

##' Class for a workspace or variable browser
setClass("gVarBrowser",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' Constructor for workspace variable browser
##'
##' @export
gvarbrowser <- function(
                        handler = NULL,
                        action = "summary",
                        container = NULL ,...,
                        toolkit=guiToolkit()){
  widget <- .gvarbrowser (toolkit,
                          handler=handler, action=action, container = container, ...
                          )
  obj <- new( 'gVarBrowser',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' generic for toolkit dispatch
##' @alias gvarbrowser
setGeneric( '.gvarbrowser' ,
           function(toolkit,
                    handler = NULL,
                    action = "summary", container = NULL,... )
           standardGeneric( '.gvarbrowser' ))

##' @include guiComponents.R

##' Checkbox class
setClass("gCheckbox",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' constructor for checkbox widget
##'
##' A checkbox widget has a checkbox or toggle button to indicate selection or not
##' @param text label text
##' @param checked is button selected
##' @param use.togglebutton Use a toggle button (shows depressed) not a check box
##' @param handler Callback called when toggle is changed.
##' @param action passed to handler
##' @param container parent container
##' @param ... passed to \code{add} method of container
##' @param toolkit toolkit
##' @example ~/pmg/r-forge/gwidgets/pkg/gWidgets/inst/tests/ex-gcheckbox.R
##' @export
##' @return Returns an object of class \code{gCheckbox} for which the
##' following methods are overridden:
##' %
##' \enumerate{
##' \item \code{svalue} gets state by boolean value
##' 
##' \item \code{svalue<-} sets state by boolean value
##' 
##' \item \code{[} Returns label
##' 
##' \item \code{[<-} sets label
##' }
gcheckbox =function(
  text, checked = FALSE, use.togglebutton=FALSE, handler = NULL, action = NULL, container = NULL, ... ,
  toolkit=guiToolkit()){

  ## ensure text is given
  if(missing(text))
    text <- ""
  text <- as.character(text)[1]
  ## checked is logical
  checked <- as.logical(checked)[1]
  
  widget =  .gcheckbox (toolkit,
    text=text, checked=checked,
    use.togglebutton=use.togglebutton,
    handler=handler, action=action, container=container, ...
    )
  obj = new( 'gCheckbox',widget=widget,toolkit=toolkit) 
  return(obj)
}


##' Generic for toolkit dispatch
##' @alias gcheckbox
setGeneric( '.gcheckbox' , function(toolkit,
                                    text, checked = FALSE, use.togglebutton=FALSE, handler = NULL, action = NULL,
                                    container = NULL, ... ) standardGeneric( '.gcheckbox' ))



##' svalue method
##'
##' Ensure value is logical
setReplaceMethod("svalue",signature(obj="gCheckbox"),
          function(obj, index=NULL,  ...,value) {
            value <- as.logical(value)[1]
            callNextMethod(obj, index, ..., value=value)
          })

            
##' ensure value is character of length 1
setReplaceMethod("[",signature(x="gCheckbox"),
          function(x,i,j,...,value) {
            value <- as.character(value)[1]
            callNextMethod(x, i, j, ..., value=value)
          })

##' @include guiComponents.R

##' Label class
setClass("gLabel",
         contains="guiComponent",
         prototype=prototype(new("guiComponent"))
         )

##' constructor for label widget
##'
##' @param text character. Text for label. Coerced to character and pasted together with newlines
##' @param markup logical. For some toolkits, one can specify marked up text.
##' @param editable logical. For some toolkits, label can be edited
##' when this is \code{TRUE}. Generally found to be an unexpected
##' interface for users, so use is discouraged.
##' @param handler function. For some toolkits, this handler will be
##' called when the label is clicked on. In general, labels are
##' expected to be static objects so this use is discouraged.
##' @param action passed to \code{handler}, when called
##' @param container parent container
##' @param ... generally ignored
##' @param toolkit underlying toolkit. Usually not specified
##' @return \code{gLabel} object to manipulate and creates widget on screen
##' @export
##' @examples
##' w <- gwindow()
##' g <- ggroup(container=w, horizontal=FALSE)
##' l1 <- glabel("Some label", container=g)
##' l2 <- glabel(c("pasted with", "new lines"), container=g)
##' svalue(l1) <- "New text for some label")
##' svalue(l1)
glabel = function(
  text= "", markup = FALSE, editable = FALSE, handler = NULL, 
    action = NULL, container = NULL, 
  ..., toolkit=guiToolkit()) {

  ## collapse if more than one line
  text <- paste(text, collapse="\n")
  
  widget = .glabel(toolkit,
    text= text, markup = markup, editable = editable, handler = handler, 
    action = action, container = container, 
    ...)
  obj = new("gLabel",widget=widget,toolkit=toolkit)
  return(obj)
}

##' glabel generic for toolkit
setGeneric(".glabel",function(toolkit,
                              text= "", markup = FALSE, editable = FALSE, handler = NULL, 
                              action = NULL, container = NULL, 
                              ...) standardGeneric(".glabel"))

##' svalue<- generic
##'
##' Ensure value is character vector. Pastes values together by collapsing with a new line.
##' @use_svalue_otherwise
setReplaceMethod("svalue",signature(obj="gLabel"),
                 function(obj, index=NULL,  ...,value) {
                   ## enforce that value is character
                   value <- paste(as.character(value), collapse="\n")
                   callNextMethod()
                 })

##' @include guiComponentWithItems.R

##' Radio button class
setClass("gRadio",
         contains="guiComponentWithItems",
         prototype=prototype(new("guiComponentWithItems"))
         )
##' Constructor for radio button widget
gradio = function(items,selected=1, horizontal=FALSE, handler=NULL,
  action=NULL, container=NULL, ...,
  toolkit=guiToolkit()) {

  ## check input
  if(length(x <- unique(items) ) != length(items))
    gwCat("Using unique items for selection values")
  
  radio = .gradio(toolkit, x, selected, horizontal, handler, action, container,...)
  obj = new("gRadio",widget=radio, toolkit=toolkit)
  return(obj)
}

##' method for dispatch into toolkit
setGeneric(".gradio",function(toolkit,
                              items, selected=1, horizontal=FALSE, handler=NULL, action=NULL,
                              container=NULL,
                              ...) standardGeneric(".gradio"))


##' replace selections
##'
##' Ensure values are unique
setReplaceMethod("[",signature(x="gRadio"),
          function(x, i, j,...,value) {
            ## check input
            if(length(value) != length(value <- unique(value)))
              gwCat("Using unique values for selection values")

            callNextMethod(x, i, j, ..., value=value)
          })

\name{gWidgets-package}
\alias{gWidgets-package}
\alias{gWidgets}
\alias{installing_gWidgets_toolkits}
\docType{package}
\title{
gWidgets API for building toolkit-independent, interactive GUIs
}
\description{
gWidgets provides a toolkit-independent API for building
interactive GUIs
}
\details{

  The gWidgets package creates an API for interacting with GUI
  toolkits. This package is toolkit neutral. The interactions is
  provided by a further package, such as gWidgetsRGtk2, or gWidgetsrJava.

  Some details on the installation of toolkits is provided by
  \code{installing_gWidgets_toolkits}.
  
Index:
\preformatted{
gWidgets-dialogs        Basic dialog constructors
gWidgets-dnd            Functions to add drag and drop ability to
                        widgets
gWidgets-handlers       Methods to add event handlers to objects
gWidgets-icons          Functions for adding icons
gWidgets-methods        Methods for gWidgets instances
gWidgets-undocumented.Rd
gaction			Reusable objects for buttons, menus, toolbars
                        Undocumented, but exported, functions
gcheckbox               Constructor of widget to indicate whether a
                        value is desired or not
gcommandline            A command line interface
gdf                     Constructor of widget to edit a data frame
gedit                   Constructors for widgets to handle text input
gfile                   Dialogs for file and date selection
ggenericwidget          A constructor to create widgets for evaluating
                        functions
ggraphics               Constructor for a toolkit specific plot device
                        and a notebook to wrap plots in
ggroup                  Containers for packing in subsequent widgets
ghelp                   Widget to interface with help pages
ghtml			widget to show html. (not implemented)
glabel                  Constructors for widgets that show text or
                        images
glayout                 A container for aligning widgets in a table
gmenu                   Constructors to make menubar or toolbars
gnotebook               constructor for notebook widget
gpanedgroup             A paned group holds two widgets with a handle
                        between them to adjust the amount of space
                        allocated to each
gradio                  Widgets to allow selection from a vector of
                        items
gseparator              Widget to draw separator line
gslider                 Constructors for widgets to select a value from
                        a sequence.
gstatusbar              Constructor of status bar widget
gtable                  Constructor for widget to display tabular data
gtree                   Constructor for widget to display heirarchical
                        dta
guiToolkit              Function to select the GUI toolkit used by
                        gWidgets
guiWidget-class         Class "guiWidget" ~~~
gvarbrowser             Widget for browsing environment
gwindow                 Constructor for base container
}
}
\author{
Philippe Grosjean, Michael Lawrence, Simon Urbanek, John
Verzani

Maintainer: John Verzani <gwidgetsrgtk@gmail.com>
}
%\references{}

\keyword{ package }

\name{gseparator}
\alias{gseparator}
\title{Widget to draw separator line}
\description{
  Simple widget to draw a line used  clarify layout of widgets.
}
\usage{
gseparator(horizontal = TRUE, container = NULL, ..., toolkit = guiToolkit())
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{horizontal}{If \code{TRUE} line is horizontal, otherwise vertical.}
  \item{container}{Optional container to attach widget to}
  \item{\dots}{Ignored }
    \item{toolkit}{Which GUI toolkit to use}

}
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
  w <- gwindow("separator example")
  gp <- ggroup(container=w)
  glabel("left widget", container=gp)
  gseparator(horizontal=FALSE, container=gp, expand=TRUE)
  glabel("right widget", container=gp)
}
}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{glabel}
\alias{glabel}
\alias{svalue<-,gLabel-method}
%%\alias{rotatelabel}
\title{Constructors for label widget}
\description{
  This constructor produces a widget to display a line or multipline
  lines of text.

  For some toolkits, the text can be marked up.

  An option is available so that the displayed text can be edited.
}
\usage{
glabel(text = "", markup = FALSE, editable = FALSE, handler = NULL,
action = NULL, container = NULL, ..., toolkit = guiToolkit())

}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{text}{Text to show in the label or button. For buttons, if
    this text matches a stock icon name, an icon is shown as well}
  \item{markup}{ Logical indicating if text for a label uses markup }
  \item{editable}{Logical. If TRUE, then the label's text can be set
  by clicking on the label and filling in the edit box. }
  \item{handler}{Handler called on a click event}
  \item{action}{ Passed to handler }
  \item{container}{Optional container to attach widget to.}
%  \item{obj}{a \code{glabel} instance}
%  \item{angle}{Angle to rotate label, in degrees}
  \item{\dots}{Passed to \code{add} method of container}
  \item{toolkit}{Which GUI toolkit to use}

}
\details{
  
	The \code{svalue()} method returns the value of the
	widget. For a label, this is the text as a single string
	(which may not include a "\\n" for newlines if not supported by
	the toolkit). 
	
	
	The \code{svalue<-()} method can be used to set the value of
	the widget. For labels and buttons, value with length greater
	than one are pasted together collapsed with "\\n". 

	The \code{addhandlerclicked} method specifies a handler to be
	called on click events.

	Although in some toolkits, labels are meant to hold static text,
	gWidgets treats label widgets like other widgets allowing the user to
	bind handlers to mouse clicks.  For labels, if
	\code{editable=TRUE} is specified, clicking on the text allows
	one to edit the label's value overriding the click handler in
	the process. However, the \code{addhandlerchanged} handler can
	be given to respond to the text after it has been chnaged.


}
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
   glabel("a label", container=TRUE)
   glabel("Click me to edit label", editable=TRUE, container=TRUE)
   glabel("Click me for a message", container=TRUE,
   handler=function(h,...) {cat("Hi\n")})
}
}
\keyword{ interface }% at least one, from doc/KEYWORDS

\name{gmenu}
\alias{gaction}
\alias{gmenu}
\alias{gtoolbar}
\title{ Constructors to make menubars or toolbars}
\description{
	A menubar or toolbar are created using these
	constructors. These are specified using a lists, and these may
	be seen as simply mapping these lists into the corresponding widget.
}
\usage{
gmenu(menulist,  popup = FALSE, action=NULL, container = NULL, ..., 
toolkit = guiToolkit())

gtoolbar (toolbarlist, style = c("both", "icons", "text",
	 "both-horiz"), 
	 action=NULL, container = NULL, 
    ..., toolkit = guiToolkit()) 

gaction(label, tooltip = NULL, icon = NULL, key.accel = NULL, 
        handler = NULL, action = NULL, parent=NULL, ...,
        toolkit = guiToolkit())

}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{menulist}{A list defining a menu bar}
  \item{popup}{Logical indicating if this should return a popup menu}
  \item{toolbarlist}{A list defining a toolbar}
  \item{style}{What style to use}
  \item{action}{Passed to menubar handlers}
  \item{container}{Container to attach widget to. Should be a gwindow instance.}
  \item{label}{Label for action item}
  \item{tooltip}{tooltip}
  \item{icon}{icon to decorate instance of action}
  \item{key.accel}{keyboard accelerator. If specified, a parent window must also be specified.}
  \item{parent}{Needed if key.accel is specified}
  \item{handler}{Handler called when object attached to action is activated}
  \item{\dots}{Passed to the \code{add} method of the container}
  \item{toolkit}{Which GUI toolkit to use}

}
\details{

	The gaction constructor creates reusable objects for use with
	buttons, menubars and toolbars. Once constructed, the main
	methods are \code{svalue}, and \code{svalue<-} for getting and
	setting the label text and \code{enabled<-} which can changes
	whether the widgets depending on the action are sensitive to
	user input. An action object contains a label, an optional
	icon, an optional keyboard accelerator, a handler and a parent
	window. The handler does not have the widget from which it is
	called passed in to the \code{obj} component of the first
	argument, but one can parametrize the argument with the
	\code{action} argument. The icon, tooltip, and keyboard
	accelerator are very much toolkit and OS dependent, and so may
	not always be available by the widget using the gaction
	object. The keyboard accelerator may use modifiers
	\code{Control}, \code{Alt} or \code{Shift} along with a
	letter, such as \code{Control-c}.  For \pkg{gWidgetstcltk} the
	value is passed to \code{tkbind}.  For \pkg{gWidgetsQt} the
	value is passed to \code{Qt$QKeySequence}.  For
	\pkg{gWidgetsRGtk2} the value is parsed and manipulated.  The
	keyboard accelerator requires a parent container so that the
	corresponding window for which the accelerator applies can be
	found.

	The lists defining a menubar or toolbar are very similar.

	Each is a list with \emph{named} components. A component is a
	terminal node if it a) is a \code{gaction} instance or b) has a
	\code{handler} component, which is a function to be called
	(without arguments) when the menu item or toolbar item is
	selected. Optionally, an \code{icon} component can be given
	specifying a stock icon to accompany the text. A non-null
	component named \code{separator} will also indicate a terminal
	node. In this case, a visible separator will be displayed.

	A menubar list can use the hierarchical nature of a list to
	generate submenus. For toolbars this is not the case.

	These constructors map the list into the widget. The methods
	for the constructors refer to these list defining the widget.

	The \code{svalue} method returns the list.

	The \code{svalue<-} method can be used to change the list, and
	hence redo the menubar.

	The \code{"["} method refers to the components of the list.

	The \code{"[<-"} method can be used to change pieces of the
	menubar or toolbar.

	The \code{add} method with signature \code{(obj,lst)} or
	\code{(obj,gmenu.instance)} can be used to apped to the
	current menubar/toolbar. The second argument is a list or an
	gmenu or gtoolbar instance.

	The \code{delete} method 
	can be used to delete part of the menubar/toolbar. The
	\code{value} argument can be either a character vector with
	the top-level names to delete, or a named list, or an instance
	of either gmenu or gtoolbar.

	Popular usage reserves toolbars and menubars for top-level
	windows -- not dialog sub windows, or sub groups within a GUI
	-- as such, the container, specified at construction, should
	be a top-level gwindow instance

      }
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
 mbl <- list()
 mbl$File$Open$handler = function(h,...) print("open")
 mbl$File$Quit$handler = function(h,...) print("quit")
 mbl$File$Quit$icon = "quit"
 mbl$Edit$Find$handler = function(h,...) print("Find")
 mbl$Edit$Replace$handler = function(h,...) print("Replace")

 w <- gwindow("gmenu test")
 mb <- gmenu(mbl, container=w)

 tbl <- list()
 tbl$New <- list(icon="new",handler = function(...) print("new"))
 tbl$Print <- list(icon="print",handler = function(...) print("print"))

 tb <- gtoolbar(tbl, container=w)

 ## example of using gaction
 ## works in gWidgetstcltk, but much  better in gWidgetsRGtk2

 ## stub for handler
f <- function(h,...) print("stub")

## some actions. The icon is optional, as is tooltip
aOpen <-  gaction(label="Open",   icon="open",  handler=f)
aClose <- gaction(label="Close",  icon="close", handler=f)
aQuit  <- gaction(label="Quit",   icon="quit",  handler=function(h,...) dispose(w))
aCut <-   gaction(label="Cut",    icon="cut",   handler=f)
aCopy <-  gaction(label="Copy",   icon="copy",  handler=f)
aPaste <- gaction(label="Paste",  icon="paste", handler=f)

## set up groups of actions so that they can be disabled/enabled
## all at once
allActionsGroup <- list(aOpen, aClose, aQuit, aCut, aCopy, aPaste)
editActionsGroup <- list(aCut, aCopy, aPaste)

## define menubar list
ml <- list(File = list(
             open = aOpen,
             close = aClose,
             sep = list(separator = TRUE), # must be named component
             quit = aQuit),
           Edit = list(
             copy = aCopy,
             paste = aPaste))

## toolbar list has only one level
tl <- list(
   Open=aOpen, 
   sep = list(separator = TRUE), # must be named component
   Quit = aQuit)

## set up main window
w <- gwindow()
gmenu(ml, container = w)
gtoolbar(tl, container = w)

## Now add a widget
gbutton(action = aQuit, container = w)

## disable a group of action
sapply(editActionsGroup, function(i) enabled(i) <- FALSE)

}
}
\keyword{interface }% at least one, from doc/KEYWORDS

\name{gformlayout}
\alias{gformlayout}

\title{A constructor for laying out groups of widgets from a template defined by a list}
\description{
	This constructor takes a list that defines the layout of widgets
	and pieces them together to create a form or dialog. It is
	similar to \code{ggenericwidget} but offers more flexibility
	with the layout, but does not offer the automatic creation of
	the widget using a functions \code{formals}. 
}
\usage{
gformlayout(lst,  container = NULL, ..., toolkit = guiToolkit())
}

\arguments{
  \item{lst}{A list that defines the layout of the containers. See the
  details section.}
  \item{container}{Optional parent container for the widget}
  \item{\dots}{Passed to \code{add} method of parent container when given}
  \item{toolkit}{Which GUI toolkit to use}
}
\details{
	The list defining the layout has the following key named components:

	\describe{
	  \item{type}{The type is the name of a gWidgets constructor or
	    "fieldset". The latter specifies that the children should be
	    layed out using a table. The type can specify either a container
	    constructor or component contstructor}
	  \item{children}{For containers, this specifies the children
	  using a
	    list. Each child is a given as a component of this
	    list. Children can be containers and hence contain other
	    children, to match the heirarchical layout common in GUIs.}
	  \item{name}{If a name is specified, then this widget will be
	    stored in a list that can be accessed by the methods
	    \code{svalue} or \code{\[}}
	  \item{depends.on}{The name of a widget previously specified
	    through the \code{name} argument. If given, then a handler is
	    added to the widget that controls whether this new
	    widget/container should be enabled.}
	  \item{depends.FUN}{When \code{depends.on} is specified, this
	    function is consulted to see if the widget should be
	    enabled. This function has argument \code{value} which is
	    the return value of \code{svalue} on the named widget this
	    new one depends on. It should return a logical value
	    indicating if the new widget is to be enabled.}
	  \item{depends.signal}{By default, the signal the handler
	    specified through \code{depends.FUN} is given by
	    \code{addHandlerChanged}, this allows on to specify a
	    different \code{addHandler} method. See the example.}
	}
	
	If the type is  \code{gnotebook}, then each child should have a
	\code{label} component.
	
	The new constructor \code{fieldset} allows the organization of
	its children in a table. These children should not be other
	containers. If the component \code{label} is non-null, the table is
	packed into a \code{gframe} container. The default number of
	columns is just 1, but specifying \code{columns} in the list can
	increase this. Children are packed in row by row when more than
	one column is given.

	The labels can be adjusted. The component \code{label.pos} can
	be "left" (the default) for a label to the left of the widget,
	or "top" to have the label on top of the widget. When the
	position if "left", then the \code{label.just} component is
	consulted for justification of the label. This can have a value
	of "right" (the default), "center" or "left"

	If a component \code{label.font} is given, then this will be
	applied to each label through the \code{font} method of the
	label.

	The children are specified as a list. Each child should have a
	\code{type} component, a \code{label} component and a
	\code{name} component. Other components are passed to the
	specified constructor in type through \code{do.call}.

	The return object has a few methods defined for it.
	
	The \code{\[} method returns a list with named components storing
	the objects created by the constructors. Subsetting is
	allowed. No \code{\[\[} method is given, instead the
	\code{drop=TRUE} argument can be used with a single index is
	given to return the component and not the list containing the component.
	
	The \code{svalue} method is a convenience method that applies
	the \code{svalue} method to each component of the list returned
	by \code{\[}.

	The \code{names} method is a convenience method that gives the
	names of the widgets store in the list returned by \code{\[}.
	
      }
      
% \value{}
% \references{}
% \author{}
\note{The design of this borrows from the FormPanel and FormLayout
  constructors in the 
  \url{extjs.com} library for javascript programming.}
\seealso{\code{\link{ggenericwidget}}}
\examples{
\dontrun{

## layout a collection of widgets to generate a t.test
tTest <- list(type = "ggroup",
              horizontal = FALSE,
              children = list(
                list(type="fieldset",
                     columns = 2,
                     label = "Variable(s)",
                     label.pos = "top",
                     label.font = c(weight="bold"),
                     children = list(
                       list(name = "x",
                            label = "x",
                            type = "gedit",
                            text = ""),
                       list(name = "y",
                            label = "y",
                            type = "gedit",
                            text = "",
                            depends.on = "x",
                            depends.FUN = function(value) nchar(value) > 0,
                            depends.signal = "addHandlerBlur"
                            )
                       )
                     ),
                list(type = "fieldset",
                     label = "Hypotheses",
                     columns = 2, 
                     children = list(
                       list(name = "mu",
                            type = "gedit",                            
                            label = "Ho: mu=",
                            text = "0",
                            coerce.with = as.numeric),
                       list(name = "alternative",
                            type="gcombobox",
                            label = "HA: ",
                            items = c("two.sided","less","greater")
                            )
                       )
                     ),
                list(type = "fieldset",
                     label = "two sample test",
                     columns = 2,
                     depends.on = "y",
                     depends.FUN = function(value) nchar(value) > 0,
                     depends.signal = "addHandlerBlur",                     
                     children = list(
                       list(name = "paired",
                            label = "paired samples",
                            type = "gcombobox",
                            items = c(FALSE, TRUE)
                            ),
                       list(name = "var.equal",
                            label = "assume equal var",
                            type = "gcombobox",
                            items = c(FALSE, TRUE)
                            )
                       )
                     ),
                list(type = "fieldset",
                     columns = 1,
                     children = list(
                       list(name = "conf.level",
                            label = "confidence level",
                            type = "gedit",
                            text = "0.95",
                            coerce.with = as.numeric)
                       )
                     )
                )
              )

w <- gwindow("t.test")
g <- ggroup(horizontal = FALSE, container = w)
fl <- gformlayout(tTest, container = g, expand=TRUE)
bg <- ggroup(container = g)
addSpring(bg)
b <- gbutton("run t.test", container = bg)
addHandlerChanged(b, function(h,...) {
  out <- svalue(fl)
  out$x <- svalue(out$x) # turn text string into numbers via get()
  if(out$y == "") {
    out$y <- out$paired <- NULL 
  } else {
   out$y <- svalue(out$y)
  }
  print(do.call("t.test",out))
})
}		
}
\keyword{interface}

\name{glayout}
\alias{glayout}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{A container for aligning widgets in a table}
\description{
  A container for laying out widgets in a table. The widgets are added
  using matrix notation (\code{[i,j]<-}).

}
\usage{
glayout(homogeneous = FALSE, spacing = 10, container = NULL, ..., toolkit = guiToolkit())
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{homogeneous}{A logical indicating if the  cells are all the same size}
  \item{spacing}{Spacing in pixels between cells}
  \item{container}{Optional container to attach widget to.}
  \item{\dots}{Passed to \code{add} method of container}
  \item{toolkit}{Which GUI toolkit to use}

}
\details{

  Widgets are added using matrix notation. A widget can span several
  cells, for instance \code{obj[1:2,2:3] <- widget} would place the
  widget in the first and second rows and second and third columns.  The
  matrix notation is to specify the space allocated to the widget. 

  For \code{gWidgetstcltk}, it is necessary for a child widget to have the
  layout object as its parent container and to call the \code{[<-}
  method to add the widget. (See the example.)

  
  As a convenience, if the value to be assigned is a character it will
  be turned into a \code{glabel} object before being added.


  Like \code{ggroup}, the extra argument \code{expand} can be used to
  force the widget to expand to fill all the space allocated to it.
  
  Like \code{ggroup}, the extra argument \code{anchor} can by used to
  anchor the child within the space allocated when this space islarger
  than needed by the widget. This is specified as a pair of values from
  -1,0,1 to indicating the x and y positioning of the widget within the
  cell.
  
  Like  \code{ggroup}, the extra argument \code{fill} can by used when \code{expand} is given, but not \code{anchor}, to have the widget expand in the \code{x} direction, the \code{y} direction, or \code{both} (the default). (Toolkit specific). 

  The method \code{[} can be used to subset. In the simplest usage, it
  returns the item at index i,j. (The item at i,j may be in other
  cells too. The return value is a gwidget if 1x1, a list if 1xn or
  mx1 (n>1), or a mxn matrix of items.


}
	
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
  ## show part of mtcars dataframe in a layout
  w <- gwindow("glayout example")
  tbl <- glayout(container = w)
  tbl[1,1] <- "a label"
  ## need container argument in gWidgetstcltk, gWidgetsRwxwidgets
  ## so we always use it.
  tbl[1,2, expand = TRUE] <- gedit("edit here", container=tbl)
  tbl[2,1, anchor = c(-1,-1)] <- glabel("ll", container = tbl)

  ## extraction:
  tbl[1,1] # glabel instance
  tbl[1,2] # gedit instance, ...
}
}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{ggraphics}
\alias{ggraphics}
\alias{ggraphicsnotebook}
\title{Constructor for a toolkit specific plot device and a
		   notebook to wrap plots in}
\description{
	If a toolkit provides a graphics device, such as the
	cairoDevice package does for GTK+ or qtutils for Qt, this constructor makes
	devices that can then be embedded in other widgets. The
	notebook interface is one such example.
}
\usage{
ggraphics(width = dpi * 6, height = dpi * 6, dpi = 75, ps = 12, container =
NULL, ..., toolkit = guiToolkit())

ggraphicsnotebook(width=dpi*6, height=dpi*6,dpi=75, 
container = NULL,..., toolkit = guiToolkit()) 
}
\arguments{
  \item{width}{width in pixels of device}
  \item{height}{height in pixels of device}
  \item{dpi}{scale factor for default width and height}
  \item{ps}{pointsize}
  \item{container}{Optional container to attach widget to}
  \item{\dots}{
    Passed to add method of container. }
  \item{toolkit}{Which GUI toolkit to use}
}
\details{
	
When multiple graphics devices are present, clicking in the window of
one will make that the current device.

The \code{visible<-} method makes the object the current device.

The \code{svalue(obj, ..., value)} method will save the visible window
to the file in \code{value}. In gWidgetsRGtk2, if the window has
another window clipping part of it, this clipping will be shown. This
"hack" is needed, as \code{dev.copy} does not currently work for the
"cairo" graphic device. (In future versions, there will be support for
pdf files within cairo.)


The \code{addhandlerclicked(obj, handler, action, ...)} method where handler has
first argument \code{h} has the additional values \code{h\$x} and
\code{h\$y} where these are values
are returned using "usr" coordinates (see \code{help("par")}). (This was
in NDC coordinates)

For \pkg{gWidgetsRGtk2} and \pkg{gWidgetsQt} there is also rubber-band
selection implemented. The \code{addHandlerChanged} method can be used
to call a handler when the selection is completed. The \code{x} and
\code{y} components of \code{h} record the lower left and upper right
points of the rectange. See the example for how this can do something
similar to "brushing".


}
% \value{}
% \author{}
% \note{}
\examples{
\dontrun{
win <- gwindow("Graphics example")
ggraphics(ps=6, container=win)
hist(rnorm(100))

## This is for gWidgetsRGtk2  (along with cairoDevice) or qtutils
library(gWidgets)
options(guiToolkit="RGtk2") ## "Qt"

w <- gwindow("brush example", visible=FALSE)
g <- ggroup(container=w)
tbl <- gtable(mtcars, container=g, filter.FUN="manual")
size(tbl) <- c(300, 500)
gg <- ggraphics(container=g)
visible(w) <- TRUE

makePlot <- function(ind) {
  plot(mpg ~ wt, mtcars)
  if(!missing(ind) && any(ind)) 
    points(mpg ~ wt, mtcars[ind,], cex=2, pch=16, col="red")
}

ID <- addHandlerChanged(gg, handler=function(h,...) {
  x <- h$x; y <- h$y

  ind <- (mtcars$wt >= x[1]) & (mtcars$wt <= x[2]) &
         (mtcars$mpg >= y[1]) & (mtcars$mpg <= y[2])

  ## udpate graphic and data frame
  makePlot(ind) 
  if(any(ind))
    visible(tbl) <- ind
})

## Example using a notebook. The device is raised on tab change
library(gWidgets)
options(guiToolkit="RGtk2")

w <- gwindow("notebook example")
nb <- gnotebook(container=w)

devs <- lapply(1:5, function(i) ggraphics(container=nb, label=as.character(i)))

addHandlerChanged(nb, handler=function(h,...) {
  ## Tricky part is svalue(h$obj) is not the new page number -- but old
  ## so we use the pageno component here
  gg <- h$obj[h$pageno]
  visible(gg) <- TRUE
})

}
}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{gfile}
\alias{gfile}
\alias{gfilebrowse}
\alias{gcalendar}

\title{Dialogs for file and date selection}
\description{
	These functions provide dialogs for file selection (files or
	directories) and date selections.
}
\usage{
gfile(text = "", type = c("open", "save", "selectdir"), initialfilename = NULL, 
    filter = list("All files" = list(patterns = c("*")), "R files" =
    list(patterns = c("*.R","*.Rdata")),
        "text files" = list(mime.types = c("text/plain"))
        ), multi=FALSE, handler = NULL, action = NULL, ..., toolkit = guiToolkit())

gfilebrowse (text = "Select a file...", type = "open", quote = TRUE, 
    container = NULL, ..., toolkit = guiToolkit()) 

gcalendar(text = "", format = "\%Y-\%m-\%d", handler=NULL, 
action=NULL, container = NULL, ..., toolkit = guiToolkit()) 
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{text}{Initial text. For thecalendar, an optional date in a form matching \code{format}}
  \item{type}{When selecting a file it can be selected for opening,
  for saving or you may want to select a directory.}
\item{initialfilename}{Suggested name for file save}
  \item{filter}{Filter for files shown during selection. Can be nested list, as in example or a named character vector with the names a description and value a file extension (no dots) of files endings to match. }
  \item{multi}{Logical. Allow selection of multiple files?}
  \item{quote}{Is result quoted}
  \item{format}{Format of date, default is year-month-day}
  \item{handler}{Handler for when file is changed. The component
    \code{file} of the first argument contains the file name}
  \item{action}{ Passed to handler }
  \item{container}{Optional container to attach widget to}
  \item{\dots}{Passed to \code{gedit} instance}
  \item{toolkit}{Which GUI toolkit to use}
}
\details{
	The \code{gfile} dialog is modal, meaning no action can take
	place until a selection is made. Whereas the
	\code{gfilebrowse} dialog consists of a \code{gedit} instance
	to hold a filename and a button to click if the dialog is
	desired to fill in this filename.

	The \code{gcalendar} widget is similar to the
	\code{gfilebrowse} widget.

	For both \code{gcalendar} and \code{gfilebrowse} any
	\code{...} arguments are passed to \code{gedit}. The
	\code{coerce.with} argument can be used to here to quote the
	values, or coerce them otherwise such as with
	\code{as.Date}. Otherwise, the \code{svalue} method returns
	a character string containing the value shown in the
	\code{gedit} box.


	The \code{svalue<-()} method may be used to set the value for
	both \code{gcalendar} and \code{gfilebrowse} .

	The return value is the filename selected. A \code{NA} value is
	returned if no file is selected.

}
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
## source a file using a handler
sourceFile <- function() gfile("Select a file",type="open", handler =
function(h,...) source(h$file))

## source an R file using fact that dialog is modal
source(gfile(filter=c("R files"="R")))

## apply a generic action to the file
countLines <- function(filename) print(length(readLines(filename)))
chooseFile <- function() gfile("Select a file",type="open",
action="countLines", handler = function(h,...) do.call(h$action,list(h$file)))
}
}
\keyword{interface}

\name{gWidgets-classes}
\alias{gWidgets-classes}

\alias{gAction-class}
 \alias{gButton-class}
 \alias{gCalendar-class}
 \alias{gCheckbox-class}
 \alias{gCheckboxGroup-class}
 \alias{gCombobox-class}
 \alias{gCommandline-class}
 \alias{gDf-class}
 \alias{gDfNotebook-class}
 \alias{gEdit-class}
 \alias{gExpandGroup-class}
 \alias{gFilebrowse-class}
 \alias{gFormLayout-class}
 \alias{gFrame-class}
 \alias{gGenericWidget-class}
 \alias{gGraphics-class}
 \alias{gGraphicsNotebook-class}
 \alias{gGridComponent-class}
 \alias{gGroup-class}
 \alias{gHelp-class}
 \alias{gHelpBrowser-class}
 \alias{gHtml-class}
 \alias{gImage-class}
 \alias{gLabel-class}
 \alias{gLayout-class}
 \alias{gMenu-class}
 \alias{gNotebook-class}
 \alias{gPanedGroup-class}
 \alias{gRadio-class}
 \alias{gSeparator-class}
 \alias{gSlider-class}
 \alias{gSpinbutton-class}
 \alias{gStatusbar-class}
 \alias{gSvg-class}
 \alias{gTable-class}
 \alias{gText-class}
 \alias{gToolbar-class}
 \alias{gTree-class}
 \alias{guiComponentRangeSelector-class}
 \alias{guiComponentWithItems-class}
 \alias{gVarBrowser-class}
 \alias{gWindow-class}
 \alias{gCommandlineANY-class}
 \alias{gGenericWidgetANY-class}
 \alias{gFormLayoutANY-class}
 \alias{gHelpbrowserANY-class}
 \alias{gHelpANY-class}

  
\title{Classes for gWidgets instances}
\description{
  Classes for gWidgets objects
}

\details{	
  The gWidgets API is designed to have a double dispatch. The gWidgets
  package calling methods in the gWidgetsXXX packages. As such, the real
  class structure sits inside the toolkit packages. These classes are
  merely here for organization and some day documentation.

  The "ANY" classes are a means to write compound widgets in gWidgets
  that work across the toolkits.

  gAction gButton gCalendar gCheckbox gCheckboxGroup gCombobox
  gCommandline  gDf gDfNotebook gEdit gExpandGroup
  gFilebrowse gFormLayout gFrame gGenericWidget
  gGraphics gGraphicsNotebook gGroup gHelp 
  gHelpBrowser  gHtml gImage gLabel gLayout gMenu
  gNotebook gPanedGroup gRadio gSeparator gSlider gSpinbutton
  gStatusbar gSvg gTable gText gToolbar gTree guiComponentRangeSelector
  guiComponentWithItems gVarBrowser gWindow

  gCommandlineANY
  gGenericWidgetANY
  gFormLayoutANY
  gHelpbrowserANY
  gHelpANY

}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{gWidgets-dnd}
\alias{gWidgets-dnd}
\alias{adddroptarget}
\alias{adddropmotion}
\alias{adddropsource}
\alias{addDropTarget}
\alias{addDropMotion}
\alias{addDropSource}


\title{Functions to add drag and drop ability to widgets}
\description{
	These functions allow drag and drop between widgets. The basic
	idea is that one creates drop sources from which one defines
	values which may be
	dragged and drop target where values may be dropped. These
	values can be text, or widgets.
}
\usage{
adddropsource (obj, targetType = "text", handler = NULL, action = NULL, 
    ...) 
adddropmotion (obj, handler = NULL, action = NULL, ...) 
adddroptarget (obj, targetType = "text", handler = NULL, action = NULL, 
    ...) 
}
\arguments{
	\item{obj}{Object to put drop handler on}
	\item{targetType}{What type of drop target: either "text" or
	"pixmap" or "entry".}
	\item{handler}{Handler called for the drop motion}
	\item{action}{action passed to handler}
	\item{...}{Not documented, currently has no role.}
}
\details{
	To specify if one can drag values from a widget use
	\code{adddropsource} called on the object.  The argument
	\code{targetType} can be set to \code{"object"} when the drop
	value is to be a widget, and not a string.  The arguments
	\code{handler} and \code{action} can be used to describe what
	gets dropped. The default is to drop the widget's contents as
	returned by \code{svalue}.

	To specify if an object is a drop target the
	\code{adddroptarget} method is called on the object. The
	argument \code{handler} (but no \code{action}) is used to handle
	the drop.

	The handler's first argument is a list with named components.
	The \code{obj} component refers to the object that has the
	target placed on it. The component \code{dropdata} is set by the
	\code{adddropsource} method. The dropdata is typically a string,
	but a mechanism is in place to drop widgets.
	The default handler for \code{adddroptarget} is to replace the
	widget's value with the dropped data.

	To add an action to a motion event, use the
	\code{adddropmotion} method. The \code{adddroptarget} must first
	have been added to the object.
}
\value{
	These functions return an ID returned  when registering
	a handler. The function \code{removehandler} uses this
	information to remove a drag and drop handler.
}
\author{Implementation of Simon Urbanek's iwidgets API was done by
Michael Lawrence and John Verzani }
\seealso{\link{gWidgets-methods}} 
\examples{
\dontrun{
## simple dnd
lab  = glabel("drag me",container=gwindow())
ed = gedit("drop here",container = gwindow())
adddropsource(lab)
adddroptarget(ed)
adddropmotion(ed,handler=function(h,...) print("bombs away"))

## more complicated
## this shows that rows of editable data frame can be dropped.
## by assigning to the changed signal, the graphs can be dynamic.
## THat is, drop a column, then edit it. The graph will update. The key
## is referring to the "value" stored in gd. This refers to the column
## in the editable data frame.
## By using svalue() and id(), the dropped value can also be a
## character string referring to a variable in the workspace.
adf = gdf(mtcars, container = gwindow())
gd = ggraphics(container = gwindow())
plotData = function() {
  dropvalue = tag(gd,"value")
  theValues = svalue(dropvalue)
  theName = id(dropvalue)
  hist(theValues, xlab=theName, main="")
}

ids = adddroptarget(gd,targetType="object", handler = function(h,...) {
    tag(gd, "value") <- h$dropdata
    plotData()

    if(is.gdataframecolumn(h$dropdata)) {
      view.col = h$dropdata
      id = addhandlerchanged(view.col, handler=function(h,...) plotData())
    }
})
}
}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{gsvg}
\alias{gsvg}
\title{Constructor for widget to show SVG files}
\description{
  Some toolkit packages provide a widget to display an SVG file. This
  widget allows this to be embedded within a gWidgets window.
}
\usage{
gsvg( filename="", width=480, height=480,
                 handler=NULL, action=NULL,
                 container = NULL, ... ,
                 toolkit=guiToolkit())
}
\arguments{
  \item{filename}{SVG file}
  \item{width}{width in pixels of widget}
  \item{height}{height in pixels of widget}
  \item{handler}{Called on click event}
  \item{action}{Used to parameterize callback specified by handler}
  \item{container}{Container to attach widget to}
  \item{\dots}{
    Passed to add method of container. }
  \item{toolkit}{Which GUI toolkit to use}
}
\details{
	
The \code{svalue} method returns the current filename.

The \code{svalue<-} method can be used to set a new file to display.

The \code{addhandlerclicked(obj, handler, action, ...)} method where handler has
first argument \code{h} has the additional values \code{h\$x} and
\code{h\$y} where these are pixel values for where the mouse click occurred.
}
% \value{}
% \author{}
\note{This is implemented in Qt only (and gWidgetsWWW).}
\examples{
\dontrun{
f = tempfile()
svg(f)
hist(rnorm(100))
dev.off()
win <- gwindow("Graphics example")
gsvg(f, container=win)
}
}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{gpanedgroup}
\alias{gpanedgroup}

\title{

  A paned group holds two child components with a handle, or sash,
  between them to adjust the amount of space allocated to each

}

\description{
  A constructor for a paned group.
}
\usage{
gpanedgroup(widget1=NULL, widget2=NULL, horizontal = TRUE, 
container = NULL, ..., toolkit = guiToolkit())
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{widget1}{Left (top) widget. Can be added at time of
  construction, or the \code{add} method can be used to add the child
  widgets one at a time.}
  \item{widget2}{Right (bottom) widget}
  \item{horizontal}{Left/right (\code{TRUE}) or top/bottom}
  \item{container}{Optional container to attach widget to}
  \item{\dots}{Passed to \code{add} method of container}
    \item{toolkit}{Which GUI toolkit to use}

}
\details{
  The \code{add} method can be used to one child at a time.

  The \code{svalue} method returns the sash position with a value
  between 0 and 1.
  
  The \code{svalue<-} method can be used to specify the sash position
  with a value between 0 and 1.

}
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
  w <- gwindow("gpanedgroup example")
  pg <- gpanedgroup(container=w)
  gvarbrowser(container = pg) ## first is left/top
  gtext(container = pg)
  svalue(pg) <- 0.25
}
}
\keyword{interface }% at least one, from doc/KEYWORDS

\name{ghelp}
\alias{ghelp}
\alias{ghelpbrowser}

\title{Widget to interface with help pages}
\description{
  A widget to interface with the help pages and that widget placed in a
  browser. The widget is a notebook capable of showing several pages at once.
}
\usage{
ghelp(topic = NULL, package = NULL, container = NULL, ..., toolkit = guiToolkit())
ghelpbrowser(title = "Help browser", maxTerms=100, width=1000, 
height=600, ..., toolkit = guiToolkit()) 
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{topic}{Help topic}
  \item{package}{Which package to look for topic in}
  \item{container}{Optional container to attach widget to}
  \item{title}{Title of help browser}
  \item{maxTerms}{Maximum number of search responses}
  \item{width}{Width of browser window in pixels}
  \item{height}{Height  of browser window in pixels}
  \item{\dots}{Passed to \code{add} method of container}
  \item{toolkit}{Which GUI toolkit to use}
}
\details{
  
	The \code{ghelp} widget is a notebook to hold help pages. One
	can add pages with \code{add}. The help page is specified with a
	character vector or list. The first component is the topic, the
	second and optional package designation. The \code{svalue}
	method returns a list with topic and package. The \code{dispose} method
	will remove the current page. For toolkits that support them,
	closebuttons appear on the etabs

	The \code{ghelpbrowser} constructor produces a stand alone GUI for
	browsing help pages. Unlike other \pkg{gWidgets} constructors, this
	has no \code{container} argument.
  
}
% \value{}
% \references{}
% \author{}
% \note{}
\seealso{The \pkg{helpr} package provides a much better interface to R's help pages.}
\examples{
\dontrun{
  w <- gwindow("Help browser", visible=FALSE)
  g <- ggroup(horizontal=FALSE, container=w)
  g1 <- ggroup(container=g)
  addSpring(g1)
  glabel("Help on:", container=g1)
  e <- gedit("", container=g1)
  helpWidget <- ghelp(container = g, expand=TRUE)
  addHandlerChanged(e, handler=function(h,...) {
     add(helpWidget, svalue(h$obj))
  })
  visible(w) <- TRUE
  ## add others
  add(helpWidget,"base:::mean")
  add(helpWidget, list(topic="mean", package="base"))
  add(helpWidget, "boxplot")

}
}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{gedit}
\alias{gedit}
\title{Constructor for widget to handle single-line text input}
\description{
	The \code{gedit} widget is used to enter single lines of text. 
	}
\usage{
gedit(text = "", width = 25, coerce.with = NULL, initial.msg="", 
handler = NULL, action = NULL, container = NULL, ..., toolkit = guiToolkit())
}
\arguments{
  \item{text}{Initial text in widget}
  \item{width}{Width of widget. For gedit, this means the number of
    characters.}
  \item{coerce.with}{For gedit, when the value is retrieved this
    function is applied to the result. (The stored value is always a
    character, this can be used to make it numerc, to quote it, ...}
    \item{initial.msg}{If \code{text} is empty, this initial message is displayed to give the user some indication of what to do}
  \item{handler}{Handler called when text is changed. For gedit, this
    means the enter key is pressed.}
  \item{action}{ Passed to handler}
  \item{container}{Optional container to attach widget to}
  \item{\dots}{Passed to add method of container}
  \item{toolkit}{Which GUI toolkit to use}
}
\details{
	The \code{gedit} widget has the following methods:

	The \code{svalue} method retrieves the value. If a function is
	given to the argument \code{coerce.with} it is applied before
	the value is returned. This can be used to coerce the text
	value (always of class character) to a numeric, or to a date,
	or to be quoted, ...

	The \code{svalue<-} method is used to set the value.

	The \code{"["} and \code{"[<-"} methods refer to the widgets
	"type-ahead" values. A familiar usage is when a url is typed
	into a web browser, matches appear from a users history that
	could possibly complete the typed url.
	
	The \code{visible<-} method is used to toggle whether
	characters are visible, or are replaced with a "*", such as is
	done with password entry.

      }
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
	gedit("type here", container=gwindow())
	
	## change handler
	obj <- gedit(container=gwindow())
	addhandlerchanged(obj, handler=function(h,...) 
	  cat("You typed", svalue(h$obj),"\n"))

	 ## coerce to numeric
	 obj <- gedit("7", container=gwindow(), coerce.with=as.numeric)
	 svalue(obj)

}
}
\keyword{interface }

\name{gimage}
\alias{gimage}
\title{Constructor to show images}
\description{
  This constructor produces a widget intended to show images
  stored as files on the file system. 
}
\usage{
gimage(filename = "", dirname = "",  size = "", 
    handler = NULL, action = NULL, container = NULL, ..., 
    toolkit = guiToolkit()) 
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{filename}{Specifies location of image. May be a stock icon
  name or filename. (In the future may be a url.)}
  \item{dirname}{Directory of file. If "stock", then a stock icon is used.}
  \item{size}{Size of image when stock image is used. Values are in
    \code{c("menu", "small_toolbar","large_toolbar","button","dialog")}}
  \item{handler}{Handler called on a click event}
  \item{action}{ Passed to handler }
  \item{container}{Optional container to attach widget to.}
%  \item{obj}{a \code{glabel} instance}
%  \item{angle}{Angle to rotate label, in degrees}
  \item{\dots}{Passed to \code{add} method of container}
    \item{toolkit}{Which GUI toolkit to use}

}
\details{
  
	The \code{svalue()} method returns the filename of the figure or
	the stock icon name, if the icon was set from a stock icon.
	
	
	The \code{svalue<-()} method can be used to set the value of
	the widget. The value is a filename containing the image to
	display.

	The \code{addhandlerclicked} method is called on click
	events. 

}
% \value{}
% \references{}
% \author{}
% \note{}
\seealso{See \code{\link{getStockIcons}} to get a list of available
  icons and \code{\link{addStockIcons}} to add to this list.}
\examples{
\dontrun{
   w <- gwindow("Stock icon example")
   gimage("ok",dirname="stock", container = w)

   ## example contributed by Richard Cotton

w <- gwindow("Help button window")
add_help_button <- function(help_text, container = w,
                            width = getOption("width"), indent = 2, ...) {
  gimage("help",	      
         dirname   = "stock",
         container = container,
         handler   = function(h, ...) {
           help_win <- gwindow("Help")
           help_label <- glabel(text= strwrap(help_text, width = width, indent = indent),
                                container = help_win)
         })
}

add_help_button(paste("Lorem ipsum dolor sit amet, consectetur adipiscing elit.",
                      "Nunc magna magna, vestibulum sit amet posuere sit amet, ",
		      "gravida placerat odio.",
                      "Integer et purus lorem, quis suscipit risus.", collapse=" "))

}
}
\keyword{ interface }% at least one, from doc/KEYWORDS

\name{gtree}
\alias{gtree}
\title{Constructor for widget to display heirarchical dta}
\description{
	This widget allows tree-like data to be presented. Each node
	on the tree should be a data frame with the same column
	structure. The first column is treated like a key, and should
	be unique. Offspring are specified through a function of the
	keys which are ancestors. This function returns the data frame
	to be displayed. Values in the tree can be selected with the
	mouse. This value can be retrieved through a method, or a
	handler can be assigned to double click events.
}
\usage{
gtree(offspring = NULL, hasOffspring = NULL, offspring.data = NULL,
col.types = NULL, icon.FUN = NULL, chosencol = 1, multiple = FALSE,
handler = NULL, action = NULL, container = NULL, ..., toolkit = guiToolkit())
}
\arguments{
  \item{offspring}{A function to produce a data frame. 

  The first column of the data frame is used as a key. It should be
  unique, otherwise the updating will not work properly.

  The \code{offspring} function has two arguments, the first being the
  path (the first column of the offspring data frame is the key, and
  the path is the vector of keys) and the value of
  \code{offspring.data}. The data frame can determine  whether an
  entry has offspring, by having the second column be a logical
  vector, \code{TRUE} if there is offspring, \code{FALSE} if not.
 
 }
 \item{hasOffspring
 }{

   Whether an entry has an offspring is determined by a. if this
   function is non-\code{NULL} and it returns a \code{TRUE} value when
   called on the offspring data frame for this row, b. if this is NULL
   and the second column of the offspring data frame is a logical vector
   and for this row is \code{TRUE}. If this function is \code{NULL} and
   the second column is not a logical vector then it is assumed that
   there are no offspring.
   
  }

  \item{offspring.data}{Passed to \code{offspring} function to
  parameterize that function.}

  \item{col.types}{Used to determine the type of column, given as a
  data frame with 1 or more rows. Otherwise it is determined by first
  row of offspring data frame. If the offspring function can return an
  empty data frame, then this argument should be given.}

  \item{icon.FUN}{An optional function to determine an icon place into
  the first column. This function gets called with the data in
  \code{offspring}, and should return a row vector of length
  \code{nrow(offspring)}. The icons are stock icons, and should be
  referenced by name. The helper function \code{getStockIcons} list
  all the available stock icons.}

  \item{chosencol}{The column used when requesting the selected row's
  value. Defaults to first} 

  \item{multiple}{ A logical to determine if multiple selection is
  allowed. Defaults to \code{FALSE}}
  \item{handler}{ Handler for double click events}
  \item{action}{ Passed to handler }
  \item{container}{Optional container to attach widget to.}
  \item{...}{Passed to \code{add} method of container}
  \item{toolkit}{Which GUI toolkit to use}  
}

\details{

  In an abstract sense, these trees are specified by a function which
  produces the value at a given node from the ancestry of the given
  node, and a function specifying if a node has offspring.

  The \code{offspring} function determines the displayed data for a
  certain node. It has signature \code{(path, offspring.data)}, where
  the path consists of the ancestors and \code{offspring.data} is an
  optional value passed in when the tree object is constructed. This
  function returns a data frame. Its first column should consist of
  unique values, as it is treated like a key.

  The \code{hasOffspring} function is called on the return value of
  \code{offspring}. It should return a logical indicating which rows
  have offspring. If this argument is not present, then the second
  column of the return values of \code{offspring} are consulted. If
  these are logical, then they are used to determine if offspring are
  present. Otherwise, no offspring are assumed.

  The \code{icon.FUN} function is called on the return value of
  \code{offspring}. If present, it should return a vector of stock
  icon names.

  The \code{svalue} method returns the current key.  The \code{index}
  argument has changed. If \code{index} is \code{TRUE}, the path of
  each selection is returned as a numeric vector, where the numbers
  represent the sibling count at each level, 1-based. That is
  \code{c(1,2,3)} is the 3rd offspring of the second offspring of the
  first offspring of the root. If more than one selection is made,
  then a list of such values is returned.  This way -- in theory -- we
  can set values by index too. In particular, we should have
  \code{svalue(obj, index=TRUE) <- svalue(obj, index=TRUE)}.  (Before,
  using a numeric value for index would give the ith column, as
  opposed to the chosen column. This behaviour can be found using the
  \code{"["} method.) 

  The \code{"["} method refers to the vector of keys for the selected
  object. That is, svalue gives the current key, and \code{[} returns
  the path of keys.
  
  The \code{addHandlerDoubleclick} handler (also
  \code{addHandlerChanged}) can be set to respond to
  a double click event. 

  The \code{addHandlerClicked} handler should be called when the
  selection is changed.
}
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
 ## function to find offspring
 offspring <- function(path, offspring.data=NULL) {
         if(length(path) > 0) 
           directory <- paste(getwd(), .Platform$file.sep,
                              paste(path,collapse=.Platform$file.sep),
                              sep="")
         else
           directory <- getwd()

         files <- file.info(dir(path=directory, full.names=TRUE))[,c(1,2,3)]
         files <- data.frame(filename=dir(path=directory),
                             isdir=files[,2],
                             size=as.integer(files[,1]),
                             mode=as.character(files[,3]),
                             stringsAsFactors=FALSE)
         return(files)
 }
 hasOffspring <- function(children,offspring.data=NULL, ...) {
   return(children$isdir)
 }
 icon.FUN <- function(children,offspring.data=NULL, ...) {
   x <- rep("file", length=nrow(children))
   x[children$isdir] <- "directory"
   return(x)
  }
  ## shows isdir directory, as hasOffspring is specified
  w <- gwindow("test with isdir showing")
  gtree(offspring, hasOffspring, icon.FUN = icon.FUN, container=w)

  ## does not show isdir directory, as hasOffspring=NULL and
  ## second column is a logical
  w <- gwindow("tree test no dir column")
  tr <- gtree(offspring, hasOffspring=NULL, icon.FUN = icon.FUN, container=w)

  ## Show a fixed list using a dynamic tree
l <- list(a=list(
            aa=1,
            ab=2,
            ac=list(ac1=1)
            ),
          b=list(
            ba=list(
              baa=1,
              bab=list(
                baba=1
                )
              )
            ))

offspring <- function(path, ...) {
  print(path)
  ll <- l
  if(length(path) > 0) {
    for(i in path)
      ll <- ll[[i]]
  }
  out <- data.frame(name=names(ll),
                    hasOffspring=!sapply(ll, is.atomic),
                    value=as.character(sapply(ll, function(i) ifelse(is.atomic(i), i, ""))),
                    stringsAsFactors=FALSE)
  out
}

w <- gwindow("Tree from list")
tr <- gtree(offspring=offspring, container=w)

addHandlerDoubleclick(tr, handler=function(h,...) {
  print(svalue(h$obj))		# the key
  print(h$obj[])		# vector of keys
})


}
}

\keyword{interface}% at least one, from doc/KEYWORDS

\name{gwindow}
\alias{gwindow}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Constructor for base container}
\description{
  Widgets are packed inside containers which may in turn be packed
  inside other containers. The base container is known as a window. Only
  one container may be packed inside a window.
}
\usage{
gwindow(title = "Window", visible = TRUE, name=title,
  width = NULL, height= NULL, parent=NULL,
  handler = NULL, action = NULL,
  ..., toolkit = guiToolkit())
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{title}{Title of window}
  \item{visible}{If \code{TRUE} window is drawn when
  constructed. Otherwise, window can be drawn latter using \code{visible<-}. This value can default to \code{FALSE} by
setting the option: \code{options("gWidgets:gwindow-default-visible-is-false"=TRUE)}. There are advantages: windows can draw slowly when adding item by item; \code{ggraphics} like to be added to an undrawn widget as this avoids a sizing issue.}
\item{name}{Name for registry of windows}
\item{width}{Default width for window at creation}
\item{height}{Default height for window at creation}
\item{parent}{If non-NULL, can be used to suggest default location of
window. The argument name was changed from location to parent. This can be a coordinate pair (x,y) with (0,0) the upper left
corner, or a gwindow instance. In the latter case the location is
suggested by the location of the current window. This is useful for
placing dialogs near the parent window.}
\item{handler}{Handler for destroy event.}
\item{action}{Passed to handler}
\item{\dots}{Not used}
\item{toolkit}{Which GUI toolkit to use}  
}
\details{
   A base window can also be created using the argument
   \code{container=TRUE} when constructing a widget.

   The \code{svalue} method returns the window title. Use
   \code{svalue<-} to change the title.

   The \code{add} method is used to add a widget or container to the
   base window. For top-level windows, some toolkits only support adding
   one widget, so in gWidgets only one widget should be added to a
   window, so usually it would be another container.

   Additionally the menubar, toolbar and statusbar widgets should now
   be added and deleted from the top-level window. Outside of RGtk2,
   the other toolkits expect these items to be properties of a
   top-level window.
   
   The \code{dispose} method destroys the window.

   The \code{size} method sets the minimum size. Use the \code{width}
   and \code{height} arguments to set the default size when the window
   is constructed.

   A window is destroyed  in response to a destroy event. However, when
   the window managager tries to close a window first a "delete-event"
   is issued. If this has the right value then the "destroy" event is
   fired. The \code{addHandlerUnrealize} handler can be called to
   intercept the closing of the window. Its handler should return a
   logical: \code{TRUE} to prevent the closing, \code{FALSE} to proceed. This may not work on all toolkits

}
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
  ## window with handler
  win <- gwindow("Window example",
    handler=function(h,...) {
     print("See ya")
  })
  gbutton("cancel", container=win,
    handler = function(h,...) dispose(win))

  ## block closing of window
  win <- gwindow("Window example")
  addHandlerUnrealize(win, handler = function(h,...) {
    val <- gconfirm("Really close window", parent=h$obj)
    if(as.logical(val))
      return(FALSE)		# destroy
    else
      return(TRUE)		# don't destroy
  })

  

  ## transient dialog (gWidgetsRGtk2)
  pwin <- gwindow("Parent window")
  cwin <- gwindow("Child window", parent = pwin)
  ## clicking button close parent causing child to close too
  gbutton("close both", container=cwin,
    handler = function(h,...) dispose(pwin))
}
}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{gnotebook}
\alias{gnotebook}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{constructor for notebook widget}
\description{
	A notebook widget organizes different pages using tabs,
	allowing only one page to be shown at once. Clicking on
	the tab raises the associated page.
}
\usage{
gnotebook(tab.pos = 3, closebuttons = FALSE, 
dontCloseThese = NULL, container = NULL, ..., 
toolkit = guiToolkit())
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{tab.pos}{Where to place tabs (1 bottom, 2 left side, 3 top, 4
  right side}
  \item{closebuttons}{Is there a close button in the tab?}
  \item{dontCloseThese}{If \code{closebuttons=TRUE} this will make it
  impossible to remove these tabs. Specified by tab number}
  \item{container}{Optional parent container to attach notebook widget to }
  \item{\dots}{passed to \code{add} method of parent container}
  \item{toolkit}{Which GUI toolkit to use}  

}
\details{
  In what follows, it is useful to think of a notebook as a vector with
  named entries, each entry being a widget, the name being the tab label.

  Notebooks have the following methods:

  New pages are added with the \code{add} method, which most likely is
  called by the widget constructor. The extra argument \code{label} is
  used to specify the tab label. This may be a string, or in
  gWidgetsRGtk2 a \code{glabel} instance. The extra argument
  \code{index} can be used to specify which page to add to. By
  default, a new page is created at the end of the notebook. In
  gWidgetsRGtk2, the extra argument \code{override.closebutton} can be
  used to add or not add a close button in the tab label.

  The \code{svalue} method returns the current page number. The
  \code{svalue<-} method is used to set the page number.

  The \code{dispose} method will remove the currently selected page
  unless it is overridden by the value of \code{dontCloseThese}.

  The \code{delete(obj, widget,...)} method will delete the widget on a
  given page. For some toolkits, the unparented widget can be reparented with the \code{add} method or \code{[<-}.

  The \code{length} method returns the number of pages.

  The \code{names} method returns the tab labels.

  The \code{names<-} method may be used to replace the tab
  labels. Something like \code{names(obj)[1]<-"new label"} should work.

   The \code{"["} method refers to the widgets in the notebook. It
   returns a single widget or list of widgets.

   For some toolkits, the \code{"[<-"} method may be used to replace a widget on a notebook page.
 
 The \code{addHandlerChanged} method passes the component
 \code{pageno} when the page index returned by \code{svalue} within
 the handler refers to the tab before it was changed. The following
 could be used to get the right one in a portable way:
 \code{if(is.null(h$pageno)) svalue(h$obj) else h$pageno}

}
% \value{}
% \references{}
% \author{}
% \note{}
\seealso{See \code{\link{gwindow}} for top-level containers, 
  \code{\link{ggroup}}, \code{\link{gframe}} and \code{\link{gexpandgroup}} for box containers}

\examples{
\dontrun{
  w <- gwindow("gnotebook example")
  nb <- gnotebook(container=w)
  ## "add" called by constructor
  glabel("Widget 1", container=nb, label="page 1")  
  ## label argument passed by constructor to add method
  glabel("Widget 2", container=nb, label="page 2")   

  length(nb)
  names(nb)
  names(nb)[1] <- "Page 1"

  svalue(nb) <- 2
  dispose(nb) ## dispose current tab
  length(nb) 
}
}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{gWidgets-undocumented}
\alias{gWidgets-undocumented.Rd}
\alias{show,guiWidget-method}
\alias{editFormulaDialog}
\alias{editSelectDialog}
\alias{editSubsetDialog}
\alias{.fixFontMessUp} %% screwed this up.
\alias{str2}
\alias{gwCat}			% for error messages

%% These from the ANY class for compound widgets
\alias{.add,ANY,ANY,gWidgetANY-method}
\alias{.add,gHelpANY,ANY,character-method}
\alias{.add,gHelpANY,ANY,list-method}
\alias{.add,gHelpANY-method}
\alias{add,ANY-method}
\alias{[<-,gWidgetANY-method}
\alias{[,gWidgetANY-method}
\alias{[,gCommandlineANY-method}
\alias{dimnames<-,gWidgetANY-method}
\alias{dimnames,gWidgetANY-method}
\alias{.dispose,gHelpANY-method}
\alias{enabled<-,gWidgetANY-method}
\alias{enabled,gWidgetANY-method}
\alias{focus<-,gWidgetANY-method}
\alias{focus,gWidgetANY-method}
\alias{font<-,gWidgetANY-method}
\alias{.gcommandline,ANY-method}
\alias{.ggenericwidget,ANY-method}
\alias{.ghelpbrowser,ANY-method}
\alias{.ghelp,ANY-method}
\alias{.leftBracket,gCommandlineANY-method}
\alias{.length,gHelpANY-method}
\alias{names<-,gWidgetANY-method}
\alias{names,gWidgetANY-method}
\alias{.size,gHelpbrowserANY-method}
\alias{size<-,gWidgetANY-method}
\alias{.size<-,gHelpbrowserANY,ANY,numeric-method}
\alias{.svalue<-,gCommandlineANY-method}
\alias{.svalue<-,gAddargANY-method}
\alias{.svalue<-,gBivariateANY-method}
\alias{.svalue<-,gModelANY-method}
\alias{.svalue,character-method}
\alias{.svalue,gCommandlineANY-method}
\alias{.svalue,gGenericWidgetANY-method}
\alias{.svalue,gHelpANY-method}
\alias{.svalue,gAddargANY-method}
\alias{.svalue,gUnivariateANY-method}
\alias{.svalue,gUnivariateTableANY-method}
\alias{.svalue,gFileURLANY-method}
\alias{.svalue,gBivariateANY-method}
\alias{.svalue,gModelANY-method}
\alias{.svalue,gLmerANY-method}
\alias{svalue<-,gWidgetANY-method}
\alias{svalue,numeric-method}
\alias{svalue,character-method}
\alias{svalue,gWidgetANY-method}
\alias{.tag<-,guiWidget-method}
\alias{.tag<-,gWidgetANY-method}
\alias{.tag,guiWidget-method}
\alias{.tag,gWidgetANY-method}
\alias{tag<-,gWidgetANY-method}
\alias{tag,gWidgetANY-method}
\alias{update,gWidgetANY-method}
\alias{visible<-,gWidgetANY-method}
\alias{visible,gWidgetANY-method}
\alias{.visible<-,gHelpbrowserANY,ANY,logical-method}
\alias{isExtant,gWidgetANY-method}

\alias{.gsvg,ANY-method}
\alias{.redo,guiWidget-method}
\alias{.redo,gWidgetANY-method}
\alias{.svalue,NULL-method}
\alias{.toolkitProvidesWidget,ANY-method}
\alias{.undo,guiWidget-method}
\alias{.undo,gWidgetANY-method}

\alias{.gformlayout,ANY-method}
\alias{.leftBracket,gFormLayoutANY-method}
\alias{.names,gFormLayoutANY-method}
\alias{.svalue,gFormLayoutANY-method}
\alias{[,gFormLayoutANY-method}




%% these from ANY methods
\title{Undocumented, but exported, functions}
\description{Undocumented, but exported functions from gWidgets.}
\keyword{interface}% at least one, from doc/KEYWORDS
\keyword{internal}

\name{gdf}
\alias{gdf}
\alias{gdfnotebook}
\title{Constructor of widget to edit a data frame}
\description{
	A widget used to edit data frames
}
\usage{
gdf(items = NULL, name = deparse(substitute(items)), do.subset = FALSE,
container = NULL, ...,toolkit = guiToolkit())

gdfnotebook(items = NULL, container = NULL, ..., toolkit=guiToolkit()) 
}
\arguments{
  \item{items}{data frame to be edited}
  \item{name}{Name of data frame}
  \item{do.subset}{A logical. If \code{TRUE} a means to filter the
  output using logical values is given.}
  \item{container}{An optional container to attach widget to}
  \item{\dots}{Can be used to overide default colors.}
  \item{toolkit}{Which GUI toolkit to use}
}
\details{
	This widget is similar to that provided by \code{\link{gtable}}
	only this is intended for editing of data frames. The
	\code{gdfnotebook} widget uses a notebook to hold several data
	frames at once.


	In gWidgetsRGtk2, the table shown can be edited. Double click in
	a cell to allow this. When editing, the value is saved when the
	cell is left. This is done using the up or down arrow keys, the
	Enter key, the Tab key or the mouse. The down arrow key moves
	the cursor down a row, extending the size of the data frame if
	necessary. The Enter key moves the cursor down, but does not
	extend the data frame if at the bottom. The Tab key moves to the
	right. If at the end, a dialog to add a new variable pops up.

	Right clicking in a cell that is not currently being edited pops
	up a menu to edit the colum names, sort or apply a function to a
	row.


	If \code{do.subset=TRUE} then one can filter using subsetting  by
	a single variable. The variable may be selected by a droplist,
	the logical expression can be entered or one selected from a
	droplist.

	If more complicated filtering is desired, the
	\code{visible<-} method may be used, its value should a logical
	vector of length given by the number of rows of the data frame.
	
	
	The \code{svalue} method returns the selected value.

	The \code{svalue<-} method is used to select rows without a
	moust, the value is a set of row numbers.


	The \code{"["} method is used for data-frame like extraction
	from the object.

	The \code{"[<-"} method can be used for data-frame like
	assignment, with limitations.

	

	The \code{dim}, \code{dimnames}, \code{dimnames<-},
	\code{length}, \code{names} , and \code{names<-} methods should
	work on the object as they do for data frames.

	The \code{addhandlerchanged} handler responds to changes in
	the values of the data frame.
}
% \value{}
% \references{}
% \author{}
% \note{}
\seealso{\code{\link{gtable}}}
\examples{
\dontrun{
	obj <- gdf(mtcars, container=gwindow("mtcars"), do.subset=TRUE)
	obj[1,1]
	obj[1,]
	obj[,1]
        obj[1,1] <- 21
        obj[,] <- head(mtcars) ## replace df
}
}
\keyword{interface }

\name{gvarbrowser}
\alias{gvarbrowser}
\title{Widget for browsing environment}
\description{
  A widget to browse the objects in the current global environment
}
\usage{
gvarbrowser(handler = NULL,
                 action = "summary", container = NULL, ...,
                 toolkit = guiToolkit())
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{handler}{Handler for double click. Default is to call value of
    \code{action} on the object}
  \item{action}{Passed to handler.}
  \item{container}{Optional container to attach widget to}
  \item{\dots}{ignored}
  \item{toolkit}{Which GUI toolkit to use}  
}
\details{
  In gWidgetsRGtk2 there is an idle handler that updates the top-level
  components. However, changes are made below this, they will not be
  updated automatically. Rather, the user must close and expand that
  level.

  The handler is called on the widget that provides the display, and not
  the gvarbrowser widget. If you want that in the handler, be sure to
  pass it in via the action argument.

  svalue returns a character string containing the selected variable.
}
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
gvarbrowser(container=TRUE)
}
}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{gcheckboxgroup}
\alias{gcheckboxgroup}
\title{Widget to allow multiple selection from a vector of items}
\description{
   Widgets to select one (or several) from a given vector of
   items. These are a radio group where all values are shown at once,
   but only one may be selected; a checkbox group where more than one
   may be selected; and a
   combo box (or droplist) where initially only a single value is shown, and the others
   are a mouse click away,
}
\usage{
gcheckboxgroup(items, checked = FALSE,  horizontal = FALSE, use.table=FALSE,
    handler = NULL, action = NULL, container = NULL, ..., toolkit = guiToolkit()) 
}


\arguments{
  \item{items}{ Vector of values to select from }
  \item{checked}{A logical vector indicating  initial values.}
  \item{horizontal}{A logical specifying the  layout for gradio and gcheckboxgroup}
  \item{handler}{Called when selection is changed}
  \item{use.table}{If \code{TRUE} a table with checkboxes will be used
  instead (toolkit depending) so that one can scroll through the values}
  \item{action}{Passed to handler when called.}
  \item{container}{Optional container to attach widget to}
  \item{\dots}{Passed to \code{add} method of container}
  \item{toolkit}{Which GUI toolkit to use}
}
\details{
	The \code{svalue} method returns the selected values by
	name. If the extra argument \code{index=TRUE} is specified,
	the indices of the selected values is given. 


	The \code{svalue<-} method can be used to set the selected
	value. This widget is a cross between a checkbox and a radio
	button group. As such, there are different ways to specify the
	state.  As with a checkbox, the argument can be a logical
	vector indicating which checkboxes are to be checked
	(recycling is done). As with a radio button group, the value
	can be a character vector indicating by label which checkboxes
	are to be checked; or if the \code{index=TRUE} argument is
	given, a vector of indices for those checkboxes to be checked.

	The \code{"["} method refers to the vector defining the items.

	The \code{"[<-"} method can be used to change the vector
	defining the items. The length should be the same as the
	original, although in some toolkits this isn't necessary.

	The \code{"length"} method returns the number of items.
	

}
% \value{}
% \references{}
% \author{}
% \note{}
\seealso{


	A checkboxgroup is one of several ways to select a value of a
	set of items. See also

\code{\link{gcheckbox}}, 
\code{\link{gradio}}, 
\code{\link{gcombobox}}, and
\code{\link{gtable}}.

Methods for gComponent objects are detailed in \code{\link{gWidgets-methods}}.

Event Handlers are detailed in \code{\link{gWidgets-handlers}}.


}
\examples{
\dontrun{
  flavors <- c("vanilla", "chocolate", "strawberry")

  f <- function(h,...) print(
      paste("Yum",
      paste(svalue(h$obj),collapse=" and "),
      sep = " "))

  w <- gwindow("checkbox example")
  gp <- ggroup(container=w)
  glabel("Favorite flavors:",container=gp)
  cbg <- gcheckboxgroup(flavors, container=gp, handler=f)

  svalue(cbg) <- c(TRUE, FALSE, TRUE)
  svalue(cbg)
  svalue(cbg) <- "vanilla"
  svalue(cbg, index=TRUE) <- 1:2
  cbg[3] <- "raspberry"

  ## use a table to display (toolkit specific) so that scrollars can be used
  cbg <- gcheckboxgroup(letters, container=gwindow(), use.table=TRUE)

}

}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{gWidgets-handlers}
\alias{gWidgets-handlers}
\alias{removehandler}
\alias{addhandlerchanged}
\alias{addhandlerkeystroke}
\alias{addhandlerclicked}
\alias{addhandlerdoubleclick}
\alias{addhandlerrightclick}
\alias{addhandlerfocus}
\alias{addhandlerblur}
\alias{addhandlerexpose}
\alias{addhandlermousemotion}
\alias{addhandlerunrealize}
\alias{addhandlerdestroy}
\alias{addhandleridle}
\alias{addpopupmenu}
\alias{add3rdmousepopupmenu}
\alias{addhandler}
\alias{addHandler}
\alias{removeHandler}
\alias{blockHandler}
\alias{unblockHandler}
\alias{addHandlerChanged}
\alias{addHandlerKeystroke}
\alias{addHandlerClicked}
\alias{addHandlerDoubleclick}
\alias{addHandlerRightclick}
\alias{addHandlerFocus}
\alias{addHandlerBlur}
\alias{addHandlerMouseMotion}
\alias{addHandlerExpose}
\alias{addHandlerUnrealize}
\alias{addHandlerDestroy}
\alias{addHandlerIdle}
\alias{addHandlerColumnClicked}
\alias{addhandlercolumnclicked}
\alias{addHandlerColumnRightclick}
\alias{addhandlercolumnrightclick}
\alias{addHandlerColumnDoubleclick}
\alias{addhandlercolumndoubleclick}


\alias{addPopupmenu}
\alias{add3rdMousePopupmenu}
\alias{removeHandler}

\title{Methods to add  event handlers to objects}
\description{

	In the gWidgets API handlers are called in reponse to certain
	events such as keystrokes or clicks. This set of methods makes
	a consistent interface to some typical events. Not all
	handlers are defined for each widget. 

}
\usage{
addHandlerChanged(obj, handler = NULL, action = NULL, ...) 

addHandlerKeystroke(obj, handler = NULL, action = NULL, ...) 

addHandlerClicked(obj, handler = NULL, action = NULL, ...) 

addHandlerDoubleclick(obj, handler = NULL, action = NULL, ...) 

addHandlerRightclick(obj, handler = NULL, action = NULL, ...) 

addHandlerFocus(obj, handler = NULL, action = NULL, ...) 

addHandlerBlur(obj, handler = NULL, action = NULL, ...) 

addHandlerMouseMotion(obj, handler = NULL, action = NULL, ...)

addHandlerExpose(obj, handler = NULL, action = NULL, ...) 

addHandlerUnrealize(obj, handler = NULL, action = NULL, ...) 

addHandlerDestroy(obj, handler = NULL, action = NULL, ...) 

addHandlerIdle (obj, handler = NULL, action = NULL, interval = 1000,   ...) 

addPopupmenu(obj, menulist, action=NULL, ...)

add3rdMousePopupmenu(obj, menulist, action=NULL, ...)

%%addHandler(obj, signal, handler = NULL, action = NULL, ...)

removeHandler(obj, ID=NULL, ...)

blockHandler(obj, ID=NULL, ...)

unblockHandler(obj, ID=NULL, ...)
}

\arguments{
  \item{obj}{The object to assign handler to}
%%  \item{signal}{The signal the handler responds to}
  \item{handler}{A function to call if the given event occurs.
    The function's first argument is a list with some specific
    components. The component \code{obj} contains the object that
    the handler was assigned to. The \code{action} component
    contains the value given to the argument \code{action}. This can be used
    with \code{do.call} to make simple handlers. Or, this can be
    used to pass in other widgets, etc. 
    
    Sometimes there are other components. For drag and drop
    handlers the component \code{dropdata} refers to the dropped
    data. For \code{ggraphics} the \code{addHandlerclicked}
    contains components \code{x} and \code{y} indicating where the
    click occurred.
  }
  \item{action}{Used to pass extra information into handlers }
  \item{interval}{For \code{addHandleridle} this specifies the
    time in milliseconds between calls to the handler.}
  \item{menulist}{For \code{addpopupmenu} and
    \code{add3rdmousepopupmenu} this specifies a menubar using a
    list which is in turn passed to \code{gmenu}.}
  \item{ID}{When a handler is assigned, an id is returned. This
    id can be used to remove or block a handler from an object.}
  \item{...}{Not documented, currently has no role.}
}
\details{
  At first these handlers were all lowercase. These functions are still
  availabe, although the mixed case usage is encouraged
	
	In GTK, and other toolkits, an event causes a signal to
	be triggered and these handlers are called in response to that
	signal. 

	These signals have various names known to the GTK
	programmer. say. These functions attempt to shield the
	gWidgets user from needing to learn these signals. For
	gWidgetsRGtk, if these handlers prove insufficient then the
	non-exported \code{addHandler} function has an additional
	\code{signal} argument: \code{(obj,signal,handler,
	action,...)} for specifying a GTK signal. By avoiding this, we
	can make the gWidgets API non-toolkit specific.

	 The signals are defined to match the event
	described by the method name, e.g., "doubleclick." 

	The handlers all have signature \code{(h,...)} where the first
	argument is a list with components \code{obj} containing the
	widget the handler is added to and \code{action} containing
	the values passed along to the \code{action} argument. This
	can be used to pass in other widget's names, when they can not
	be found from a function closure, say.


	The handlers do not have lazy evaluation. The value of
	\code{action} is the one at the time of creation of the
	widget. (See the example). In GTK, a means to cheat this is to pass in
	a gWidget instance, as the underlying GTK objects are stored
	as pointers, not copies, so that when queried, their current
	state is used.

	\describe{
	\item{\code{addHandlerChanged}:}{ This handler is called when a widget
	is "changed."  This is interpreted differently by the various
	widgets. For \code{gedit} change refers to a changed value,
	not a keystroke change (when ENTER is pressed). For notebooks,
	this is called when a page is changed.
	}

	\item{\code{addHandlerKeystroke}:}{ This handler is called when keys are
	pressed in the text widgets. The extra argument \code{key} is
	used to pass back the key code of the pressed key.
	}	

	\item{\code{addHandlerClicked}:}{This handler is called when a widget,
	such as a button or label, is clicked.
	}	

	\item{\code{addHandlerDoubleclick}:}{This handler is called when a
	widget is doubleclicked, like in the tree widget. Not all
	widgets receive a double click signal. Only when a single
	mouse click is needed for selection is this implemented.}

	\item{\code{addHandlerRightclick}:}{This handler is called
	when a widget is clicked with the right mouse button}

	\item{\code{addHandlerFocus}:}{This handler is called when a widget gains focus}

	\item{\code{addHandlerBlur}:}{This handler is called when a widget loses focus}


      	\item{\code{addHandlerMouseMotion}:}{This handler is called when a
	  the mouse moves over a widget. In some toolkits it is called
	  just once per visit to the widget, for others maybe multiple
	  times. This is like a mouseover for web pages. The drag motion
	  handler is similar, only it is called when a drag event is
	  dragged over a widget.}

	\item{ \code{addHandlerExpose}:}{ handler is called when a widget is
	exposed. For instance when a page in a notebook is exposed.}

	\item{ \code{addHandlerUnrealize}:}{ handler is called when a widget
	is being unrealized.}

	\item{ \code{addHandlerDestroy}:}{ handler is called when a widget
	is being destroyed. For top level windows, this usually allows
	one to intercept the window destroy event for purposes of saving
	work etc.}

	\item{ \code{addHandlerIdle}:}{ handler is called every so often,
	and can be used to update a widget's content. This method has
	an extra argument 
	\code{interval} specifying the interval in milliseconds with a
	default of 1000 or 1 second. }
        }

	Although not handlers, the \code{addPopupMenu} method adds a
	popup menu to a mouse click. The popup menu is specified using
	a list that is passed to \code{gmenu}.

	A refinement of this is the \code{add3rdMousePopupmenu} method
	which puts the popupmenu on the right mouse click.


	The method \code{removeHandler} is used to remove a handler from an object. If an ID is specified, just that handler is removed, otherwise all handlers will be. To temporarily disable a handler, use \code{blockHandler} then \code{unblockHandler}.

}
% \value{}
% \author{}
% \note{}

\seealso{\code{\link{gWidgets-methods}}}
\examples{
\dontrun{
	## a default handler, useful for when action is enough to
	## specify desired results

	handler.default = function(h,...) do.call(h$action,list(svalue(h$obj)))
	group = ggroup(horizontal=FALSE, container=gwindow("Click
		button"))
        button = gbutton("Click me", container=group)
	addhandlerclicked(button, handler=handler.default, action="print")


	## use two widgets, one to update the other
	group = ggroup(horizontal=FALSE, container=gwindow("two widgets"))
	button = gbutton("click me", container=group)
	label = glabel("Button has not been clicked", container=group)
	addhandlerclicked(button, handler = function(h,...) {
	svalue(h$obj) <-"click me again"
	svalue(h$action) <- "Button has been clicked"
	}, action = label)


	## lazy evaluation is not used here
	obj = 4
	gbutton("click",container=TRUE, handler=function(h,...)
	print(h$action), action=obj)
	obj = 2
	## now click button and value of 4 will be printed, not 2

	## Whereas, if one uses a gWidget we get the same as lazy
       ## loading
       obj = gedit("4")		 
	gbutton("click",container=TRUE, handler=function(h,...)
		print(svalue(h$action)), action=obj)
	svalue(obj) <- "2"
	## Now click and "2" is printed.

      ## remove handler, block handler, unblockhandler (latter two may not be implemented)
      b <- gbutton("click", container=gwindow())
      id <- addHandlerClicked(b, handler=function(h,...) print("ouch"))
      ## click --> "ouch"
      blockHandler(b, id) ## now click -- nothing
      unblockHandler(b, id) ## now click -- "ouch"
      removeHandler(b, id)  ## all gone now
}
}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{gcombobox}
\alias{gcombobox}
\alias{gdroplist}
\alias{[<-,gCombobox-method}
\title{Widgets to allow selection from a vector of items}
\description{

	A combobox allows selection of a value from a list of items
	using a popup menu. Additionally, the widget can combine a
	text entry widget for user input outside of the pre-set list
	of items. A combobox is useful for selection from a moderate
	size of items (2-30, say). For smaller sets of items, a radio
	button group is a possibility, for larger sets of items, a
	scrollable (and perhaps searchable) table may be preferred.

}
\usage{
gcombobox(items, selected = 1, editable = FALSE, coerce.with=NULL, handler = NULL, 
    action = NULL, container = NULL, ..., toolkit = guiToolkit())

gdroplist(items, selected = 1, editable = FALSE, coerce.with=NULL, handler = NULL, 
    action = NULL, container = NULL, ..., toolkit = guiToolkit()) 
}


\arguments{
  \item{items}{ Vector of values to select from. This may also be a data frame, in which case the first column is the vector of values, the second (if present) indicates a stock icon to display with the item (not all toolkits), and the third (if present) will indicate a tooltip to display (not all toolkits). }
  \item{selected}{ For gradio the initial selected value (as an index)
  		   For a drop list, the first selected value. Use 0 to
		     leave blank}
  \item{editable}{A logical indicating if the user can
  add an entry to the list of available answers}
  \item{coerce.with}{Apply this function to selected value before returning}
  \item{handler}{Called when selection is changed}
  \item{action}{Passed to handler when called.}
  \item{container}{Optional container to attach widget to}
  \item{\dots}{Passed to \code{add} method of container}
  \item{toolkit}{Which GUI toolkit to use}
}
\details{

	The initial \code{items} can be a vector or a data frame. Not
	all tool kits do something with the extra columns in the data
	frame.

	The \code{svalue} method returns the selected value by
	name. Assume the value is a character vector. Use the
	\code{coerce.with} argument to return a value of a different
	type. If the extra argument \code{index=TRUE} is specified,
	the index of the selected value is given.


	The \code{svalue<-} method can be used to set the selected
	value. This is done my name or if the argument
	\code{index=TRUE} is given by index. The value can be a data
	frame, in which case the first column is used to match against
	the current items.

	The \code{"["} method refers to the vector defining the items.

	The \code{"[<-"} method can be used to change the vector
	defining the items. 

	The \code{"length"} method returns the number of items.
	
	For \code{gcombobox} the argument \code{editable=TRUE} adds a
	text-edit box where the user can type in a selection. By
	default this value is returned as a character by
	\code{svalue}. Use \code{coerce.with} to coerce this prior to returning.

}
% \value{}
% \references{}
% \author{}
% \note{}
\seealso{

	A combobox is one of several ways to select a value of a set of items. See also 
\code{\link{gcheckbox}}, 
\code{\link{gradio}}, 
\code{\link{gcheckboxgroup}}, and
\code{\link{gtable}}.

Methods for gComponent objects are detailed in \code{\link{gWidgets-methods}}.

Event Handlers are detailed in \code{\link{gWidgets-handlers}}.



}
\examples{
\dontrun{
  flavors <- c("vanilla", "chocolate", "strawberry")

  f <- function(h,...) print(
      paste("Yum",
      paste(svalue(h$obj),collapse=" and "),
      sep = " "))

  w <- gwindow("combobox example")
  gp <- ggroup(container=w)
  glabel("Favorite flavor:", container=gp)
  cb <- gcombobox(flavors, editable=TRUE, container=gp, handler=f)

  svalue(cb) <- "vanilla"
  svalue(cb)
  cbg[3] <- "raspberry"

}

}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{gslider}
\alias{gslider}
\alias{gspinbutton}
\title{ Constructors for widgets to select a value from a sequence.}
\description{
	The gslider widget and gspinbutton widget allow the user to
	select a value from a sequence using the mouse. In the slider
	case, a slider is dragged left or right (or up or down) to
	change the value. For a spin button a text box with arrows
	beside allow the user to scroll through the values by clicking
	the arrows.

	Some toolkits only allow integer values for these.
}
\usage{
gslider(from = 0, to = 100, by = 1, length.out=NULL, along.with=NULL, 
value = from[1], horizontal = TRUE, handler = NULL, action = NULL, 
container = NULL, ..., toolkit = guiToolkit())

gspinbutton (from = 0, to = 10, by = 1, length.out=NULL, along.with=NULL, 
value = from, digits = 0, 
    handler = NULL, action = NULL, container = NULL, ..., toolkit = guiToolkit()) 
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{from}{Starting point in range. For \code{glider}, this may be a vector of values that
    can be sorted from \code{sort(unique(...))}. In this case, \code{to},
    \code{by}, etc. are ignored.}
  \item{to}{Ending point in range}
  \item{by}{Step size between values in the sequence}
  \item{length.out}{In place of by, take number of steps from this}
  \item{along.with}{In place of length.out, take length from this vector}
  \item{value}{ The initial value }
  \item{digits}{The number of digits shown}
  \item{horizontal}{Specifies orientation of gslider widget}
  \item{handler}{Called on a change event.}
  \item{action}{Passed to handler }
  \item{container}{ Optional container to attach widget to}
  \item{\dots}{Passed to \code{add} method of container}
    \item{toolkit}{Which GUI toolkit to use}

}
\details{
  
	Widgets to select from a vector of values. This vector is
	usually a sequence, as is returned by \code{seq}, hence the
	similar arguments, although the implementation is a bit less
	general, as \code{length.out} and \code{along.with} are used to
	compute \code{by} when given.
	

	For \code{gslider} any ordered vector may be used if specified
	to \code{from}.  Some toolkits only allow integer sequences, see
	the respective \pkg{gWidgetsXXX} packages for details.


	The \code{svalue} method returns the selected value. If all
	values are specified to \code{from}, then \code{index}
	argument is respected.

	The \code{svalue<-} method is used to set the selected value.
	If all values are specified to \code{from}, then \code{index}
	argument is respected.

	The \code{[<-} method can be used to change the sequence that the
	value is selected from. It expects a regular sequence, or if all
	values were originally specified to \code{from} a sortable
	sequence.

	The \code{addhandlerchanged} handler is called when the
	widgets' value is changed. 

}
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
  x <- rnorm(100)

  ## our handler
  plotHist <- function(...)
    hist(x, col=gray(svalue(sb)), breaks = svalue(sl))

   

  w <- gwindow("Slider and spinbox example")
  tbl = glayout(container=w)
  tbl[1,1] <- "Slide value to adjust shade"
  tbl[1,2] <- (sb <- gspinbutton(from=0,to=1,by=0.05,value=.5, container=tbl,
    handler=plotHist))
  tbl[2,1] <- "No. breaks"
  tbl[2,2, expand=TRUE] <- (sl <- gslider(from = 1, to= 100, by=1, value = 10,
    container = tbl, handler = plotHist))

## update slider using [<-
  sl[] <- seq(2,50, by=2)


  ## other sequence:
  w <- gwindow("Slider with sequence")
  sl <- gslider(letters, container=w)
  svalue(sl, index=TRUE)
  svalue(sl) <- "m"
  sl[] <- LETTERS ## can be sorted via sort(unique(LETTERS))
}
}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{gWidgets-icons}
\alias{gWidgets-icons}
\alias{addStockIcons}
\alias{getStockIcons}
\alias{stockIconFromClass}
\alias{stockIconFromObject}
\alias{.addStockIcons,ANY-method}
\alias{.getStockIcons,ANY-method}
\alias{.stockIconFromClass,ANY-method}
\alias{.stockIconFromObject,ANY-method}

\title{Functions for adding icons}
\description{
  Two functions for listing "stock" icons, and adding "stock" icons. A
  stock icon can be referenced within gWidgets by its simple name, such
  as "ok" or "close". 
}
\usage{
addStockIcons(iconNames, iconFiles, ...,toolkit=guiToolkit())

getStockIcons(..., toolkit=guiToolkit())
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{iconNames}{A vector of icon names}
  \item{iconFiles}{A matching vector of filenames for the icons}
  \item{...}{ignored}
  \item{toolkit}{Which toolkit to use}
}
\details{
  The file type must be supported by the toolkit. The \code{tcltk}
  supports few filetypes without additional libraries.
}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
 iconNames <- c("larrow","rarrow")
 iconFiles <= c("/usr/share/icons/larrow.png",
    "/usr/share/icons/rarrow.png")
 addStockIcons(iconNames, iconFiles)
}
}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{gstatusbar}
\alias{gstatusbar}

\title{Constructor of status bar widget}
\description{
  A status bar widget is used to send message to the user. A familiar
  instance is the bottom area of a web browser. 
  }
\usage{
gstatusbar(text = "", container = NULL, ..., toolkit = guiToolkit())
}

\arguments{
  \item{text}{Initial text of status bar}
  \item{container}{Optional container to attach widget to. Should be
  \code{gwindow} object}
  \item{\dots}{Passed to \code{add} method of container}
  \item{toolkit}{Which GUI toolkit to use}
}
\details{
 The status bar simply shows a message in a label, typically at the bottom of a window.
 The \code{svalue} and \code{svalue<-} methods can be used to query or set the text.
 message onto the stack.

 Statusbars should be added to the top-level gwindow instance.
}
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
  w <- gwindow("status bar example")
  tbl <- list(quit=list(icon="quit",
    handler = function(...) dispose(w)))
  tb <- gtoolbar(tbl, container=w)
  sb <- gstatusbar("", container=w)
  txt <- gtext("type here", container=w)
  addHandlerChanged(txt, handler=function(h,...)
    svalue(sb) <- paste("You typed",svalue(txt),"in the  box",collapse=" "))

}
}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{gWidgets-dialogs}
\alias{gWidgets-dialogs}
\alias{gmessage}
\alias{galert}
\alias{gconfirm}
\alias{ginput}
\alias{gbasicdialog}

\title{Basic dialog constructors}
\description{
  A dialog is a widget that draws its own window. These dialogs are used
  for simple things -- confirming a choice, gathering a single line of
  input, etc. Dialogs are always modal, meaning they must be closed
  before R can be interacted with again.
}
\usage{
gmessage(message, title="message",
icon = c("info", "warning", "error", "question"),
        parent = NULL,
     handler = NULL, 
    action = NULL, ..., toolkit=guiToolkit()) 

ginput(message, text="", title="Input", icon = c("info", "warning",
 "error", "question"), parent=NULL, 
 handler = NULL, action = NULL,..., toolkit=guiToolkit())

gconfirm(message, title="Confirm", icon = c("info", "warning", "error",
 "question"), parent=NULL,
 handler = NULL, action = NULL, ..., toolkit=guiToolkit())

gbasicdialog(title = "Dialog", widget, parent=NULL, do.buttons=TRUE, 
handler = NULL, action=NULL,  ..., toolkit=guiToolkit())

galert(message, title = "message", delay=3, parent=NULL, ..., toolkit=guiToolkit())
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{message}{Message shown for widget}
  \item{title}{Title of window}
  \item{icon}{Which icon to show}
  \item{text}{default value for ginput text}
  \item{widget}{Widget to place in basic dialog. If missing, dialog returns a container.}
  \item{parent}{A gwindow() instance. If specified, dialog will be
    located in relation to this}
  \item{do.buttons}{For \code{gbasicdialog} -- when no \code{widget}
    argument is passed in -- this can be used to suppress the addition of
    Ok and Cancel buttons. If suppressed, the dialog can be closed by the
    window manager or programattically through the \code{dispose} method.}
  \item{handler}{Handler called on OK selection.}
  \item{action}{Value passed to handler}
  \item{delay}{For galert, how long the transient message will appear}
  \item{\dots}{Ignored}
  \item{toolkit}{Toolkit to use for GUI}
}
\details{
  These basic dialogs do slightly different things.

  The \code{gmessage} dialog shows a message with an icon and a dismiss
  button. This dialog returns \code{TRUE} or \code{FALSE} as
  appropriate. 

  The \code{gconfirm} dialog shows a message with an icon and an OK
  button and a dismiss button. A handler may be attached to the OK
  button selection. This dialog returns \code{TRUE} or \code{FALSE} as
  appropriate. 

  The \code{ginput} dialog adds an edit box for gathering user
  information. The \code{text} argument sets the default value. This is
  then passed to the handler via the component \code{input} of the first
  argument of the handler. This dialog returns the value of the string
  if OK is clicked, otherwise \code{NA}.

  The \code{gbasicdialog} widget wraps a dialog (with buttons) around
   a widget. For \pkg{gWidgetsRGtk2} and \pkg{gWidgetsQt} the widget may be specified throuh the
   \code{widget} argument of the constructor. The constructor produces
   a modal dialog, hence no methods are defined. The return value is a
   logical indicating which button was clicked.

  More portably (hence encouraged), if the \code{widget} argument is NULL, then the
  constructor produces a container. This container becomes modal after a
  call to \code{visible(..., set=TRUE)} (not the assignment version
  though). Again the return value is a logical.  This too creates a
  modal dialog. The handler specified to the constructor is called when
  OK is clicked and \code{TRUE} is returned. The value of \code{FALSE}
  is returned on cancel, and \code{NA} otherwise.

  The buttons may be suppressed by setting the argument
  \code{do.buttons=FALSE}. The
  dialog then may be closed by calling the \code{dispose} method
  within a callback.


  These dialogs are modal. This means that the R session freezes until
  the dialog is dismissed. This may be confusing to users if the window
  should appear below a currently drawn window.

  The \code{galert} dialog is non-modal and does not grab the
  focus. Like \code{gmessage} it shows a message but unlike it, only
  for a short period of time and is unobtrusive.

}
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
   gmessage("Hi there")
   gconfirm("Are we having fun?", handler = function(h,...)
   print("Yes"))

   ginput("Enter your name", icon="question", handler = function(h,...) cat("Hi",h$input,"\n"))

   ## gbasicdialog
   w <- gbasicdialog(title="Select a state", handler = function(h,...) 
      print(svalue(tbl)))
   tbl <- gtable(data.frame(states = rownames(state.x77)), expand=TRUE, container = w)
   visible(w, set=TRUE) ## show dialog

}
}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{ghtml}
\alias{ghtml}
\title{Constructors for widgets to handle text input}
\description{
  The ghtml widget is intended to show HTML text either from a url or
  from a character string. Currently no toolkits support this widget, although it is in gWidgetsWWW.
}
\usage{
ghtml(x, handler = NULL, action = NULL, container = NULL, ..., toolkit = guiToolkit())

}
\arguments{
  \item{x}{url or HTML-marked up character string to load into widget.}
  \item{handler}{(In theory, not implemented yet) Handles a click on a URL. The default is to open the
     clicked url in the widget. To override, the first argument,
     a list \code{h}, has component \code{h\$url} containing the url.}
  \item{action}{ Passed along to the  handler as \code{h\$action}}
  \item{container}{Optional container to attach widget to}
  \item{\dots}{Passed to \code{add} method of container}
  \item{toolkit}{Which GUI toolkit to use}
}
\details{
  This widget loads the given url into a widget. Currently no toolkits
  support this.

  The \code{svalue} method returns the current url or character string.

  The \code{svalue<-} method loads a url or character string
  in the widget.

}
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
  ghtml(system.file("html","gedit.html",package="gWidgets"),
    container = gwindow())
}
}
\keyword{interface }

\name{ggenericwidget}
\alias{ggenericwidget}
%%\alias{autogenerategeneric}
%%\alias{geditlist}
%%\alias{geditnamedlist}
%%\alias{gvariables}

\title{A constructor to create widgets for evaluating functions}
\description{
  This constructor creates a widget for collecting arguments for a
  function using a list to define the widget's components. When called
  with a function name a list is created on the fly which can be used as
  is, or modified as desired.
}
\usage{
ggenericwidget(lst,  cli = NULL, container = NULL, ..., toolkit = guiToolkit())
}

%% also could do:
%autogenerategeneric(f, help = fName, variableType = NULL)

%geditlist(...) 

%geditnamedlist(...)

%gvariables(variableType = NULL, ...) 

\arguments{
  \item{lst}{Either a list defining the widget or a function name as a
    string. In the latter case, the defining list may be retrieved by
    the \code{svalue} method.}
%%  \item{variableType}{Type of variable. One of
%%  \code{c("univariate","univariatetable", "bivariate", "model",
%%    "lattice")}}
  \code{x=} for initial variable name.
  \item{cli}{An instance of \code{gcommandline} or NULL. If NULL, then a
  new command line pops up in its own window}
  \item{container}{Optional container to attach widget to}
%%  \item{f}{Name of function}
%%  \item{help}{What man page should be used to look up arguments to function}
  \item{\dots}{Currently ignored by \code{ggenericwidget}, but passed
    along to \code{gedit} by \code{geditlist} and \code{geditnamedlist}}
  \item{toolkit}{Which GUI toolkit to use}
}
\details{
  
  This widget provides an easy way to create dialogs that collect the
  arguments for a function evaluation. When the OK button is clicked,
  the arguments are collected and passed along to the function specified
  via the \code{action} part of the list. When collecting the arguments,
  empty strings are not passed along. 

  The easiest usage is to simply provide a function name and have
  \code{autogenerategeneric} take a stab. However, in the long run it
  might be better to use \code{autogenerategeneric} to create an initial
  list, and then modify this to adjust the widget's look.

  
  The list contains several named components
  \describe{
  \item{title}{The title for the widget}
  \item{help}{What help page is called}
  \item{type}{Either "text" or "graphic." Currently ignored.}
  \item{variableType}{Describes the type of variable. Either
    "univariate", "univariatetable","fileurl","bivariate", "model",
    "lattice", "lmer" or \code{NULL}. 
    This value is passed directly to \code{gvariables}.
    For non-NULL values, the widget shows an
    appropriate area for collecting the main variable. For the
    model and lattice interfaces buttons allow editing of fields
    by subsequent dialogs. }
  \item{variableTypeExtras}{An optional list with components \code{name}
    and \code{value} containing a name and value passed along to the
    constructor for the variable type. Useful to override default
  }
  \item{assignto}{If TRUE, creates box for collecting name for
    assigning output}
  \item{action}{a list with named components \code{beginning}
    and \code{ending}. The arguments are collected and pasted
    together to form a string containing the R command to
    execute. These get put at the beginning and end of the
    string. A typical pair would be something like "prop.test("
    and ")".}
  \item{arguments}{a list with named components. In the simplest
    usage the names are argument names, and the components are
    lists with entries that create the corresponding widget. The
    first such component is called \code{type} and is the name of
    a gWidget, such as \code{"gradio"}. Subsequent components are
    passed to this function using \code{do.call}.

    The constructors \code{geditlist} and \code{geditnamedlist} can be
    used when the input is to be a list of values or a list of named values.
    
    In the more complicated cases, these named components can be
    grouped into a list component. The name of this is then used
    to block the arguments. See the example.
  }
  }	   

  The \code{svalue} method returns the value of the list. This can be
  used to retrieve the list that is created when the constructor is
  called with a function name.
  
}
% \value{}
% \references{}
% \author{}
\note{This function may be improved and the list defining it changed.}
%\seealso{}
\examples{
\dontrun{
	## a sample list definition
## Save some typing by defining a list to be used more than once later
TRUE.list <- list(
  type = "gradio",
  items = c("TRUE","FALSE")
  )

## define a list for producing a histogram widget	  
hist.list <- list(
  title = "hist()",
  help = "hist",
  action = list(
    beginning = "hist(",
    ending = ")"
    ),
  type = "graphic",                      # either text or graphic
  variableType = "univariate",           # single variable
  arguments = list(
    adjustments = list(
      breaks= list(
        type="gdroplist",
        items=c("\"Sturges\"","\"Scott\"","\"Friedman-Diaconis\"")
        ),
      probability = TRUE.list,
      include.lowest = TRUE.list,
      right = TRUE.list,
      shading = list(
        density = list(
            type="gedit",
            text=NULL
        ),
      angle = list(
        type="gedit",
        coerce.with="as.numeric",
        text="45"
        )
        )
      )
    )
  )

ggenericwidget(hist.list, container=TRUE)
## or to autogenerate one
ggenericwidget("boxplot.default", container=TRUE)
	
}
}
\keyword{interface}

\name{guiWidget-class}
\docType{class}
\alias{guiWidget-class}
\alias{guiComponent-class}
\alias{guiContainer-class}
\alias{guiDialog-class}
\alias{guiWidgetOrNULL-class}
\alias{gWidgetANY-class}
\alias{gComponentANY-class}
\alias{gContainerANY-class}

\title{Class "guiWidget" ~~~ }
\description{Base class for gWidget objects}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("guiWidget", ...)}.

	These objects have two slots: a widget provided by a
	guiToolkit and a toolkit. Method dispatch is done on both values.

}
\section{Slots}{
	 \describe{
    \item{\code{toolkit}:}{Object of class
    \code{"guiWidgetsToolkit"}. A specification of which GUI toolkit
    the widget uses.}
    \item{\code{widget}:}{Object of class \code{"ANY"}. A widget
    returned by the corresponding toolkit function. }
  }
}
\section{Methods}{
  \describe{
    \item{.add}{\code{signature(obj = "guiWidget", toolkit = "guiWidgetsToolkitRGtk2", value = "ANY")}: ... }
    \item{.add}{\code{signature(obj = "guiWidget", toolkit = "guiWidgetsToolkitRGtk2", value = "guiWidgetORgWidgetRGtkORRGtkObject")}: ... }
    \item{.add}{\code{signature(obj = "gContainerRGtk", toolkit = "guiWidgetsToolkitRGtk2", value = "guiWidget")}: ... }
    \item{.add}{\code{signature(obj = "gMenuRGtk", toolkit = "guiWidgetsToolkitRGtk2", value = "guiWidget")}: ... }
    \item{.add}{\code{signature(obj = "gNotebookRGtk", toolkit = "guiWidgetsToolkitRGtk2", value = "guiWidget")}: ... }
    \item{.add}{\code{signature(obj = "gTextRGtk", toolkit = "guiWidgetsToolkitRGtk2", value = "guiWidget")}: ... }
    \item{.delete}{\code{signature(obj = "gContainerRGtk", toolkit = "guiWidgetsToolkitRGtk2", widget = "guiWidget")}: ... }
    \item{.delete}{\code{signature(obj = "RGtkObject", toolkit = "guiWidgetsToolkitRGtk2", widget = "guiWidget")}: ... }
    \item{.delete}{\code{signature(obj = "gMenuRGtk", toolkit = "guiWidgetsToolkitRGtk2", widget = "guiWidget")}: ... }
    \item{.svalue<-}{\code{signature(obj = "gMenuRGtk", toolkit = "guiWidgetsToolkitRGtk2", value = "guiWidget")}: ... }
    \item{.tag}{\code{signature(obj = "guiWidget", toolkit = "guiWidgetsToolkitRGtk2")}: ... }
    \item{.tag<-}{\code{signature(obj = "guiWidget", toolkit = "guiWidgetsToolkitRGtk2")}: ... }
    \item{[}{\code{signature(x = "guiWidget")}: ... }
    \item{[<-}{\code{signature(x = "guiWidget")}: ... }
    \item{add3rdmousepopupmenu}{\code{signature(obj = "guiWidget")}: ... }
    \item{add}{\code{signature(obj = "guiWidget")}: ... }
    \item{addSpace}{\code{signature(obj = "guiWidget")}: ... }
    \item{addSpring}{\code{signature(obj = "guiWidget")}: ... }
    \item{adddropmotion}{\code{signature(obj = "guiWidget")}: ... }
    \item{adddropsource}{\code{signature(obj = "guiWidget")}: ... }
    \item{adddroptarget}{\code{signature(obj = "guiWidget")}: ... }
    \item{addhandlerchanged}{\code{signature(obj = "guiWidget")}: ... }
    \item{addhandlerclicked}{\code{signature(obj = "guiWidget")}: ... }
    \item{addhandlerdestroy}{\code{signature(obj = "guiWidget")}: ... }
    \item{addhandlerdoubleclick}{\code{signature(obj = "guiWidget")}: ... }
    \item{addhandlerexpose}{\code{signature(obj = "guiWidget")}: ... }
    \item{addhandleridle}{\code{signature(obj = "guiWidget")}: ... }
    \item{addhandlerkeystroke}{\code{signature(obj = "guiWidget")}: ... }
    \item{addhandlerrightclick}{\code{signature(obj = "guiWidget")}: ... }
    \item{addhandlerunrealize}{\code{signature(obj = "guiWidget")}: ... }
    \item{addpopupmenu}{\code{signature(obj = "guiWidget")}: ... }
    \item{defaultWidget}{\code{signature(obj = "guiWidget")}: ... }
    \item{defaultWidget<-}{\code{signature(obj = "guiWidget")}: ... }
    \item{delete}{\code{signature(obj = "guiWidget")}: ... }
    \item{dim}{\code{signature(x = "guiWidget")}: ... }
    \item{dimnames}{\code{signature(x = "guiWidget")}: ... }
    \item{dimnames<-}{\code{signature(x = "guiWidget")}: ... }
    \item{dispose}{\code{signature(obj = "guiWidget")}: ... }
    \item{editable}{\code{signature(obj = "guiWidget")}: ... }
    \item{editable<-}{\code{signature(obj = "guiWidget")}: ... }
    \item{enabled}{\code{signature(obj = "guiWidget")}: ... }
    \item{enabled<-}{\code{signature(obj = "guiWidget")}: ... }
    \item{focus}{\code{signature(obj = "guiWidget")}: ... }
    \item{focus<-}{\code{signature(obj = "guiWidget")}: ... }
    \item{tooltip<-}{\code{signature(obj = "guiWidget")}: ... }
    \item{font}{\code{signature(obj = "guiWidget")}: ... }
    \item{font<-}{\code{signature(obj = "guiWidget")}: ... }
    \item{id}{\code{signature(obj = "guiWidget")}: ... }
    \item{id<-}{\code{signature(obj = "guiWidget")}: ... }
    \item{length}{\code{signature(x = "guiWidget")}: ... }
    \item{names}{\code{signature(x = "guiWidget")}: ... }
    \item{names<-}{\code{signature(x = "guiWidget")}: ... }
    \item{removehandler}{\code{signature(obj = "guiWidget")}: ... }
    \item{size}{\code{signature(obj = "guiWidget")}: ... }
    \item{size<-}{\code{signature(obj = "guiWidget")}: ... }
    \item{svalue}{\code{signature(obj = "guiWidget")}: ... }
    \item{svalue<-}{\code{signature(obj = "guiWidget")}: ... }
    \item{tag}{\code{signature(obj = "guiWidget")}: ... }
    \item{tag<-}{\code{signature(obj = "guiWidget")}: ... }
    \item{update}{\code{signature(object = "guiWidget")}: ... }
    \item{visible}{\code{signature(obj = "guiWidget")}: ... }
    \item{visible<-}{\code{signature(obj = "guiWidget")}: ... }
    \item{isExtant}{\code{signature(obj = "guiWidget")}: ... }
	 }
}
\author{John Verzani}
\note{
	Within gWidgets there are three main subclasses guiContainers,
	guiComponents and guiDialogs. The distinctions are more clear
	at the toolkit level.


}
% \seealso{}
% \examples{}
\keyword{classes}

\name{gtext}
\alias{gtext}
\title{Constructor for widget for multi-line editable text input}
\description{
	The
	\code{gtext} widget creates a text buffer for handling multiple lines
	of text. 
}
\usage{
gtext (text = NULL, width = NULL, height = 300, font.attr = NULL, 
    wrap = TRUE, handler = NULL, action = NULL, container = NULL, 
    ..., toolkit = guiToolkit()) 
}
\arguments{
  \item{text}{Initial text in widget}
  \item{width}{Width of widget in pixels}
  \item{height}{Height of gtext widget in pixels}
  \item{font.attr}{Optional specification of font attributes}
  \item{wrap}{For gtext, are long lines wrapped?}
  \item{handler}{Handler called when text is changed.}
  \item{action}{ Passed to handler}
  \item{container}{Optional container to attach widget to}
  \item{\dots}{Passed to add method of container}
  \item{toolkit}{Which GUI toolkit to use}
}
\details{
	The \code{gtext} widget has the following methods.

	The \code{svalue} method returns the text held in the
	buffer. If \code{drop=TRUE}, then only the text in the
	currently selection is returned.

	The \code{svalue<-} method replaces the text in the buffer
	with the new text.

	New text is added with the \code{insert} method. The basic
	usage is \code{insert(obj,text)} where "text" could be a
	single line or a vector of text, or --for gWidgetsRGtk2 -- a
	gwidget (although some, like gedit, are kind of flaky). Extra
	arguments include \code{do.newline} a logical indicating if a
	new line after the last line should be added (default is
	\code{TRUE}); \code{font.attr} to specify any font attributes;
	\code{where} indicating where to add the text (either
	\code{end} or \code{beginning}). The \code{insert} generic
	replaces the overused \code{add} for \code{gtext}, but
	\code{add} will still work.

	The font can be changed. The \code{font.attr} argument to the
	constructor is used to specify font properties for the
	buffer. When specifed to the \code{add} method, the font
	specification applies to the new text. Both uses use a named
	character vector to specify the font properties. For instance
	\code{c(style="normal", weights="bold",sizes="medium")}.  The
	command \code{obj[['tags']]} will produce a list containing
	all the available attributes.

	The \code{font<-} method is used to change the font of the
	currently selected text. It too takes a named character vector
	specifying the font attributes. If there is no currently selected text, the 
	entire buffer will have the new font attribute.

	The \code{dispose} method clears the text in the buffer.

	The \code{addHandlerKeystroke} method for \code{gedit}and
	\code{gtext} is called for 
	each keystroke. In \code{gtext} or \code{RGtk2} the component
	\code{key} of the \code{h} argument contains the keystroke.

      }
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
        ## gtext example
        obj <- gtext("First line", container=gwindow())
	insert(obj,"second line", font.attr=c(family="monospace"))
        insert(obj,"third line", font.attr=c(foreground.colors="red"))
}
}
\keyword{interface }

\name{ggroup}
\alias{ggroup}
\alias{gframe}
\alias{gexpandgroup}
\title{Box containers for packing in subsequent widgets}
\description{

	Various box containers useful for laying out GUI controls. These
	containers pack in child widgets from left to right or top to
	bottom. A few arguments can be used to adjust the sizing and positioning.

}
\usage{
ggroup(horizontal = TRUE, spacing = 5,  use.scrollwindow = FALSE, 
container = NULL, ..., toolkit = guiToolkit())

gframe(text = "", markup = FALSE, pos = 0, horizontal=TRUE, container = NULL, 
    ..., toolkit = guiToolkit()) 
gexpandgroup(text = "", markup = FALSE, horizontal=TRUE, handler = NULL, 
action = NULL, 
    container = NULL, ..., toolkit = guiToolkit())
}
\arguments{
  \item{horizontal}{Specifies if widgets are packed in left to right
	or top to bottom (\code{FALSE})}
  \item{spacing}{Space in pixels around each widget. Can be changed
	with \code{svalue}}
  \item{text}{Text for label}
  \item{markup}{Optional markup. (See \code{\link{glabel}} for details.)}
  \item{pos}{Where to place label: 0 is to left, 1 to right,
  interpolates.}
  \item{handler}{Called when expand arrow is clicked}
  \item{action}{Passed to handler}
  \item{use.scrollwindow}{If \code{TRUE} then group is placed in a
  scrollwindow allowing panning with mouse.}
  \item{container}{Optional container to attach widget to. Not optional
    for gWidgetstcltk, or gWidgetsRwxwidgets}
  \item{\dots}{Passed to the \code{add} method of the container}
  \item{toolkit}{Which GUI toolkit to use}
}
\details{


	A \code{ggroup} is the primary container for packing in
	subsequent widgets, either from left to right or top to
	bottom. Widgets are packed in using the \code{add} method and
	can be removed with the \code{delete} method.
	
	The \code{gframe} container adds a decorative border and
	optional label to the box container.

	The \code{gexpandgroup} containers has an optional label and a
	trigger to click  on which toggles the display of the the child widgets.
	By default, the child widgets are not shown. Using the \code{visible<-} method to adjust.
  
	The containers pack in child widgets from either left to right
	(when \code{horizontal=TRUE}) or from top to bottom (when
	\code{horizontal=FALSE}).
	
	Child widgets are added to box containers through their
	\code{add} method or through the containers use as the parent
	container when a widget is constructed. This is done by using
	the \code{container} argument of the widget.  The
	\code{container} argument is not optional for
	\pkg{gWidgetstcltk}.  It is suggested that it always be included
	for portability. When it is not included, widgets are added to
	the new group object through its \code{add} method. Otherwise, when a
	widget is created, the group is specified as the container and
	the add method is then called implicitly, with the constructor's
	\code{...} argument used to pass arguments to \code{add}.
	
	When the parent allocates space to a child widget it
	be possible to allocate more space than is requested by the
	child widget. The child may then be
	positioned in the available space by specifying the
	\code{anchor=c(a,b)} argument to \code{add} where \code{a}
	and \code{b} are values in -1,0,1 and specify the position using
	Cartesian coordinates.

	If the argument \code{expand=TRUE} to \code{add} is given, then the space
	available to the child expands.  The child widget can be
	instructed to grow to fill the space. The \code{add} method's argument \code{fill},
	with values \code{"both"}, \code{"x"}, \code{"y"} or \code{""},
	instructs the child as to which direction to grow in. (The
	\code{""} value says none.)

	The implementation of \code{expand}, \code{anchor}, \code{fill}
	varies with the underlying toolkit. The basic language comes
	from \pkg{tcltk} and an attempt -- not entirely successful -- is
	made to implement it in the \pkg{gWidgetsRGtk2} and
	\pkg{gWidgetsQt} packages.

	A child component may be deleted using \code{delete(parent,
	child)}. TYpically the child may be replaced in the GUI, using \code{add}.
	
	The \code{spacing} argument determines the number of pixels of
	padding between each widget when packed in. This can be set when
	the group is constructed, or later using \code{svalue<-}.

	The argument \code{use.scrollwindow = TRUE}
	will add scrollbars around the box container. When the child
	components require more size than is given to the container, the
	scroll bars allow one to position the viewable area over the
	child of interest. Again, not all toolkits do this equally well.
	
	
	To put space between two adjoining widgets, the
	\code{addSpace(obj, value, ...)}  method may be used where
	\code{value} is the number of pixels of padding between the just
	packed widget, and the next one to be packed.


	The \code{addSpring(obj,...)} method will push the just packed
	widget and the next-to-be packed widget as far apart as possible.
	

	For \code{ggroup}, in \code{gWidgetsRGtk2} a few arguments add
	to the container.  The argument \code{raise.on.dragmotion =
	TRUE} will cause the group to jump to the foreground when a drag
	action crosses it.
	For \code{gframe} and \code{gexpandgroup} the label name can be
	retrieved or adjusted with the \code{names} method.

	For \code{gframe} and \code{gexpandgroup} the label can be
	adjusted through the \code{names<-} method.
	
	For \code{gexpandgroup} the \code{visible} method can be used
	to toggle the display programmatically.

	
      }
% \value{}
% \references{}
% \author{}
% \note{ }
\seealso{For top-level containers \code{\link{gwindow}}, for containers
  to display more than one child widget see \code{\link{gpanedgroup}},
  \code{\link{gnotebook}}, \code{\link{glayout}}}
\examples{
\dontrun{
  ## basic group 
  group <- ggroup(horizontal=FALSE, container=gwindow())
  l <- glabel("widget 1")  ## not in gWidgetstcltk -- needs a container
  add(group, l)
  glabel("widget 2", container = group) ## style for all toolkits

  ## nested groups
  group <- ggroup(horizontal=FALSE, container=gwindow())
  innergroup <- ggroup(container = group)
  gtext("Text area", container=group)
  gbutton("button 1", container = innergroup)
  gbutton("button 2", container = innergroup)

  ## expand argument
  group <- ggroup(horizontal=FALSE, container=gwindow())
  gbutton("no expand", container=group)
  gbutton("expand=TRUE", container=group, expand=TRUE)

  ## anchor argument
  w <- gwindow("Anchor")
  size(w) <- c(500,500)
  group <- ggroup(container=w)
  glabel("upper left", container=group, anchor=c(-1,1))
  glabel("lower right", container=group, anchor=c(1,-1))

  ## add spring
  group <- ggroup(container=gwindow("menubar-like example"))
  gbutton("File",handler=function(h,...) print("file"), container=group)
  gbutton("Edit",handler=function(h,...) print("edit"), container=group)
  addSpring(group)				   
  gbutton("Help",handler=function(h,...) print("help"), container=group)


  ## delete and add
  w <- gwindow("Delete and add", visible=FALSE)
  g <- ggroup(container=w)
  b <- gcheckbox("hide", checked=FALSE, container=g)
  l <- gedit("click checkbox to hide me", container=g)
  addHandlerClicked(b, handler=function(h,...) {
     if(svalue(b))
       delete(g, l)
     else
       add(g, l)
  })
  visible(w) <- TRUE
}
}
\keyword{ interface }

\name{gcheckbox}
\alias{gcheckbox}
\alias{[<-,gCheckbox-method}
\title{

Constructor of widget to indicate whether a value is desired or not

}
\description{
	A checkbox shows a value and a box to  check indicating if the
	value is desired or not.
}
\usage{
gcheckbox(text, checked = FALSE, use.togglebutton=FALSE, handler = NULL, action = NULL,
container = NULL, ..., toolkit = guiToolkit())
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{text}{Text to show by box}
  \item{checked}{Logical indicating initial state of box}
  \item{use.togglebutton}{Logical indicating if a toggle button should be used (depresses when \code{TRUE}) in place of a check box}
  \item{handler}{ Called when box is toggled.}
  \item{action}{ Passed to handler}
  \item{container}{ Optional container to attach widget to.}
    \item{...}{Not documented, currently has no role.}
  \item{toolkit}{Which toolkit to use?}
}
\details{
	The value of the widget is either \code{TRUE} or \code{FALSE}.

	The \code{svalue} method returns a logical indicating
	\code{TRUE} if the box is checked.

	The \code{svalue<-} method can be used to set the value
	using a logical.

	The \code{"["} method returns the label on the box.

	The \code{"[<-"} method can be used to change the label on the
	box.

	The default handler is set by the \code{addHandlerClicked}
	method. This is called when the button is 
	toggled. If one wishes to have the handler called only when
	checked to indicate \code{TRUE}, say, one should check the state
	of the widget in the handler (e.g., \code{if(svalue(h$obj))}).
}
%%\value{}
%%\references{}
\author{John Verzani}
%%\note{}
\seealso{

Methods for gComponent objects are detailed in \code{\link{gWidgets-methods}}.

Event Handlers are detailed in \code{\link{gWidgets-handlers}}.


}
\examples{
\dontrun{
 gcheckbox("checked", container=TRUE, handler=function(h,...) {
   cat("The widget is checked?",svalue(h$obj), "\n")
})
}
}
\keyword{ interface }

\name{gradio}
\alias{gradio}
\alias{[<-,gRadio-method}
\title{Radio button group widget}
\description{

	A radio group allows the user to select one value from a set
	of items. The items may be displayed horizontally or
	vertically.

}
\usage{
gradio(items, selected = 1, horizontal = FALSE, handler
= NULL, action = NULL, container = NULL, ..., toolkit = guiToolkit())
}


\arguments{
  \item{items}{ Vector of values to select from }
  \item{selected}{ The initial selected value (as an index). Radio groups must have a selection}
  \item{horizontal}{A logical specifying the  layout for gradio}
  \item{handler}{Called when selection is changed}
  \item{action}{Passed to handler when called.}
  \item{container}{Optional container to attach widget to}
  \item{\dots}{Passed to \code{add} method of container}
  \item{toolkit}{Which GUI toolkit to use}
}
\details{
	The \code{svalue} method returns the selected value by
	name. If the extra argument \code{index=TRUE} is specified,
	the index of the selected value is given. 


	The \code{svalue<-} method can be used to set the selected
	value. One can specify the value by name or by index if
	\code{index=TRUE} is specified.

	The \code{"["} method refers to the vector defining the items.

	The \code{"[<-"} method can be used to change the vector
	defining the items. 

	The \code{"length"} method returns the number of items.
	
}
% \value{}
% \references{}
% \author{}
% \note{}
\seealso{

The radio group is one of several widgets useful to selecting a value
or values from a set of items. See also \code{\link{gcheckbox}},
\code{\link{gcheckboxgroup}}, \code{\link{gcombobox}}, and
\code{\link{gtable}}

Methods for gComponent objects are detailed in \code{\link{gWidgets-methods}}.

Event Handlers are detailed in \code{\link{gWidgets-handlers}}.

}
\examples{
\dontrun{

  flavors <- c("vanilla", "chocolate", "strawberry")

  w <- gwindow("Radio example", visible=FALSE)
  gp <- ggroup(container=w)
  glabel("Favorite flavor:",container=gp, anchor=c(0,1))
  rb <- gradio(flavors, container=gp)
  addHandlerClicked(rb, handler=function(h,..) {
   cat(sprintf("You picked \%s\n", svalue(h$obj)))
  })
  visible(w) <- TRUE
  
  betterFlavors <- c("coffee", "mint chip")
  rb[] <- betterFlavors 
  rb[] <- c(betterFlavors, "chocolate") # some toolkits don't allow change of length
  
  rb[3] <- "mango sorbet" ## can change a label name

  ## set values
  svalue(rb) <- "coffee"  ## by name
  svalue(rb, index=TRUE) <- 1  ## by index

  ## get selected values
  svalue(rb)
  svalue(rb, index=TRUE)

}

}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{gcommandline}
\alias{gcommandline}
\title{A command line interface}
\description{
  This constructs a simple command line interface for R
}
\usage{
gcommandline(command = "", assignto = NULL, useGUI = TRUE, 
useConsole = FALSE, prompt = getOption("prompt"), width = 500, 
height = 0.6 * width, container = NULL, ...,toolkit =
                 guiToolkit())
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{command}{Initial command to evalues }
  \item{assignto}{Assigns output to this variable is non-NULL}
  \item{useGUI}{Is result also printed to GUI. Use FALSE to get
    text-only instance}
  \item{useConsole}{Is result also printed to console?}
  \item{prompt}{Prompt to use}
  \item{width}{Width of widget in pixels}
  \item{height}{Height of widget in pixels}
  \item{container}{Optional container to attach to}
  \item{\dots}{Ignored for now}
  \item{toolkit}{Which GUI toolkit to use}
}
\details{
  
  Additional commands can be added programmatically with the
  \code{svalue<-} method. The The value assigned is a string containing
  the command. If it has a \code{names} attribute, this is taken as the
  variable name to assign the output to.

  The \code{svalue} method returns the command history.

  The \code{"["} method can be used to retrieve the command history as well.
}
% \value{}
% \references{}
% \author{}
% \note{}
% \seealso{}
\examples{
\dontrun{
  obj = gcommandline(container=TRUE)
  svalue(obj) <- "2+2"
  ## assign to x
  command = "rnorm(100)"; names(command) = "x"
  svalue(obj) <- command
  ## look at history
  obj[]
}
}
\keyword{interface}% at least one, from doc/KEYWORDS

\name{guiToolkit}
\alias{guiToolkit}
\alias{gtoolkit}
\alias{guiWidgetsToolkit-class}
\alias{guiWidgetsToolkitRGtk2-class}
\alias{guiWidgetsToolkitrJava-class}
\alias{guiWidgetsToolkitSJava-class}
\alias{guiWidgetsToolkittcltk-class}
\alias{guiWidgetsToolkitRwxWidgets-class}
\title{Function to select the GUI toolkit used by gWidgets}
\description{
	A GUI toolkit is a separate package that implements the
	gWidgets API. This function allows one to select the toolkit
	to be used by default.
}
\usage{
guiToolkit(name = NULL)

gtoolkit()
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{name}{The name matches the package name without the initial
  gWidgets. For instance, "RGtk2" refers to the implementation
  provided by gWidgetsRGtk2.}
}
\details{
	Toolkits are named gWidgetsXXX. This function is used to get the toolkit class, or have the user select one. The \code{gtoolkit} function returns a string form of the toolkit. One way to set a toolkit is to use the \code{guiToolkit} option, as in \code{options(guiToolkit="RGtk2")}.
}
\value{
	The \code{guiToolkit} function returns a subclass of guiWidgetsToolkit that is
	used for dispatching purposes by gWidgets. For example, the
	method svalue dispatches on its first argument and the value
	of the toolkit class stored in the toolkit slot of the object.

	The \code{gtoolkit} function returns a character string for the toolkit.
}
\examples{
	guiToolkit("RGtk2")
}
\keyword{ interface }% at least one, from doc/KEYWORDS
